; Оптимизированный вариант
; ### - в комментариях правки для неуязвимости и бесконечной жизни

; Processor:        К1801ВМ1
; Target assembler: BKTurbo8 Cross-Assembler

; ═══════════════════════════════════════════════════════════════════════════

.include "Vars.asm"

TopStack:       jmp     @#EntryPoint

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Формирование и вывод на экран лабиринта

DrawLabyrint:   call    ClrScr
                movb    CurrPyramid, R0 ; Номер текущей пирамиды, отсчёт с 1
                asl     R0
                mov     PyrIntAddrTbl-2(R0), R0 ; берём адрес блока параметров комнаты пирамиды
                mov     (R0)+, R1       ; каждые 4 бита - номера половинок комнат лабиринта
                mov     R0, -(SP)
                mov     #Room, R2       ; адрес буфера распакованной пирамиды
                call    UnpackRoom      ; Распаковка половинки комнаты лабиринта
                                        ; Вход: R1 - параметр, из которого выделяется мл. 4 бита - это номер блока
                                        ;       R2 - адрес буфера
                call    UnpackRoomNxt   ; Сдвиг R1 на 4 вправо и продолжение
                                        ; распаковки половинки комнаты лабиринта
                                        ; Вход: R1 - параметр, из которого выделяется мл. 4 бита - это номер блока
                                        ;       R2 - адрес буфера
                call    UnpackRoomNxt   ; Сдвиг R1 на 4 вправо и продолжение
                                        ; распаковки половинки комнаты лабиринта
                                        ; Вход: R1 - параметр, из которого выделяется мл. 4 бита - это номер блока
                                        ;       R2 - адрес буфера
                call    UnpackRoomNxt   ; Сдвиг R1 на 4 вправо и продолжение
                                        ; распаковки половинки комнаты лабиринта
                                        ; Вход: R1 - параметр, из которого выделяется мл. 4 бита - это номер блока
                                        ;       R2 - адрес буфера
                mov     (SP)+, R0
                mov     (R0)+, EntryDoor ; 2-й параметр - адрес входа
                mov     (R0)+, ExitDoor ; 3-й параметр - адрес выхода
                mov     #HunterCoord, R1
                mov     (R0)+, R2       ; 4-й параметр - количество охотников

1$:             mov     (R0)+, R3       ; берём параметр
                mov     R3, R4          ; копируем
                bic     #176000, R3     ; выделяем младшие 10. битов
                add     #Room, R3       ; получим адрес в буфере комнат
                mov     #12., R5        ; выделим старшие 4 бита

2$:             asr     R4
                sob     R5, 2$
                mov     #NoCoProgrGme, R5 ; звука пока не надо
                movb    R4, HP$HuntParam(R1) ; старшие 4 бита сохраним сюда
                                        ; судя по всему, там бит 15 всегда 0, поэтому будет число 0..7
                movb    #-14, HP$HuntState(R1) ; начальное значение
                movb    112027(R4), HP$ColorMask(R1) ; по этому адресу в ПЗУ байты цвета

                comb    HP$ColorMask(R1) ; инвертируем, получаем маску цвета
                mov     R3, HP$StartCoord(R1) ; адрес сохраним сюда
                mov     R3, (R1)+       ; и сюда
                sob     R2, 1$          ; и так все параметры
                mov     R0, ThreasureParamPtr ; указатель на параметры сокровищ сохраним
                mov     (R0)+, R2       ; 5-й параметр (количество сокровищ)
                cmp     CurrPyramid, AccomplishPyramid ; вернулись назад?
                bgt     3$              ; нет
                asl     R2              ; да - всё пропускаем
                add     R2, R0
                clrb    ThreasuresNum   ; и сокровищ в пирамиде уже нету
                br      7$
; ───────────────────────────────────────────────────────────────────────────

3$:             mov     R2, ThreasuresNum ; количество сокровищ запомним

4$:             mov     (R0)+, R1       ; берём параметр (адрес)
                call    RND             ; Генерация случайного числа.
                                        ; Выход: R3 - число
                bic     #177770, R3     ; число 0..7 - это номер цветовой маски
                movb    R3, (R1)
                bisb    #200, (R1)      ; это код сокровища с цветовой маской
                clrb    -1(R1)          ; слева от сокровища сделаем пусто
                clrb    1(R1)           ; справа от сокровища тоже
                clrb    -100(R1)        ; и сверху тоже
                tstb    -77(R1)         ; справа-вверху есть что-то?
                beq     5$              ; пусто - переход
                tstb    -177(R1)        ; не пусто, а ещё выше?
                bne     5$              ; тоже что-то есть, переход
                clrb    -77(R1)         ; а иначе и справа-вверху сделаем пусто

5$:             tstb    -101(R1)        ; слева-вверху что-то есть?
                beq     6$              ; пусто - переход
                tstb    -201(R1)        ; не пусто, а ещё выше?
                bne     6$              ; тоже что-то есть, переход
                clrb    -101(R1)        ; а иначе и слева-вверху сделаем пусто

6$:             sob     R2, 4$          ; и так все сокровища

7$:             mov     (R0)+, R2       ; 6-й параметр - количество ножей

8$:             mov     (R0)+, R1       ; адрес
                movb    #TS$Knife, (R1) ; ставим нож
                sob     R2, 8$
                mov     (R0)+, R2       ; 7-й параметр - количество кирок
                beq     10$

9$:             mov     (R0)+, R1       ; адрес
                movb    #TS$Hack, (R1)  ; ставим кирку
                sob     R2, 9$

10$:            mov     (R0)+, R2       ; 8-й параметр - количество дверей с односторонней проницаемостью
                beq     13$

11$:            mov     #TS$ClosBreachLeft, R3  ; номер тайла
                mov     (R0)+, R1       ; берём адрес
                bgt     12$             ; если бит 15
                bic     #100000, R1     ; то это правосторонняя дверь
                tst     -(R3)           ; корректируем

12$:            movb    R3, (R1)+
                inc     R3
                movb    R3, (R1)
                dec     R3
                add     #77, R1
                tstb    (R1)
                beq     12$
                sob     R2, 11$

13$:            mov     (R0)+, R2       ; 9-й параметр - количество лестниц

14$:            mov     #TS$LadderUppRight, R3
                mov     #1, R4
                mov     (R0)+, R1
                bpl     16$
                neg     R4
                tst     -(R3)
                bic     #100000, R1

16$:            tstb    (R1)
                bne     17$
                movb    R3, (R1)
                inc     R3
                add     R4, R1
                movb    R3, (R1)
                dec     R3
                sub     #100, R1
                br      16$
; ───────────────────────────────────────────────────────────────────────────

17$:            movb    R3, (R1)
                sob     R2, 14$
                mov     R0, GrownWallsPtr ; сохраним указатель на структуру зарастающих стен
                mov     #100, HuntTurnHead ; флаг наличия зарастающей стены
                call    RND             ; Генерация случайного числа.
                                        ; Выход: R3 - число
                bic     #177771, R3
                mov     SpriteColorMaskTbl(R3), R2
                mov     R2, WallColorMask ; сохраним адрес цветовой маски для стен
                call    RND             ; Генерация случайного числа.
                                        ; Выход: R3 - число
                inc     RndBuff
                bic     #177771, R3
                cmp     SpriteColorMaskTbl(R3), R2 ; если совпадает с предыдущей
                bne     18$
                sub     #2, R3          ; подкорректируем
                bge     18$
                add     #10, R3

18$:            mov     SpriteColorMaskTbl(R3), LadderColorMask ; сохраним адрес цветовой маски для лестниц
                call    RND             ; Генерация случайного числа.
                                        ; Выход: R3 - число
                bic     #177771, R3
                bne     19$
                mov     #6, R3

19$:            mov     112026(R3), CharColorMask ; маска цвета
                clr     RoomOffset      ; смещение, в какой мы половинке комнаты
                clr     R4              ; индекс двери
                tstb    MoveToBack      ; движемся в обратном направлении?
                beq     20$             ; нет
                tst     (R4)+           ; да - значит скорректируем индекс

20$:            mov     DoorAddress(R4), R0 ; адрес двери в буфере
                mov     R0, GGCoord     ; там появится человечек
                sub     #176, GGCoord
                bic     #177700, R0     ; проверим в какой половине?
                cmp     #40, R0
                bgt     21$             ; в первой
                add     #40, RoomOffset ; во второй

21$:            clr     R2
                call    DrawRoom        ; вывод на экран сформированной половинки комнаты
                                        ; Вход: R2 - адрес смещения в буфере
                clr     R2
                call    DrawRoomNxt     ; вывод на экран следующей сформированной половинки комнаты
                                        ; Вход: R2 - адрес смещения в буфере
; под конец рисуем пол
                mov     #75400, R0
                mov     #40, R1

22$:            mov     #4, R2
                mov     WallColorMask, R3

23$:            mov     #TS$Floor, (R0)
                tst     R3
                beq     24$
                bic     (R3)+, (R0)

24$:            add     #100, R0
                sob     R2, 23$
                sub     #376, R0
                sob     R1, 22$
                return
; End of function DrawLabyrint


; ███████████████ S U B R O U T I N E ███████████████████████████████████████


ClrScr:         mov     #40000, R0
                mov     #20000, R1

1$:             clr     (R0)+
                sob     R1, 1$
                return
; End of function ClrScr


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Сдвиг R1 на 4 вправо и продолжение
; распаковки половинки комнаты лабиринта
; Вход: R1 - параметр, из которого выделяется мл. 4 бита - это номер блока
;       R2 - адрес буфера

UnpackRoomNxt:  ror     R1
                ror     R1
                ror     R1
                ror     R1
; End of function UnpackRoomNxt


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Распаковка половинки комнаты лабиринта
; Вход: R1 - параметр, из которого выделяется мл. 4 бита - это номер блока
;       R2 - адрес буфера

UnpackRoom:     mov     R1, R0
                bic     #177760, R0     ; младшие 4 бита
                beq     5$              ; если 0, то ничего не делаем, комнаты нет
                mov     #44., R4
                mov     #PyramidConf-44., R3 ; начало массива

1$:             add     R4, R3          ; подводим указатель к нужному блоку (blk * 54)
                sob     R0, 1$
                mov     #22., R4        ; распаковываем массив

2$:             mov     (R3)+, R0       ; берём слово
                mov     #16., R5

3$:             clrb    (R2)            ; каждый бит слова -> байт в буфере
                rol     R0
                adcb    (R2)+

                sob     R5, 3$
                add     #60, R2         ; выравниваем по ТВ строкам
                sob     R4, 2$
                sub     #2560, R2       ; возвращаем указатель в буфере на начало + 20

5$:             return
; End of function UnpackRoom


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; R0 *= 20.

Mul20.:         asl     R0

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; R0 *= 10.

Mul10.:         call    (R5)
                asl     R0
                mov     R0, -(SP)
                asl     R0
                asl     R0
                add     (SP)+, R0
                jmp     (R5)
; End of function Mul10.
; End of function Mul20.


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; вывод на экран следующей сформированной половинки комнаты
; Вход: R2 - адрес смещения в буфере

DrawRoomNxt:    add     #20, R2


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; вывод на экран сформированной половинки комнаты
; Вход: R2 - адрес смещения в буфере

DrawRoom:       add     RoomOffset, R2  ; смещение, показывающее, в какой мы сейчас половинке комнаты: 0, 40
                add     #Room, R2       ; начало буфера
                mov     R2, R1
                call    CalcScrAddr     ; вычисление адреса экрана по адресу байта в буфере комнаты
                                        ; вход: R2 - адрес в буфере комнаты
                                        ; выход: R2 - адрес экрана
                mov     #22., R0        ; высота

1$:             mov     #16., R3        ; ширина

2$:             call    (R5)
                call    DrawTileRoom    ; вывод на экран элемента комнаты
                                        ; Вход: R1 - адрес элемента в буфере комнаты
                                        ;       R2 - адрес экрана
                inc     R1
                tst     (R2)+
                sob     R3, 2$
                add     #60, R1
                add     #1140, R2
                sob     R0, 1$
                jmp     (R5)
; End of function DrawRoom
; End of function DrawRoomNxt


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; вычисление адреса экрана по адресу байта в буфере комнаты
; вход: R2 - адрес в буфере комнаты
; выход: R2 - адрес экрана

CalcScrAddr:    call    (R5)
                mov     R0, -(SP)
                sub     #Room, R2       ; сперва получим смещение в буфере
                mov     R2, R0
                bic     #77, R0         ; смещение до строки
                bic     R0, R2          ; номер байта
                call    Mul10.          ; R0 *= 10.
                sub     RoomOffset, R2  ; скорректируем смещение до нужной половины
                asl     R2              ; * 2
                add     R0, R2
                add     #TopScreen, R2  ; получим адрес экрана
                mov     (SP)+, R0
                jmp     (R5)
; End of function CalcScrAddr


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; вывод на экран элемента комнаты
; Вход: R1 - адрес элемента в буфере комнаты

DrawTileRoomAdr:mov     R1, R2
                call    CalcScrAddr     ; вычисление адреса экрана по адресу байта в буфере комнаты
                                        ; вход: R2 - адрес в буфере комнаты
                                        ; выход: R2 - адрес экрана

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; вывод на экран элемента комнаты
; Вход: R1 - адрес элемента в буфере комнаты
;       R2 - адрес экрана

DrawTileRoom:   mov     R0, -(SP)
                mov     R1, -(SP)
                mov     R2, -(SP)
                mov     R3, -(SP)
                call    (R5)
                movb    (R1), R0        ; получим код элемента
                bgt     2$              ; >0 - обработаем
                bne     1$              ; <0 - обработаем сокровище
                                        ; ==0 - стираем
                call    ClearTile       ; Стереть объект с экрана
                                        ; Вход: R2 - адрес экрана
                br      6$
; ───────────────────────────────────────────────────────────────────────────
; прорисовка сокровища
1$:             bic     #177600, R0     ; очищаем не нужное
                asl     R0
                mov     SpriteColorMaskTbl(R0), R1 ; получим адрес цветовой маски
                mov     #TS$Threasure, R0 ; это сокровище
                br      5$
; ───────────────────────────────────────────────────────────────────────────
; прорисовка всего остального
2$:             cmp     #TS$Wall, R0    ; Это стена?
                bne     3$              ; нет
                mov     WallColorMask, R1 ; да - то вот её маска цвета
                br      5$
; ───────────────────────────────────────────────────────────────────────────
; проверка на элементы лестницы
3$:             call    (R5)
                cmp     #TS$LadderDnpRight, R0 ; проверим на лестницу
                blt     4$
                cmp     #TS$LadderUppLeft, R0
                bgt     4$
                mov     LadderColorMask, R1 ; Это маска цвета для лестниц
                br      5$
; ───────────────────────────────────────────────────────────────────────────

4$:             clr     R1              ; для остального маска цвета не применяется
5$:             call    DrawTile        ; Вывести объект на экран
                                        ; Вход: R0 - номер тайла в массиве
                                        ;       R1 - адрес шаблона маски цвета
                                        ;       R2 - адрес экрана
6$:             mov     (SP)+, R3
                mov     (SP)+, R2
                mov     (SP)+, R1
                mov     (SP)+, R0
                jmp     (R5)
; End of function DrawTileRoom


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Вывести объект на экран без цветовой маски
; Вход: R0 - номер тайла в массиве
;       R2 - адрес экрана
DrawTile0:      clr     R1              ; цветовой маски нет

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Вывести объект на экран
; Вход: R0 - номер тайла в массиве
;       R1 - адрес шаблона маски цвета
;       R2 - адрес экрана
DrawTile:       call    Mul20.          ; R0 *= 20.
                add     #SpriteArray-20., R0

                mov     #100, R3
                tst     R1
                beq     2$

                mov     (R0)+, (R2)
                bic     (R1)+, (R2)
                add     R3, R2
                mov     (R0)+, (R2)
                bic     (R1)+, (R2)
                add     R3, R2
                mov     (R0)+, (R2)
                bic     (R1)+, (R2)
                add     R3, R2
                mov     (R0)+, (R2)
                bic     (R1)+, (R2)
                add     R3, R2
                mov     (R0)+, (R2)
                bic     (R1)+, (R2)
                add     R3, R2
                mov     (R0)+, (R2)
                bic     (R1)+, (R2)
                add     R3, R2
                mov     (R0)+, (R2)
                bic     (R1)+, (R2)
                add     R3, R2
                mov     (R0)+, (R2)
                bic     (R1)+, (R2)
                add     R3, R2
                mov     (R0)+, (R2)
                bic     (R1)+, (R2)
                add     R3, R2
                mov     (R0)+, (R2)
                bic     (R1)+, (R2)
                add     R3, R2
                jmp     (R5)

2$:             mov     (R0)+, (R2)
                add     R3, R2
                mov     (R0)+, (R2)
                add     R3, R2
                mov     (R0)+, (R2)
                add     R3, R2
                mov     (R0)+, (R2)
                add     R3, R2
                mov     (R0)+, (R2)
                add     R3, R2
                mov     (R0)+, (R2)
                add     R3, R2
                mov     (R0)+, (R2)
                add     R3, R2
                mov     (R0)+, (R2)
                add     R3, R2
                mov     (R0)+, (R2)
                add     R3, R2
                mov     (R0)+, (R2)
                add     R3, R2
                jmp     (R5)

; End of function DrawTile


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Анимация мигания сокровищ
; Вход: R0 - номер тайла в массиве
;       R1 - адрес шаблона маски цвета
;       R2 - адрес экрана

AnimBlinkHalo:  tstb    TrHBlinkingFlg  ; флаг мигания ореола сокровища
                beq     ClearTile
                br      DrawTile        ; Вывести объект на экран
                                        ; Вход: R0 - номер тайла в массиве
                                        ;       R1 - адрес шаблона маски цвета
                                        ;       R2 - адрес экрана
; ───────────────────────────────────────────────────────────────────────────

; убрать подобранный предмет с экрана и карты
; Вход: R2 - координаты ГГ
; портит R2
ClearLUT:       clrb    (R2)
                call    CalcScrAddr     ; вычисление адреса экрана по адресу байта в буфере комнаты
                                        ; вход: R2 - адрес в буфере комнаты
                                        ; выход: R2 - адрес экрана
;1$:             jmp     ClearTile       ; Стереть объект с экрана
                                        ; Вход: R2 - адрес экрана
; End of function AnimBlinkHalo


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Стереть объект с экрана
; Вход: R2 - адрес экрана

ClearTile:      mov     #100, R0

                clr     (R2)
                add     R0, R2
                clr     (R2)
                add     R0, R2
                clr     (R2)
                add     R0, R2
                clr     (R2)
                add     R0, R2
                clr     (R2)
                add     R0, R2
                clr     (R2)
                add     R0, R2
                clr     (R2)
                add     R0, R2
                clr     (R2)
                add     R0, R2
                clr     (R2)
                add     R0, R2
                clr     (R2)
                add     R0, R2

                jmp     (R5)

; End of function ClearTile


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Генерация случайного числа.
; Выход: R3 - число

RND:            mov     R1, -(SP)
                mov     R2, -(SP)
                mov     #14, R2
                mov     RndBuff, R1
1$:             mov     R1, R3
                rol     R3
                bmi     2$
                com     R3

2$:             rol     R3
                rol     R3
                rol     R1
                call    (R5)
                sob     R2, 1$
                add     GGCoord, R1
                add     @#177710, R1
                mov     R1, R3
                mov     R1, RndBuff
                mov     (SP)+, R2
                mov     (SP)+, R1
                jmp     (R5)
; End of function RND


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; вычисление координат и параметров прорисовки спрайта ГГ/охотника
; с учётом анимаций
; Вход: R3 - индекс: 0 - ГГ; 2,4,6 - охотник1,2,3

CalcSpriteDrawing:
                clr     R0              ; номер тайла
                tst     R3              ; кого обрабатываем?
                beq     3$              ; 0 - человечек
                                        ; !0 - охотники
                movb    HuntState(R3), R1 ; состояние охотника
                beq     3$              ; 0 - активно бегает
                bgt     0RemoveHunt$    ; >0 - нет на экране
                cmp     #-1, R1
                beq     1$
                call    (R5)
                cmp     #-40, R1
                bne     2$
; это анимации появления/исчезновения охотника (пузыри)

1$:             mov     #TD$BubbleBurst, R0 ; если -1 или -40 - тайл #46 (пузырь лопнул)
                br      0Draw$
; ───────────────────────────────────────────────────────────────────────────

2$:             cmp     #-5, R1
                bgt     0RemoveHunt$    ; если < -5, то нет на экране
                mov     #TD$BubbleMax, R0 ; иначе, тайл #45 или #44, в зависимости от чётности
                                        ; #44 - маленький пузырь
                                        ; #45 - большой пузырь
                asr     R1
                sbc     R0
                br      0Draw$
; ───────────────────────────────────────────────────────────────────────────
; здесь R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3

3$:             call    (R5)
                movb    AnimType(R3), R1 ; номер анимации действий ГГ/охотника
                movb    AnimStage(R3), R2 ; номер этапа в анимации движения
                bic     #177774, R2
                bic     #177770, R1
                asl     R1
                call    (R5)
                add     R1, PC
                br      0Moving$        ; 0 движение
                br      0Jumping$       ; 1 прыжок
                br      0Jumping$       ; 2 прыжок
                br      0Stoping$       ; 3 остановка
                br      0Stoping$       ; 4 остановка
                br      0HitHackSide$   ; 5 удар киркой в бок
                br      0HitHackDown$   ; 6 удар киркой вниз
                movb    #TD$GGKSwingRight, R0 ; 7 бросок ножа (R0 = 28.)
                cmp     #2, R2          ; какой номер этапа?
                beq     0ChkLeftRight$  ; такой
                tst     -(R0)           ; нет - начальная фаза анимации
                br      0ChkLeftRight$
; ───────────────────────────────────────────────────────────────────────────

0Moving$:       call    (R5)
                tst     OffsetX(R3)     ; движение по горизонтали есть?
                beq     0Stoping$       ; нет
                mov     R2, R0          ; есть, тогда это будет номер тайла
                movb    OffsetY(R3), R1 ; движение по вертикали есть?
                beq     4$              ; нету
                bic     #2, R0          ; есть, тогда номер тайла такой
                tstb    R1              ; а куда движемся?
                bgt     4$              ; вниз
                tst     R0              ; вверх, а номер тайла ==0?
                beq     0Stoping$       ; да
                tst     (R0)+           ; нет № тайла + 2

4$:             asl     R0              ; номер тайла * 2
                br      0Stoping$
; ───────────────────────────────────────────────────────────────────────────

0Jumping$:      tst     R3              ; кого обрабатываем?
                bne     5$              ; охотников
                tstb    GGHaveEquip     ; ГГ, а у него в руках что-нибудь есть?
                bne     0Moving$        ; да, тогда проверка на движение

5$:             bit     #1, R2          ; номер этапа нечётный?
                bne     0ChkLeftRight$  ; да
                cmp     (R0)+, (R0)+    ; № тайла + 4

0Stoping$:      tst     (R0)+           ; № тайла + 2
                br      0ChkLeftRight$
; ───────────────────────────────────────────────────────────────────────────
; анимация удара киркой вбок
0HitHackSide$:  mov     #TD$GGHStartHitRight, R0 ; начало анимации удара киркой
                bit     #1, R2          ; вторая часть анимации?
                bne     0ChkLeftRight$  ; нет
                tst     (R0)+           ; да - следующий тайл
                br      0Stoping$
; ───────────────────────────────────────────────────────────────────────────
; анимация удара киркой вниз
0HitHackDown$:  mov     #TD$GGFrontBegin, R0 ; начало анимации удара киркой вниз
                bit     #1, R2          ; вторая часть анимации?
                bne     0ChkGGEquip$    ; нет
                br      0NextAnim3$     ; да - следующий тайл
; ───────────────────────────────────────────────────────────────────────────
; удаление охотника с экрана
0RemoveHunt$:   call    (R5)
                clr     ScrAddrOut(R3)  ; охотник исчезает с экрана
                return
; ───────────────────────────────────────────────────────────────────────────
; проверка на движение влево/вправо
0ChkLeftRight$: tstb    DirMove(R3)     ; в каком направлении двигаемся?
                beq     0ChkGGEquip$    ; 0 - вправо
                                        ; !0 - влево, корректируем номер тайла
0NextAnim3$:    inc     R0              ; да - следующий (нечётный) тайл
0ChkGGEquip$:   call    (R5)
                tst     R3              ; кого обрабатываем?
                bne     0Draw$          ; охотников - переход
                cmp     #TD$GGStartLeft, R0 ; человечка, а номер тайла какой?
                blt     0Draw$          ; больше 11 - переход
                                        ; меньше - это ходьба
                tstb    GGHaveEquip     ; что в руках?
                beq     0Draw$          ; пусто
                bge     6$              ; > 0 - кирка
                add     #8., R0         ; < 0 - нож
6$:             add     #8., R0         ; корректируем номер тайла

0Draw$:         call    (R5)
                mov     R0, -(SP)
                asl     R0              ; номер спрайта *2
                mov     TileIndex(R0), R1 ; берём параметры
                mov     #TileArray, R0  ; начало массива спрайтов
                tst     R3              ; нет, а обрабатываем человечка?
                beq     7$              ; да
                cmp     (SP), #TD$GGStartLeft ; номер тайла больше 11?
                bgt     7$              ; да
                mov     #HuntTileArray, R0 ; нет, то корректируем массив спрайтов, будем рисовать охотника

7$:             call    (R5)
                mov     R1, R2
                bic     #174000, R1     ; берём мл.11 бит - это смещение в массиве спрайтов
                add     R1, R0          ; получаем адрес спрайта
                mov     R0, SpriteAdr(R3) ; сохраним
                swab    R2
                ror     R2
                ror     R2
                ror     R2
                mov     R2, R1
                call    (R5)
                bic     #177770, R2     ; берём биты 13-11
                movb    R2, SprWidthOut(R3) ; это ширина спрайта в байтах
                ror     R1
                ror     R1
                ror     R1
                bic     #177774, R1     ; берём биты 15..14
                sub     #2, R1          ; делаем знаковые значения -2,-1,0,1
                mov     (SP)+, R0       ; восстановим номер тайла
                movb    AnimStage(R3), R2 ; это этап в анимации
                call    (R5)
                bic     #177774, R2
                cmp     #2, R2
                ble     8$
                sub     #TD$GGStepRight, R0
                beq     10$
                dec     R0
                beq     9$
                br      11$
; ───────────────────────────────────────────────────────────────────────────

8$:             cmp     #TD$GGKStartSwingRight, R0 ; !!!тут должно быть сравнение с 32, было - с 33
                ble     11$
                mov     R0, R2
                bic     #31, R0         ; получим номер тайла, не зависимо от того, что в руках, и направления
                call    (R5)
                cmp     #TD$GGStepRight, R0 ; если шаг
                beq     11$             ; то переход
                cmpb    AnimType(R3), #3 ; иначе, проверим анимацию - прыжок на месте?
                beq     11$             ; да
                bit     #1, R2          ; нет, куда было направление?
                bne     10$             ; нечётный - влево

9$:             dec     R1
                br      11$
; ───────────────────────────────────────────────────────────────────────────

10$:            inc     R1

11$:            call    (R5)
                mov     Coordinate(R3), R0 ; текущие координаты
                bic     #177700, R0     ; смещение в строке по горизонтали
                sub     RoomOffset, R0  ; вычтем смещение комнаты
                asl     R0
                add     R1, R0
                call    (R5)
                cmp     #77, R0
                blt     0RemoveHunt$
                cmp     #-4, R0
                bge     0RemoveHunt$
                call    (R5)
                tst     R0
                bge     13$
                movb    SprWidthOut(R3), R2 ; ширина спрайта ГГ/охотника
                add     R2, R0

12$:            ble     0RemoveHunt$
                movb    R0, SprWidthOut(R3) ; корректируем ширину с учётом выхода за экран
                sub     R0, R2
                add     R2, R1
                mov     R2, R0
                asl     R0
                call    (R5)
                asl     R0
                asl     R0
                add     R2, R0
                asl     R0
                add     R0, SpriteAdr(R3)   ; и так же адрес спрайта
                br      14$
; ───────────────────────────────────────────────────────────────────────────

13$:            sub     #100, R0
                neg     R0
                ble     12$
                cmpb    SprWidthOut(R3), R0
                ble     14$
                movb    R0, SprWidthOut(R3)

14$:            mov     Coordinate(R3), R2
                call    CalcScrAddr     ; вычисление адреса экрана по адресу байта в буфере комнаты
                                        ; вход: R2 - адрес в буфере комнаты
                                        ; выход: R2 - адрес экрана
                add     #200, R2
                add     R2, R1
                call    (R5)
                mov     R1, ScrAddrOut(R3)
                mov     #word_22572, R0 ; смещения к массивам
                movb    AnimType(R3), R1 ; берём номер анимации
                bic     #177770, R1     ; убираем лишнее
                beq     15$
                cmp     #7, R1
                bne     17$
; анимации 0 и 7
15$:            call    (R5)
                tstb    OffsetY(R3)     ; движение по вертикали есть?
                beq     18$             ; нету
                blt     16$             ; вверх: +2
                tst     (R0)+           ; вниз: +4

16$:            tst     (R0)+
                br      18$
; ───────────────────────────────────────────────────────────────────────────
                call    (R5)
; анимации 1..6
17$:            cmp     #5, R1          ; если 5 и 6
                ble     19$             ; просто выход
                asl     R1              ; остались 1..4
                add     R1, R0
                cmp     (R0)+, (R0)+

18$:            call    (R5)
                sub     (R0), R0
                movb    AnimStage(R3), R1
                asl     R1
                beq     19$
                add     R1, R0
                add     -(R0), ScrAddrOut(R3)

19$:            jmp     (R5)
; End of function CalcSpriteDrawing


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; сохранение экрана под ГГ/охотником
; Вход: R3 - индекс: 0 - ГГ; 2,4,6 - охотник1,2,3

StoreScrNPC:    mov     #111120, R0
                mov     #11120, R2
                br      0XchgScrNpc$
; End of function StoreScrNPC


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; восстановление экрана под ГГ/охотником
; Вход: R3 - индекс: 0 - ГГ; 2,4,6 - охотник1,2,3

RestoreScrNPC:  mov     #112011, R0
                mov     #12011, R2

0XchgScrNpc$:   mov     ScrAddrSav(R3), R1 ; берём адрес экрана
                beq     0EndXchg$       ; 0 - ничего не делаем
                mov     R0, morphb$
                mov     R0, morphb1$
                mov     R2, morphw$
                mov     R2, morphw1$
                call    (R5)
                mov     R3, R0          ; x
                asl     R0
                asl     R0
                asl     R0              ; x*8
                add     R3, R0          ; x*9
                asl     R0
                asl     R0              ; x*36.
                add     #ScrBuffer, R0  ; адрес буфера
                call    (R5)
                movb    SprWidthSav(R3), R2 ; ширина в байтах
                cmp     #207, (R5)      ; музыка выключена?
                beq     1$              ; да
                add     #BgrMusOffs1-BgrMusPlay, R5

1$:             bit     #1, R1          ; адрес чётный?
                beq     w_loop$         ; да

b_loop$:        mov     #9., R3         ; нет, сохраняем столбец побайтно

morphb$:        movb    (R0)+, (R1)+
                add     #100, R1
morphb1$:       movb    (R0)+, (R1)+
                add     #100, R1
                tstb    @#177710
                bpl     2$
                call    (R5)

2$:             sob     R3, morphb$
                sub     #2177, R1
                br      4$
; ───────────────────────────────────────────────────────────────────────────

w_loop$:        cmp     #1, R2          ; остался один байт?
                bge     b_loop$         ; да
                mov     #9., R3         ; нет - сохраняем пословно

morphw$:        mov     (R0)+, (R1)+
                add     #100, R1
morphw1$:       mov     (R0)+, (R1)+
                add     #100, R1
                tstb    @#177710
                bpl     3$
                call    (R5)

3$:             sob     R3, morphw$
                sub     #2176, R1
                dec     R2

4$:             sob     R2, w_loop$     ; и так, пока ширина не кончится
                cmp     #207, (R5)      ; музыка выключена?
                beq     0EndXchg$       ; да
                sub     #BgrMusOffs1-BgrMusPlay, R5

0EndXchg$:      jmp     (R5)
; End of function RestoreScrNPC


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; прорисовка ГГ/охотника
; Вход: R3 - индекс: 0 - ГГ; 2,4,6 - охотник1,2,3

DrawNPC:        mov     R4, -(SP)
                mov     R3, -(SP)
                mov     SpriteAdr(R3), R0 ; адрес в массиве спрайтов
                mov     ScrAddrOut(R3), R1 ; адрес экрана
                beq     0NothindDraw$   ; 0 - ничего не делать
                movb    SprWidthOut(R3), -(SP) ; ширина спрайта в байтах
                call    (R5)
                cmp     #207, (R5)      ; звук отключён?
                beq     1$              ; да
                add     #BgrMusOffs1-BgrMusPlay, R5 ; нет

1$:             tst     R3              ; это ГГ?
                beq     0Draw$          ; да
                movb    ColorMaskHun(R3), R2 ; нет, а цветовая маска есть?
                beq     0Draw$          ; нет
; вывод с применением цветовой маски
2$:             mov     #18., R4     ; высота спрайта

3$:             movb    (R0)+, R3
                ror     R3
                bicb    R3, (R1)
                rol     R3
                bicb    R2, R3
                bisb    R3, (R1)
                add     #100, R1
                tstb    @#177710
                bpl     4$
                call    (R5)

4$:             sob     R4, 3$
                sub     #2177, R1
                decb    (SP)
                bne     2$
                br      7$
; ───────────────────────────────────────────────────────────────────────────
; вывод без цветовой маски
0Draw$:         mov     #18., R2        ; высота спрайта

5$:             movb    (R0), R3        ; выводим столбец спрайта
                ror     R3
                bicb    R3, (R1)
                bisb    (R0)+, (R1)
                add     #100, R1
                tstb    @#177710
                bpl     6$
                call    (R5)

6$:             sob     R2, 5$
                sub     #2177, R1       ; передвигаемся к следующему
                decb    (SP)
                bne     0Draw$
                ;clr     R2 там и так 0

7$:             tst     (SP)+
                cmp     #207, (R5)      ; звук отключён?
                beq     8$              ; да
                sub     #BgrMusOffs1-BgrMusPlay, R5 ; нет

8$:             mov     (SP), R3
                beq     0EndDraw$       ; если ГГ, то выход
                                        ; остальное - только для охотников
                                        ; Это как бы верчение головой. Но в динамике нифига не видно.
                tstb    HuntTurnHead(R3) ; время пришло?
                beq     0EndDraw$       ; нет
                mov     SpriteAdr(R3), R0 ; адрес спрайта охотника в массиве
                add     #TileSpriteH04-TileSpriteH00 + 3, R0 ; смещение ко второй половине блока спрайтов из первой, +3 строки
                call    (R5)
                decb    HuntTHCnt(R3)
                beq     10$
                cmpb    HuntTHCnt(R3), #2
                bgt     10$
                tstb    DirMove(R3)     ; направление движения?
                bne     9$              ; влево
                add     #44, R0         ; вправо
                br      10$
; ───────────────────────────────────────────────────────────────────────────

9$:             sub     #44, R0         ; влево

10$:            mov     ScrAddrOut(R3), R1 ; адрес экрана
; очищаем ненужное
                add     #300, R1
                mov     #37774, R3
                bic     R3, (R1)
                bic     R3, 200(R1)
                bic     R3, 300(R1)
                call    (R5)
; рисуем новую голову
                mov     #2, -(SP)

11$:            mov     #4, R4

12$:            movb    (R0)+, R3
                ror     R3
                bicb    R3, (R1)
                rol     R3
                bicb    R2, R3          ; применяем цветовую маску, если есть
                bisb    R3, (R1)
                add     #100, R1
                sob     R4, 12$

                sub     #377, R1
                add     #16, R0
                dec     (SP)
                bne     11$
                tst     (SP)+

0NothindDraw$:
0EndDraw$:      mov     (SP)+, R3
                mov     (SP)+, R4
                jmp     (R5)
; End of function DrawNPC


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Анимация открывающегося прохода в стене

AnimDoorOpen:   mov     DoorAddress(R4), R2
; Раздвигается стена влево и прорисовка прохода
                sub     #201, R2
                call    CalcScrAddr     ; вычисление адреса экрана по адресу байта в буфере комнаты
                                        ; вход: R2 - адрес в буфере комнаты
                                        ; выход: R2 - адрес экрана
                call    DrawGreenWallCol ; рисуем столбец из зелёной стены
                add     #1202, R2
                call    DrawEntry       ; рисуем проход в стене.
                                        ; Вход: R2 - адрес экрана
                mov     DoorAddress(R4), R2
                ;jmp     DrawGreenWallAround ; рисуем стену над проходом и справа от него
; End of function AnimDoorOpen


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; рисуем стену над проходом и справа от него

DrawGreenWallAround:
                sub     #200, R2
                call    CalcScrAddr     ; вычисление адреса экрана по адресу байта в буфере комнаты
                                        ; вход: R2 - адрес в буфере комнаты
                                        ; выход: R2 - адрес экрана
                mov     #2, R3

1$:             mov     #TS$GreenWall, R0
                mov     R3, -(SP)
                call    DrawTile0       ; Вывести объект на экран без цветовой маски
                                        ; Вход: R0 - номер тайла в массиве
                                        ;       R2 - адрес экрана
                mov     (SP)+, R3
                sub     #1176, R2
                sob     R3, 1$
                jmp     DrawGreenWallCol ; рисуем столбец из зелёной стены
; End of function DrawGreenWallAround


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Анимация спуска человечка из прохода в пирамиду

AnimGGGoIn:     mov     #2, R0

1$:             movb    OffsetX, R1
                movb    OffsetY, R2
                add     R1, R2
                add     R2, GGCoord
                mov     #4, R1
                movb    R1, AnimStage   ; номер этапа в анимации

                mov     R0, -(SP)
2$:             decb    AnimStage       ; номер этапа в анимации
                clr     R3              ; индекс человечка
                mov     R1, -(SP)
                call    CalcSpriteDrawing ; вычисление координат и параметров прорисовки спрайта ГГ/охотника
                                        ; с учётом анимаций
                                        ; Вход: R3 - индекс: 0 - ГГ; 2,4,6 - охотник1,2,3
                movb    SprWidthOut, SprWidthSav ; ширину продублируем
                mov     ScrAddrOut, ScrAddrSav ; адрес продублируем
                call    StoreScrNPC     ; сохранение экрана под ГГ/охотником
                                        ; Вход: R3 - индекс: 0 - ГГ; 2,4,6 - охотник1,2,3
                clr     R3              ; индекс человечка
                call    DrawNPC         ; прорисовка ГГ/охотника
                                        ; Вход: R3 - индекс: 0 - ГГ; 2,4,6 - охотник1,2,3
                mov     DoorAddress(R4), R2
                call    DrawGreenWallAround ; рисуем стену над проходом и справа от него
                mov     #40000, R0
                sob     R0, .
                clr     R3              ; индекс человечка
                call    RestoreScrNPC   ; восстановление экрана под ГГ/охотником
                                        ; Вход: R3 - индекс: 0 - ГГ; 2,4,6 - охотник1,2,3
                call    BlinkTreasureHalo ; функция мигания ореола сокровищ
                mov     (SP)+, R1
                sob     R1, 2$
                mov     (SP)+, R0
                sob     R0, 1$
                return
; End of function AnimGGGoIn


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; рисуем зелёную стену, где открывается дверь входа
; Вход: R2 - адрес в буфере лабиринта

DrawGrWall:     sub     #200, R2
                call    CalcScrAddr     ; вычисление адреса экрана по адресу байта в буфере комнаты
                                        ; вход: R2 - адрес в буфере комнаты
                                        ; выход: R2 - адрес экрана
; End of function DrawGrWall

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; рисуем зелёную стену, где открывается дверь входа
; Вход: R2 - адрес экрана, где рисовать

DrawGrWallSc:   call    DrawGreenWallCol ; рисуем столбец из зелёной стены
                tst     (R2)+
                ;jmp     DrawGreenWallCol ; рисуем столбец из зелёной стены
; End of function DrawGrWallSc


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; рисуем столбец из зелёной стены

DrawGreenWallCol:
                mov     R2, -(SP)
                call    (R5)
                mov     R1, -(SP)
                mov     R4, -(SP)
                mov     #4, R4

1$:             mov     #TS$GreenWall, R0
                call    DrawTile0       ; Вывести объект на экран без цветовой маски
                                        ; Вход: R0 - номер тайла в массиве
                                        ;       R2 - адрес экрана
                sob     R4, 1$
                mov     (SP)+, R4
                mov     (SP)+, R1
                mov     (SP)+, R2
                jmp     (R5)
; End of function DrawGreenWallCol


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Анимация закрытия прохода

AnimDoorClose:  sub     #201, R2
                mov     R2, R1
                call    CalcScrAddr     ; вычисление адреса экрана по адресу байта в буфере комнаты
                                        ; вход: R2 - адрес в буфере комнаты
                                        ; выход: R2 - адрес экрана
                call    RestoreLabyr    ; Восстанавливаем содержимое лабиринта из-под прохода
                tst     (R2)+
                call    DrawGrWallSc    ; рисуем зелёную стену, где открывается дверь входа
                                        ; Вход: R2 - адрес экрана, где рисовать
                tst     (R1)+
                br      0EndAnim$
; End of function AnimDoorClose


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Анимация исчезновения зелёной стены
; (человечек тоже стирается)

AnimGrWallOff:  sub     #200, R2
                mov     R2, R1
                call    CalcScrAddr     ; вычисление адреса экрана по адресу байта в буфере комнаты
                                        ; вход: R2 - адрес в буфере комнаты
                                        ; выход: R2 - адрес экрана
                call    RestoreLabyr    ; Восстанавливаем содержимое лабиринта из-под прохода

0EndAnim$:      tst     (R2)+
                inc     R1
                jmp     RestoreLabyr    ; Восстанавливаем содержимое лабиринта из-под прохода
; End of function AnimGrWallOff


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; рисуем проход в стене.
; Вход: R2 - адрес экрана

DrawEntry:      mov     #12, R3         ; рисуем стену внутри прохода

EntryInterrior1:
1$:             mov     #73567, (R2)
                mov     (R2)+, (R2)
                mov     (R2), 1176(R2)
                add     #76, R2
                call    (R5)
                sob     R3, 1$
                mov     #InpLadder, R1  ; рисуем ступеньки
                tst     (R2)+
                mov     #12, R3

2$:             mov     (R1), (R2)
                mov     (R1)+, 1176(R2)
                add     #100, R2
                call    (R5)
                sob     R3, 2$
                mov     #5, R3

3$:             mov     (R1), (R2)
                mov     (R1)+, 500(R2)
                add     #100, R2
                call    (R5)
                sob     R3, 3$
                return
; End of function DrawEntry

; ───────────────────────────────────────────────────────────────────────────
; элементы лестницы внутри прохода
InpLadder:      .word ^B1010011101110111
                .word ^B1010101001110111
                .word ^B1111111101110111
                .word ^B1111111101110111
                .word ^B1111111101110111
                .word ^B1010101010100111
                .word ^B1010101010101010
                .word ^B1111111111111111
                .word ^B1111111111111111
                .word ^B1111111111111111
                .word ^B1010101010101010
                .word ^B1010101010101010
                .word ^B1111111111111111
                .word ^B1111111111111111
                .word ^B1111111111111111

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Восстанавливаем содержимое лабиринта из-под прохода

RestoreLabyr:   mov     R2, -(SP)
                mov     R1, -(SP)
                mov     #4, R3

1$:             call    DrawTileRoom    ; вывод на экран элемента комнаты
                                        ; Вход: R1 - адрес элемента в буфере комнаты
                                        ;       R2 - адрес экрана
                add     #1200, R2
                add     #100, R1
                sob     R3, 1$
                mov     (SP)+, R1
                mov     (SP)+, R2
                return
; End of function RestoreLabyr


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; функция мигания ореола сокровищ

BlinkTreasureHalo:
                mov     ThreasureParamPtr, R0 ; указатель на структуру количества и адресов сокровищ
                mov     (R0)+, R3       ; берём кол-во сокровищ
                clr     R1

1$:             mov     (R0), R2        ; адрес сокровища
                call    (R5)
                tstb    (R2)            ; оно подобрано?
                bge     2$              ; да - пропускаем
                bic     #177700, R2
                sub     RoomOffset, R2  ; оно вне экрана?
                ble     2$              ; пропускаем
                cmp     #37, R2
                ble     2$
                mov     (R0), R2
                sub     #100, R2
                call    CalcScrAddr     ; вычисление адреса экрана по адресу байта в буфере комнаты
                                        ; вход: R2 - адрес в буфере комнаты
                                        ; выход: R2 - адрес экрана
                mov     R0, -(SP)
                mov     R3, -(SP)
                mov     #TS$ThrShineUp, R0
                call    (R5)
                call    AnimBlinkHalo   ; Анимация мигания сокровищ
                                        ; Вход: R0 - номер тайла в массиве
                                        ;       R1 - адрес шаблона маски цвета
                                        ;       R2 - адрес экрана
                mov     #TS$ThrShineLeft, R0
                tst     -(R2)
                call    AnimBlinkHalo   ; Анимация мигания сокровищ
                                        ; Вход: R0 - номер тайла в массиве
                                        ;       R1 - адрес шаблона маски цвета
                                        ;       R2 - адрес экрана
                mov     #TS$ThrShineRight, R0
                call    (R5)
                sub     #1174, R2
                call    AnimBlinkHalo   ; Анимация мигания сокровищ
                                        ; Вход: R0 - номер тайла в массиве
                                        ;       R1 - адрес шаблона маски цвета
                                        ;       R2 - адрес экрана
                mov     (SP)+, R3
                mov     (SP)+, R0

2$:             tst     (R0)+
                call    (R5)
                sob     R3, 1$
                comb    TrHBlinkingFlg  ; флаг мигания ореола сокровища
                jmp     (R5)
; End of function BlinkTreasureHalo


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Вывод строки
; Вход: R0 - адрес строки
;       R1 - длина строки
;       R2 - адрес экрана
;       R5 - адрес сопрограммы (типично - фоновый звук)
; Выход: R0 += R1 указывает за конец строки

PutStr:         movb    (R0)+, R3
                mov     R0, -(SP)
                mov     R1, -(SP)
                call    PutChr          ; Вывод символа
                                        ; Вход: R2 - адрес вывода
                                        ;       R3 - код символа
                                        ;       R5 - адрес сопрограммы (типично - фоновый звук)
                mov     (SP)+, R1
                mov     (SP)+, R0
                sob     R1, PutStr      ; цикл по длине строки
                return
; End of function PutStr


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Вывод символа
; Вход: R2 - адрес вывода
;       R3 - код символа
;       R5 - адрес сопрограммы (типично - фоновый звук)

PutChr:         call    (R5)
                mov     R4, -(SP)
                asl     R3
                asl     R3
                asl     R3
                add     #Font, R3       ; получим смещение до символа
                mov     #8., -(SP)      ; высота - 8 строк

1$:             call    (R5)
                clr     R0
                movb    (R3)+, R1       ; берём байт символа
                beq     4$              ; если 0, ничего делать не надо

                mov     #8., R4         ; расширяем байт в слово
2$:             asr     R1
                ror     R0
                asr     R0
                call    (R5)
                sob     R4, 2$

                bic     CharColorMask, R0 ; применяем маску цвета символов

4$:             mov     R0, (R2)
                add     #100, R2
                dec     (SP)
                bne     1$
                tst     (SP)+
                sub     #776, R2
                mov     (SP)+, R4
                jmp     (R5)
; End of function PutChr


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Прорисовка ГГ и охотников
; Обработка попадания ножа в кого-нибудь, и воспроизведение звука
; Вход: R4 - индекс звука

DrawHumanoids:  mov     #10, R3         ; индекс, начинаем с третьего охотника

1$:             tst     -(R3)           ; индекс-=2
                call    (R5)
                mov     Coordinate(R3), R2 ; берём текущий адрес охотника в буфере лабиринта
                beq     1$              ; 0 - нету, значит будем искать,
                                        ; когда R3 индекс станет равным 0, то будет указывать на адрес человечка,
                                        ; а он всегда есть.
                mov     R3, -(SP)       ; нашли существующий объект
                cmpb    ThrowKnife, #200 ; нож летит?
                beq     3$              ; нет, в руках
                mov     KnifeAddr, R0   ; да - адрес летящего ножа в буфере лабиринта
                cmp     R0, R2          ; в кого-то попал?
                beq     2$              ; да
                add     #100, R2        ; или чуть ниже
                cmp     R0, R2          ; попал?
                bne     3$              ; нет ещё

2$:             tst     R3              ; умудрился попасть сам в себя?
                beq     6$              ; да! - пойдём проверим, поймал ли
                call    CheckHunterHit  ; счёт за попадание ножом в охотника, если он активен
                                        ; если в процессе зарождения - то нет
                                        ; Вход: R3 - индекс: 2,4,6 - охотник1,2,3,  0 - ГГ быть не может
                br      3$

6$:             call    CheckKnifeCatch ; проверка на взаимодействие ГГ с ножом

3$:             call    CalcSpriteDrawing ; вычисление координат и параметров прорисовки спрайта ГГ/охотника
                                        ; с учётом анимаций
                                        ; Вход: R3 - индекс: 0 - ГГ; 2,4,6 - охотник1,2,3
                movb    SprWidthOut(R3), SprWidthSav(R3)
                mov     ScrAddrOut(R3), ScrAddrSav(R3)
                call    StoreScrNPC     ; сохранение экрана под ГГ/охотником
                                        ; Вход: R3 - индекс: 0 - ГГ; 2,4,6 - охотник1,2,3
                mov     (SP)+, R3
                call    DrawNPC         ; прорисовка ГГ/охотника
                                        ; Вход: R3 - индекс: 0 - ГГ; 2,4,6 - охотник1,2,3
                tst     R3              ; возвращаем индекс
                bne     1$              ; и пока охотники не кончатся, проверяем
; ───────────────────────────────────────────────────────────────────────────
                ; теперь выводим на экран нож, если он летит и в видимой части комнаты
                call    (R5)
                cmpb    ThrowKnife, #200 ; нож летит?
                beq     5$              ; нет
                mov     KnifeAddr, R0   ; да - берём адрес летящего ножа
                mov     R0, R2          ; скопируем
                call    IsVisible       ; проверим, не вылетел ли он за экран
                                        ; Вход: R2 - адрес в буфере
                                        ; Выход: <0 - нет
                blt     5$              ; если да - то пропустим
                movb    SprNFlyKnife, R0 ; отрисовка летящего ножа, берём номер спрайта
                call    Mul20.          ; R0 *= 20.
                add     #SpriteArray-20., R0
                mov     KnifeAddr, R2   ; берём адрес летящего ножа
                call    CalcScrAddr     ; вычисление адреса экрана по адресу байта в буфере комнаты
                                        ; вход: R2 - адрес в буфере комнаты
                                        ; выход: R2 - адрес экрана
                mov     #5, R1
                mov     #100, R3
4$:             bis     (R0)+, (R2)
                add     R3, R2
                bis     (R0)+, (R2)
                add     R3, R2
                sob     R1, 4$
                call    (R5)
; ───────────────────────────────────────────────────────────────────────────
5$:             jmp     PlaySound       ; Вход: R4 - номер звука:
                                        ; 0
                                        ; 2
                                        ; 4
                                        ; 6
                                        ; 10
                                        ; 12
                                        ; 14
; End of function DrawHumanoids

; ───────────────────────────────────────────────────────────────────────────
Kings:          .byte 24, 22, 27, 20, 45, 34 ; "KING'S"
Valley:         .byte 37, 12, 25, 25, 16, 42 ; "VALLEY"
                .byte 45, 34, 46, 26, 12, 31 ; "'S MAP"
Shishkin:       .byte 34, 21, 22, 34, 21, 24, 22, 27 ; "SHISHKIN"
Software:       .byte 34, 30, 17, 35, 40, 12, 33, 16 ; "SOFTWARE"
; строка состояния
StrScore:       .byte 34, 14, 30, 33, 16, 44 ; "SCORE-" ...
ValScore:       .byte 0, 0, 0, 0, 0, 0
                .byte 46, 46, 21, 22, 44    ; "  HI-"
ValHiScore:     .byte 0, 0, 0, 0, 0, 0
                .byte 46, 46, 33, 16, 34, 35, 44 ; "  REST-"
ValRest:        .byte 0, 3
                .byte 31, 42, 33, 12, 26, 22, 15, 44 ; "PYRAMID-"
ValPyramid:     .byte 0, 1
StrPause:       .byte 31, 12, 36, 34, 22, 27, 20 ; "PAUSING"
                .byte 46, 46, 46, 46, 46, 46, 46 ; "       "
                .even

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; вычисление следующей горизонтальной координаты, в зависимости от направления движения
; Вход: R1 - текущий адрес в буфере лабиринта
;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
; Выход: R1 - следующий адрес

NextCoord:      tstb    DirMove(R3)     ; куда направление движения?
                beq     1$              ; вправо
                dec     R1              ; влево, значит коорд. - 1
                jmp     (R5)

1$:             inc     R1              ; коорд. + 1
                jmp     (R5)
; End of function NextCoord


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Обработка нажатий клавиатуры

KeyboardWrk:    call    (R5)
                tstb    @#177660        ; новый код клавиши появился?
                bmi     5$              ; да
                bit     #100, @#177716  ; нет, а клавиша всё ещё нажата?
                beq     4$              ; да

1$:             movb    PressButton, R0 ; тогда берём код уже нажатой клавиши
                bne     0clrKey$        ; если есть
                                        ; если нету - выход
2$:             return
; ───────────────────────────────────────────────────────────────────────────
                ; Вкл/Выкл музыку
3$:             comb    @#MusicOff
                jmp     StartPlayMelody1
; ───────────────────────────────────────────────────────────────────────────

4$:             cmpb    @#177662, #14   ; и эта нажатая клавиша СБР?
                beq     2$              ; да - выход из функции

5$:             call    (R5)
                movb    @#177662, R0    ; читаем код нажатой клавиши
                cmp     #14, R0         ; это СБР?
                beq     3$              ; да - вкл/выкл музыки
                cmp     #10, R0         ; влево?
                beq     0StoreKey$      ; да - переход
                cmp     #31, R0         ; код < 31
                bgt     6$              ; да - переход
                cmp     #33, R0         ; код 31,32,33?
                bge     0StoreKey$      ; да - переход
                cmp     #40, R0         ; пробел?
                beq     0StoreKey$      ; да - переход

6$:             call    (R5)
                cmp     #3, R0          ; КТ?
                bne     1$              ; нет
                mov     #StrPause, R0   ; да - ставим на паузу
                mov     #7, R1
                mov     #GameNameScr2+62, R2
                call    PutStr          ; Вывод строки
                                        ; Вход: R0 - адрес строки
                                        ;       R1 - длина строки
                                        ;       R2 - адрес экрана
                                        ;       R5 - адрес сопрограммы (типично - фоновый звук)
                                        ; Выход: R0 += R1 указывает за конец строки
7$:             tstb    @#177660
                bpl     7$
                movb    @#177662, R1
                cmpb    #3, R1
                beq     7$
                movb    R1, PressButton
                mov     #7, R1
                mov     #GameNameScr2+62, R2
                call    StartPlayMusic
                call    PutStr          ; Вывод строки
                                        ; Вход: R0 - адрес строки
                                        ;       R1 - длина строки
                                        ;       R2 - адрес экрана
                                        ;       R5 - адрес сопрограммы (типично - фоновый звук)
                                        ; Выход: R0 += R1 указывает за конец строки
                clr     R3
                br      KeyboardWrk     ; Обработка нажатий клавиатуры
; ───────────────────────────────────────────────────────────────────────────
0clrKey$:       clrb    PressButton     ; а если есть - очищаем, чтоб в следующий раз не было
                br      ReactControl

0StoreKey$:     movb    R0, PressButton ; Сохраняем коды: 10,31,32,33,40
; End of function KeyboardWrk           ; и обрабатываем действия


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Обработка реакции на взаимодействие
; Вход: R0 - код нажатой клавиши: 10,31,32,33,40. других нет
;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3

ReactControl:   call    (R5)
                mov     #1, R2
                movb    AnimType(R3), R1 ; проверим анимацию
                bicb    #10, R1         ; убираем лишнее
                bne     0Done1$         ; если там что-то есть - выходим
                ; работаем только если анимация 0
                mov     Coordinate(R3), R1 ; берём текущую координату
                cmp     #31, R0         ; код нажатой клавиши >31?
                blt     8$              ; да - переход
                ; нет - обрабатываем нажатия 10 (влево) и 31 (вправо)
                call    (R5)
                tstb    OffsetY(R3)     ; вертикальное перемещение есть?
                beq     2$              ; нет - переход
                inc     R1              ; да - тогда сдвиг на 1 вправо
                cmp     #10, R0         ; нажали клавишу влево?
                bne     1$              ; нет
                tst     -(R1)           ; да - тогда сдвиг на 1 влево

1$:             cmpb    200(R1), R2     ; внизу стена/пол?
                beq     2$              ; да - переход
                cmp     #RoomFooter, R1 ; дошли до самого низа?
                bgt     0Done1$         ; нет, выходим

2$:             call    (R5)
                movb    R2, OffsetX(R3) ; задаём смещение вправо
                clrb    DirMove(R3)     ; направление движения - вправо
                cmp     #10, R0         ; нажали клавишу влево?
                bne     5$              ; нет - переход
                negb    OffsetX(R3)     ; да - значит смещение влево
                incb    DirMove(R3)     ; и направление движения - влево

5$:             call    (R5)
                tstb    OffsetY(R3)     ; вертикальное перемещение есть?
                bne     0Done1$         ; да - выход
                movb    OffsetX(R3), R0 ; нет - берём горизонтальное смещение
                mov     Coordinate(R3), R1 ; текущую координату
                add     R1, R0          ; это адрес, куда будет перемещение
                movb    200(R1), R2
                cmpb    #TS$LadderUppLeft, R2 ; если на текущем месте проходимая преграда
                bgt     0Done1$         ; то выход
                cmpb    200(R0), #TS$Wall ; если на будущем месте стена/пол
                beq     0Done1$         ; то выход
                cmpb    100(R0), R2
                beq     7$
                cmpb    300(R0), R2     ; похоже на проверку на лестницу
                bne     0Done1$
                movb    #100, OffsetY(R3) ; спуск на 1 вниз
                br      0Done1$
; ───────────────────────────────────────────────────────────────────────────

7$:             movb    #-100, OffsetY(R3) ; а это подъём на 1 вверх
0Done1$:        jmp     (R5)
; ───────────────────────────────────────────────────────────────────────────
; обработка других действий

8$:             call    (R5)
                cmp     #33, R0         ; код нажатой клавиши >33?
                blt     14$             ; да переход
                cmp     #32, R0         ; нажали стрелку вверх?
                bne     10$             ; нет
; ───────────────────────────────────────────────────────────────────────────
                ; обработка нажатия стрелки вверх
                call    (R5)            ; да
                tstb    OffsetY(R3)     ; вертикальное перемещение есть?
                blt     0Done1$         ; да и итак вверх, выход
                bgt     13$             ; а если вниз - то переход (меняем направление движения на лестнице)
                ; проверка на лестницы, если да - то подъём
                cmpb    101(R1), #TS$LadderUppRight ; лестница вправо там есть?
                bne     9$              ; нет
                mov     #140001, OffsetX(R3) ; да - значит X <- 1; Y <- -100
                clrb    DirMove(R3)     ; направление движения - вправо
                br      0Done1$

9$:             call    (R5)
                cmpb    77(R1), #TS$LadderUppLeft ; а лестница влево там есть?
                bne     0Done1$         ; нет - выход
                mov     #140377, OffsetX(R3) ; да - значит X <- -1; Y <- -100
                movb    R2, DirMove(R3) ; и направление движения - влево
                br      0Done1$
; ───────────────────────────────────────────────────────────────────────────
                ; обработка нажатия стрелки вниз
10$:            call    (R5)            ; значит нажали стрелку вниз
                tst     R3              ; кого обрабатываем?
                bne     11$             ; охотника
                clrb    GGFlag          ; флаг - висеть и не падать в только что пробитую дыру киркой вниз.
                                        ; всё, можно падать
11$:            tstb    OffsetY(R3)     ; вертикальное перемещение есть?
                bgt     0Done1$         ; да и итак вниз, выход
                blt     13$             ; а если вверх - то переход (меняем направление движения на лестнице)
                ; если вертикального перемещения не было
                call    (R5)
                cmp     #RoomFooter, R1 ; до дна дошли?
                blt     12$             ; да - переход
                movb    200(R1), R0     ; что под нами?
                call    DownToLadder    ; проверка на спуск по лестнице
                                        ; Вход: R0 - значение элемента комнаты, куда будет шаг
                                        ;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
                                        ; Выход: Z - можно спускаться
                beq     0Done1$         ; да, лестница и всё в норме
                call    (R5)            ; нет - не лестница
                movb    OffsetX(R3), R1 ; горизонтальное смещение
                add     Coordinate(R3), R1 ; где будем
                movb    200(R1), R1     ; что там?
                bicb    #2, R1          ; для лестницы - убираем лево/право
                call    (R5)
                cmpb    #TS$LadderUppLeft, R1 ; если лестница, не важно какая
                beq     0Done1$         ; то выход
                cmpb    R2, R0          ; если стена
                beq     12$             ; то переход
                cmpb    #TS$BreachLeft, R0
                bgt     0Done1$

12$:            clr     OffsetX(R3)     ; остановиться
                br      0Done1$
; ───────────────────────────────────────────────────────────────────────────

13$:            jmp     ReflectMove     ; изменение направления движения на обратное

; ───────────────────────────────────────────────────────────────────────────
; обработка нажатия пробела
14$:            call    (R5)
                tst     R3              ; кого обрабатываем?
                bne     15$             ; охотника
                clrb    PressButton
                tstb    GGHaveEquip     ; а в руках что-то есть?
                bne     16$             ; да - пойдём обрабатывать
                ; нет - просто прыжок
15$:            tstb    OffsetY(R3)     ; движение по вертикали есть?
                bne     0Done2$         ; да - выходим
                jmp     MakeJump        ; нет - Прыжок
                                        ; Вход: R1 - текущая координата
                                        ;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
; ───────────────────────────────────────────────────────────────────────────

16$:            bgt     18$             ; пойдём обрабатывать кирку
; обработка бросания ножа, сперва проверим, можно ли бросать.
                tstb    AnimType        ; анимации есть?
                bne     0Done2$         ; да - выходим
                cmpb    ThrowKnife, #200 ; нож летит?
                bne     0Done2$         ; да, летит, выходим
                ; вот сюда попадаем сразу после броска ножа
                mov     #2, R0          ; проверка на 2 координаты в сторону, а не только перед собой
                ; так можно будет кидать нож, только если перед собой пустое пространство
                ; если это убрать, то нож можно будет кидать всегда, кроме как упёршись лбом в препятствие
17$:            call    (R5)
                call    NextCoord       ; вычисление следующей горизонтальной координаты, в зависимости от направления движения
                                        ; Вход: R1 - текущий адрес в буфере лабиринта
                                        ;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
                                        ; Выход: R1 - следующий адрес
                cmpb    (R1), #TS$Wall  ; там стена?
                beq     0Done2$         ; да - выход
                cmpb    (R1), #TS$BreachLeft ; там двери?   (сравнить с 18.)
                bge     0Done2$         ; да - выход
                mov     R1, R2
                call    CalcScrAddr     ; вычисление адреса экрана по адресу байта в буфере комнаты
                                        ; вход: R2 - адрес в буфере комнаты
                                        ; выход: R2 - адрес экрана
                cmp     GreenWallCheck, (R2) ; это зелёная стена?
                beq     0Done2$         ; да - выход, не даём бросить нож если стоим впритык к зелёной стене
                cmp     EntryInterrior1+2, (R2) ; не даём бросать нож внутри открытого прохода
                beq     0Done2$         ; если левая часть - стенка
                cmp     InpLadder, (R2)
                beq     0Done2$         ; если правая часть - лестница
                sob     R0, 17$         ; проверка на 2 координаты в сторону, а не только перед собой
                clrb    GGHaveEquip     ; всё, в руках ГГ пусто, нож брошен
                mov     #3404, AnimStage ; AnimStage <- 4, AnimType <- 7
                mov     #6001, OffsXFlyKnife ; KnifeOffsX <- 1, KnifeSprite <- 14
                mov     #10, R4         ; номер звука ножа
                movb    #177, @#DopplerEffect
                tstb    DirMove         ; флаг направления движения для ГГ/охотника, 0 - вправо, !0 - влево
                beq     0Done2$
                negb    OffsXFlyKnife   ; скорректируем смещение ножа

0Done2$:        jmp     (R5)
; ───────────────────────────────────────────────────────────────────────────
; обработка стучания киркой

18$:            cmp     #RoomFooter, R1 ; дна достигли?
                blt     23$             ; да
                add     #200, R1        ; нет
                cmpb    (R1), R2        ; под нами стена?
                bne     0Done2$         ; нет - выход
                mov     GrownWallsPtr, R0 ; указатель на структуру блока параметров зарастающих стен комнаты
                mov     (R0)+, R2       ; количество зарастающих стен
                beq     21$             ; нету

19$:            cmp     (R0)+, R1       ; мы на месте стены?
                bne     20$             ; нет
                mov     #40, HuntTurnHead ; да - не даём стене зарасти

20$:            sob     R2, 19$         ; проверим все стены

21$:            movb    #6, AnimType    ; постучать киркой вниз

22$:            clr     OffsetX         ; остановимся
                clrb    GGHaveEquip     ; всё, в руках больше ничего нет
                movb    #10, AnimStage  ; номер этапа в анимации
                br      0Done2$
; ───────────────────────────────────────────────────────────────────────────

23$:            call    NextCoord       ; вычисление следующей горизонтальной координаты, в зависимости от направления движения
                                        ; Вход: R1 - текущий адрес в буфере лабиринта
                                        ;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
                                        ; Выход: R1 - следующий адрес
                cmpb    (R1), R2        ; впереди стена?
                beq     24$             ; да
                cmpb    100(R1), R2     ; и чуть ниже тоже?
                bne     0Done2$         ; нет

24$:            call    (R5)
                bic     #177740, R1     ; мы у левого края?
                beq     0Done2$         ; да - выход
                cmp     #37, R1         ; у правого?
                beq     0Done2$         ; да - тоже выход
                movb    #5, AnimType    ; постучать киркой вбок
                br      22$
; End of function ReactControl


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; проверка на спуск по лестнице
; Вход: R0 - значение элемента комнаты, куда будет шаг
;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
; Выход: Z - можно спускаться

DownToLadder:   call    (R5)
                cmpb    #TS$LadderUppLeft, R0 ; лестница левая?
                bne     1$              ; нет
                mov     #40001, OffsetX(R3) ; да, тогда X <- 1; Y <- 100
                clrb    DirMove(R3)     ; движемся вправо
                br      2$
; ───────────────────────────────────────────────────────────────────────────

1$:             cmpb    #TS$LadderUppRight, R0 ; лестница правая?
                bne     3$              ; нет
                mov     #40377, OffsetX(R3) ; да, тогда X <- -1; Y <- 100
                movb    #1, DirMove(R3) ; движемся влево

2$:             sez                     ; флаг успешной операции
3$:             return
; End of function DownToLadder


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; какая-то сложная функция, так и непонятно что делает, какие-то непонятные действия.
; одно из - проверка на препятствия, чтобы останавливался и не проходил сквозь непроходимые препятствия.
; Вход: R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3

sub_7452:       tst     R3              ; кого обрабатываем?
                bne     1$              ; охотника
                cmp     GGCoord, StartCoord ; ГГ, а его координата совпадает с этой?
                beq     1$              ; да, т.е. пока родился и стоит на месте, или висит не двигаясь над пробитой дырой в полу
                ; если ГГ сместился, то чистим переменные
                clr     StartCoord      ; нет - очистим
                clrb    GGFlag          ; флаг - висеть и не падать в только что пробитую дыру киркой вниз.
                                        ; всё, можно падать
1$:             call    (R5)
                mov     Coordinate(R3), R0 ; берём текущую координату
                movb    OffsetX(R3), R1
                add     R1, R0
                movb    OffsetY(R3), R1
                add     R1, R0          ; будущая координата
                movb    AnimType(R3), R2 ; тип анимации
                call    (R5)
                bic     #10, R2         ; убираем лишнее
                beq     2$              ; ходьба
                cmpb    #7, R2          ; бросок ножа?
                bne     14$             ; нет
; анимации 0 и 7 - ходьба и бросок ножа
2$:             tstb    R1              ; движение по вертикали есть?
                beq     6$              ; нет
                blt     3$              ; да, и вверх
                mov     Coordinate(R3), R0 ; а если вниз, то будущей сделаем текущую координату

3$:             call    (R5)
                call    IsLadder        ; под ногами - лестница?
                                        ; Вход: R0 - координата
                                        ; Выход: Z - да
                beq     0Done3$         ; да, лестница - выход
                ; не лестница.
4$:             call    (R5)
                clrb    OffsetY(R3)     ; тогда и больше не идём по вертикали
                cmpb    #7, R2          ; бросок ножа?
                beq     5$              ; да
                clrb    AnimType(R3)    ; нет - отменяем анимации
                ; это флаг прекращения движения по вертикали, т.е. мы закончили шагать по лестнице
5$:             tstb    word_556        ; флаг однократной проверки
                bne     8$              ; уже проверяли - выходим
                incb    word_556        ; больше не проверять.
                ;br      sub_7452        ; нет смысла идти туда, т.к. GGCoord здесь не меняется.
                br      1$              ; и начнём сначала, там заново вычислим будущую координату
                                        ; и перейдём на метку 6$
; ───────────────────────────────────────────────────────────────────────────
; движения по вертикали нет, идём горизонтально
6$:             call    CheckObstacle   ; Проверка на препятствие для ГГ/охотника
                                        ; Вход: R0 - адрес в лабиринте, будущая координата
                                        ;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
                                        ; Выход: результат работы - прекращение движения, если встретилось препятствие
                add     #100, R0
                call    CheckObstacle   ; Проверка на препятствие для ГГ/охотника
                                        ; Вход: R0 - адрес в лабиринте, будущая координата
                                        ;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
                                        ; Выход: результат работы - прекращение движения, если встретилось препятствие
                call    (R5)
                cmp     #RoomFooter + 100, R0 ; идём по самому дну?
                blt     11$             ; да, переход
                mov     Coordinate(R3), R1
                cmpb    100(R0), #TS$Wall ; под ногами будет стена?
                beq     9$              ; да, есть куда идти
                movb    200(R1), R0     ; что под ногами сейчас
                tstb    OffsetX(R3)     ; препятствия нету, идти можно?
                beq     10$             ; нет
                tstb    word_556        ; можно, а лестница была?
                bne     10$             ; да - пропустим
                call    DownToLadder    ; проверка на спуск по лестнице
                                        ; Вход: R0 - значение элемента комнаты, куда будет шаг
                                        ;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
                                        ; Выход: Z - можно спускаться
                bne     10$             ; нету лестницы, негде спускаться

0Done3$:        call    (R5)
;  тут такое условие 
;  if ( ( (OffsetY(R3) > 0) && (Coordinate(R3) > RoomFooter) )
;    || ( (R3 == 0) && (GGFlag != 0) )
;     ) goto 4$
;   непонятно что хотел Шишкин.
; если движение вниз, и достигли дна - то 4$ - там остановка движения по вертикали. и надо делать сразу выход
; если движения вниз нету - сразу выход
; или если ГГ и висит над пробитой дырой - то 4$ иначе - выход

                tstb    OffsetY(R3)     ; движение по вертикали есть?
                ble     8$              ; вверх или нет
                cmp     Coordinate(R3), #RoomFooter ; вниз -
                bgt     4$
                ; закомментировал это и ничего не изменилось
                ;tst     R3
                ;bne     8$
                ;tstb    GGFlag          ; флаг - висеть и не падать в только что пробитую дыру киркой вниз.
                ;bne     4$

8$:             clrb    word_556
                jmp     (R5)
; ───────────────────────────────────────────────────────────────────────────

9$:             movb    200(R1), R0     ; что под ногами сейчас

10$:            call    (R5)
                cmpb    #TS$Wall, R0    ; под ногами стена?
                bne     12$             ; нет
                ; да - стена
11$:            tstb    OffsetX(R3)     ; горизонтальное движение есть?
                bne     0Done3$         ; да - выходим, ещё есть куда идти
                clrb    AnimStage(R3)   ; нет - прекращаем анимацию
                br      0Done3$
; ───────────────────────────────────────────────────────────────────────────

12$:            cmpb    #TS$BreachLeft, R0 ; под ногами односторонняя дверь?
                ble     0Done3$         ; да - выходим
                call    IsLadderHere    ; проверка на лестницу по текущим координатам
                                        ; Вход: R3 - индекс
                                        ; Выход: Z - лестница
                beq     0Done3$         ; под ногами лестница, выходим.
                tst     R3              ; кто?
                bne     13$             ; охотник - переход
                ; а если ГГ, проверяем
                ; вот это место, где ГГ висит и не падает, если эту проверку убрать, то будет сразу
                ; падать в пробитую дыру
                tstb    GGFlag          ; флаг - висеть и не падать в только что пробитую дыру киркой вниз.
                bne     0Done3$         ; висим пока - пропускаем
                call    (R5)
                ; вот это тоже какая-то бессмысленная проверка, т.к. в падении нож всё равно бросать нельзя.
                cmpb    #7, R2          ; бросок ножа?
                bne     13$
                decb    GGHaveEquip     ; нож подхвачен
                clr     R4              ; звук броска ножа

13$:            mov     #2002, AnimStage(R3) ; AnimStage <- 2, AnimType <- 4
                mov     #40000, OffsetX(R3) ; X <- 0; Y <- 100
                br      0Done3$
; ───────────────────────────────────────────────────────────────────────────
; анимации 1..6
14$:            cmp     #2, R2          ; что за анимация?
                blt     0Done3$         ; не прыжки - игнорируем
                ; обрабатываем только 1 и 2 - прыжки
                ; проверяем на препятствие, мешающее лететь
                call    CheckObstacle   ; Проверка на препятствие для ГГ/охотника
                                        ; Вход: R0 - адрес в лабиринте, будущая координата
                                        ;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
                                        ; Выход: результат работы - прекращение движения, если встретилось препятствие
                add     #100, R0
                call    CheckObstacle   ; Проверка на препятствие для ГГ/охотника
                                        ; Вход: R0 - адрес в лабиринте, будущая координата
                                        ;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
                                        ; Выход: результат работы - прекращение движения, если встретилось препятствие
                ; это проверка, когда на исходе высокого прыжка ГГ стукается башкой в препятствие
                ; то останавливается
                tstb    OffsetY(R3)     ; движение по вертикали?
                ble     15$             ; вверх или нет
                sub     #200, R0        ; вниз - проверим, что над головой
                call    CheckObstacle   ; Проверка на препятствие для ГГ/охотника
                                        ; Вход: R0 - адрес в лабиринте, будущая координата
                                        ;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
                                        ; Выход: результат работы - прекращение движения, если встретилось препятствие
15$:            tstb    OffsetX(R3)     ; остановились? т.е. возникло препятствие?
                bne     0Done3$         ; нет - выход
                ; если препятствие остановило ГГ, проверим что под ногами
                ; и если пусто - то анимация падения, если нет - то просто стоять.
                call    (R5)            ; да
                mov     #2002, AnimStage(R3) ; AnimStage <- 2, AnimType <- 4
                mov     Coordinate(R3), R0
                movb    200(R0), R0
                cmpb    #TS$Wall, R0    ; под ногами стена?
                beq     16$             ; да
                cmpb    #TS$BreachLeft, R0 ; нет, а возможно односторонняя дверь?
                bgt     0Done3$         ; возможно, да

16$:            clrb    AnimType(R3)    ; стоять
                clr     OffsetX(R3)     ; X <- 0; Y <- 0
                br      0Done3$
; End of function sub_7452


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Проверка на препятствие для ГГ/охотника
; Вход: R0 - адрес в лабиринте, будущая координата
;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
; Выход: результат работы - прекращение движения, если встретилось препятствие

CheckObstacle:  call    (R5)
                cmpb    (R0), #TS$Wall      ; там стена?
                beq     2$                  ; да
                bitb    #10, AnimType(R3)   ; нет - бит выставлен? т.е. проход через дверь?
                bne     3$                  ; да - ничего делать не нужно
                cmpb    (R0), #TS$ClosBreachRight ; это правая сторона двери, через которую можно пройти?
                beq     1$                  ; да
                cmpb    (R0), #TS$ClosBreachLeft ; или левая?
                bne     3$                  ; нет - просто выход
                ; если проходим сквозь дверь с односторонней проницаемостью
1$:             call    (R5)
                cmpb    @Coordinate(R3), #TS$OpnBreachLeft ; по тек. коорд. 20.?
                blt     2$              ; там пройти нельзя
                tst     R3              ; это кто?
                bne     2$              ; охотник - он не может проходить через дверь.
                ; для охотников никогда не выставляем бит 4 в AnimType, только для ГГ
                bisb    #10, AnimType(R3)
                br      3$
; ───────────────────────────────────────────────────────────────────────────

2$:             clrb    OffsetX(R3)     ; остановка
3$:             jmp     (R5)
; End of function CheckObstacle


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Вход: R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3

MakeJumpHere:   mov     Coordinate(R3), R1

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Прыжок
; Вход: R1 - текущая координата
;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3

MakeJump:       call    (R5)
                tstb    OffsetX(R3)     ; Горизонтальное движение есть?
                bne     2$              ; есть
                ; нет движения по горизонтали
                decb    OffsetX(R3)     ; двигаться влево
                tstb    DirMove(R3)     ; а куда двигаться надо?
                bne     2$              ; влево, ок
                negb    OffsetX(R3)     ; вправо, тогда будем двигаться вправо

2$:             call    VerifyCanJump   ; проверка, можно ли прыгнуть
                                        ; Вход: R1 - текущая координата
                tstb    AnimType(R3)    ; анимация прыжка началась?
                bne     3$              ; да
                clr     OffsetX(R3)     ; нет - стоять на месте

3$:             jmp     (R5)
; End of function MakeJump
; End of function MakeJumpHere


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; проверка, можно ли прыгнуть
; Вход: R1 - текущая координата
;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3

VerifyCanJump:  call    (R5)
                mov     #1, R2
                cmp     #RoomFooter, R1
                blt     2$
                movb    200(R1), R0     ; под ногами что?
                bne     1$              ; что-то есть
                tstb    GGFlag          ; пусто, флаг - висеть и не падать в только что пробитую дыру киркой вниз.
                bne     2$              ; пропустить проверку
                ; проверить опору под ногами
1$:             call    (R5)
                cmpb    R0, R2          ; под ногами стена?
                beq     2$              ; да
                cmpb    #TS$BreachLeft, R0 ; односторонняя дверь?
                ble     2$              ; да
                bic     #2, R0
                cmp     #TS$LadderUppLeft, R0 ; лестница, любая?
                bne     8$              ; нет
                ; в принципе прыгать можно, проверяем дальше
2$:             call    (R5)
                movb    -100(R1), R0    ; что над головой?
                cmpb    R2, R0          ; стена?
                beq     8$              ; да - прыгать нельзя
                tst     R3              ; это кто?
                bne     6$              ; охотник, для него не делаются проверки на ключ и кирку
                cmpb    #TS$Key, R0     ; ГГ - ключ для выхода из пирамиды? (сравнение с 17.)
                bne     5$              ; нет
                movb    R2, CatchKeyFlg ; да, отметим

3$:             movb    #3, AnimType(R3) ; прыжок на месте
4$:             clrb    AnimStage(R3)   ; выходим
                jmp     (R5)
; ───────────────────────────────────────────────────────────────────────────

5$:             cmpb    #TS$Hack, R0    ; наткнулись на кирку?
                bne     6$              ; нет
                movb    R2, GGHaveEquip ; да - флаг, что в руках кирка
                br      3$
; ───────────────────────────────────────────────────────────────────────────

6$:             call    (R5)
                movb    OffsetX(R3), R0
                add     R0, R1
                cmpb    (R1), R2        ; впереди по движению стена?
                beq     8$              ; да - прыгать нельзя
                cmpb    -100(R1), R2    ; выше стена?
                beq     8$              ; да - прыгать нельзя
                call    (R5)
                cmpb    -200(R1), R2    ; ещё выше стена?
                beq     9$              ; да - можно малый прыжок
                add     R0, R1          ; а ещё дальше по движению?
                sub     #100, R1        ; над головой
                cmpb    (R1), R2        ; стена?
                beq     9$              ; да - можно малый прыжок
                call    (R5)
                cmpb    (R1), #TS$ClosBreachRight ; через одностороннюю дверь тоже можно малый прыжок
                beq     9$
                cmpb    (R1), #TS$ClosBreachLeft
                beq     9$
                cmpb    -100(R1), R2    ; ещё выше тоже стена?
                beq     9$              ; да - можно малый прыжок
                call    (R5)
                cmp     #Room + 100, R1 ; верх лабиринта?
                bge     9$              ; да - можно малый прыжок
                ; 2 - большой прыжок
                mov     #1020, AnimStage(R3) ; AnimStage <- 20, AnimType <- 2

7$:             movb    #-100, OffsetY(R3) ; движемся вверх
                jmp     (R5)
; ───────────────────────────────────────────────────────────────────────────
                ; под ногами нет опоры, или над головой - места
8$:             clrb    AnimType(R3)    ; прыгать нельзя.
                br      4$              ; выходим
; ───────────────────────────────────────────────────────────────────────────

9$:             call    (R5)
                mov     #410, AnimStage(R3) ; AnimStage <- 10, AnimType <- 1
                br      7$
; End of function VerifyCanJump


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; перерисовка лабиринта при выходе за экран
; стираем человечков, потом рисуем, потом снова стираем
; Выход: R0 - номер текущей анимации
;        Z=1 - нет прохода через одностороннюю дверь (обработка других анимаций)
;        Z=0 - есть

sub_10662:      call    (R5)
                call    sub_11016       ; Изменение этапа анимаций, стирание персонажей, обработка полёта ножа
                                        ; если нужно - обработка анимации прохода через одностороннюю дверь
                                        ; Выход: R0 - номер текущей анимации
                                        ;        Z=1 - нет прохода через одностороннюю дверь (обработка других анимаций)
                                        ;        Z=0 - есть
                call    BlinkTreasureHalo ; функция мигания ореола сокровищ
                tstb    ChangeRoomFlg   ; комната сменилась?
                beq     4$              ; нет, переход
                tstb    OffsetX         ; куда движемся?
                blt     2$              ; влево
                add     #20, RoomOffset ; вправо - переход в полукомнату справа
                call    (R5)
                clr     R2
                call    DrawRoom        ; вывод на экран сформированной половинки комнаты
                                        ; Вход: R2 - адрес смещения в буфере
                clr     R2
                call    DrawRoomNxt     ; вывод на экран следующей сформированной половинки комнаты
                                        ; Вход: R2 - адрес смещения в буфере
                br      3$
; ───────────────────────────────────────────────────────────────────────────

2$:             sub     #20, RoomOffset ; переход в полукомнату слева
                call    (R5)
                clr     R2
                call    DrawRoomNxt     ; вывод на экран следующей сформированной половинки комнаты
                                        ; Вход: R2 - адрес смещения в буфере
                clr     R2
                call    DrawRoom        ; вывод на экран сформированной половинки комнаты
                                        ; Вход: R2 - адрес смещения в буфере
3$:             cmp     RoomOffset, #20
                beq     4$
                call    RedrawInOutDoor

4$:             call    (R5)
                call    DrawHumanoids   ; Прорисовка ГГ и охотников
                                        ; Обработка попадания ножа в кого-нибудь, и воспроизведение звука
                                        ; Вход: R4 - индекс звука


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Изменение этапа анимаций, стирание персонажей, обработка полёта ножа - 
; расчёт координат летящего ножа, проверка коллизий ножа.
; если нужно - обработка анимации прохода через одностороннюю дверь
; Выход: R0 - номер текущей анимации, если Z=1, иначе не имеет значения
;        Z=1 - нет прохода через одностороннюю дверь (обработка других анимаций)
;        Z=0 - есть

sub_11016:      clr     R3              ; R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3

1$:             call    (R5)
                tst     Coordinate(R3)  ; текущая координата есть?
                beq     5$              ; нету, и делать нечего
                mov     R3, -(SP)
                tstb    AnimStage(R3)   ; что с анимацией?
                ble     2$              ; 0
                decb    AnimStage(R3)   ; не 0 - уменьшаем счётчик

2$:             call    (R5)
                bitb    AnimStage(R3), #1 ; какой этап?
                beq     3$              ; чётный - пойдём сотрём персонажа
                tstb    ChangeRoomFlg   ; или комнату менять надо?
                bne     4$              ; да, тогда восстанавливать экран нет смысла

3$:             call    RestoreScrNPC   ; восстановление экрана под ГГ/охотником
                                        ; Вход: R3 - индекс: 0 - ГГ; 2,4,6 - охотник1,2,3
4$:             mov     (SP)+, R3

5$:             tst     (R3)+           ; следующий индекс
                cmp     #10, R3         ; пока все не обработаем
                bne     1$
                call    (R5)
; ───────────────────────────────────────────────────────────────────────────
; теперь обработка ножа - расчёт координат летящего ножа,
;   проверка коллизий
                cmpb    ThrowKnife, #200 ; нож летит?
                beq     14$             ; нет - ничего делать не надо
                ; да - нож летит
                mov     KnifeAddr, R1   ; адрес летящего ножа в буфере лабиринта
                call    DrawTileVisible ; Прорисовываем нож на экране
                                        ; Вход: R1 - адрес в буфере
                movb    OffsXFlyKnife, R0 ; смещение летящего ножа
                movb    R0, R2
                add     R1, R0          ; будущий адрес
                call    (R5)
                tstb    ThrowKnife      ; нож летит?
                bne     9$              ; да
                ; всё, кончилась дальность броска
                tstb    R2              ; Нож остановился вися в воздухе?
                beq     10$             ; да
                ; ещё нет, или падает, проверим, что там по будущей координате
                cmpb    (R0), #TS$Wall  ; стена?
                beq     6$              ; да
                cmpb    (R0), #TS$Key   ; односторонний проход?
                ble     12$             ; нет

6$:             call    (R5)
                cmpb    #100, R2        ; падает вниз?
                bne     11$             ; нет
                tstb    (R1)            ; да - пока не упрётся во что-нибудь
                bne     8$
                tstb    1(R1)
                blt     8$
                tstb    -1(R1)
                blt     8$

7$:             call    (R5)
                movb    #TS$Knife, (R1) ; вот тут будет упавший нож
                call    DrawTileVisible ; Прорисовываем нож на экране
                                        ; Вход: R1 - адрес в буфере
                mov     #14, R4         ; звук упавшего ножа

8$:             call    (R5)
                call    CatchKnife      ; подбор ножа
                br      14$
; ───────────────────────────────────────────────────────────────────────────

9$:             decb    ThrowKnife      ; уменьшаем счётчик
                br      13$
; ───────────────────────────────────────────────────────────────────────────

10$:            movb    #100, OffsXFlyKnife ; должен падать
                br      13$
; ───────────────────────────────────────────────────────────────────────────

11$:            clrb    OffsXFlyKnife   ; нож упёрся в препятствие, останавливаем
                movb    #10, ThrowKnife ; счётчик, сколько ножик крутится на месте, пока не упадёт
                cmp     #10, R4         ; звук был такой?
                bne     13$             ; нет
                clr     R4              ; да - станет такой
                br      13$
; ───────────────────────────────────────────────────────────────────────────

12$:            mov     R0, R2
                call    CalcScrAddr     ; вычисление адреса экрана по адресу байта в буфере комнаты
                                        ; вход: R2 - адрес в буфере комнаты
                                        ; выход: R2 - адрес экрана
                cmp     GreenWallCheck, (R2)
                beq     11$
                cmp     #RoomFooter + 100, R1
                blt     7$
                mov     R0, KnifeAddr   ; перемещаем нож на следующую координату

13$:            call    (R5)

                mov     #SprNFlyKnife, R0
                incb    (R0)    ; циклически меняем номер спрайта ножа
                cmpb    (R0), #TS$FlyKnife045+1
                blt     14$
                movb    #TS$FlyKnife135, (R0)
; ───────────────────────────────────────────────────────────────────────────
; теперь проверка и обработка анимации прохода через одностороннюю дверь
; если он выполняется
; как оказалось, это нужно всегда. Так получается плавная анимация
14$:            movb    AnimType, R0    ; номер анимации действий ГГ/охотника
                call    (R5)
                bit     #10, R0
                beq     15$
                call    DrawAnimDoor    ; отработка поворота односторонней двери
                clz                     ; снимаем флаг, чтоб не делать обработки других анимаций
15$:            return
; End of function sub_11016
; End of function sub_10662


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; проверка, в видимой полукомнате или нет.
; Вход: R2 - адрес в буфере
; Выход: <0 - нет

IsVisible:      bic     #177700, R2
                call    (R5)
                sub     RoomOffset, R2
                blt     1$
                cmp     #37, R2

1$:             return
; End of function IsVisible


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Вывод на экран элемента комнаты, если он видимый.
; Это для перерисовки.
; Вход: R1 - адрес в буфере

DrawTileVisible:mov     R1, R2
                call    IsVisible       ; проверка, в видимой полукомнате или нет.
                                        ; Вход: R2 - адрес в буфере
                                        ; Выход: <0 - нет
                blt     1$              ; вне зоны видимости
                jmp     DrawTileRoomAdr ; вывод на экран элемента комнаты
                                        ; Вход: R1 - адрес элемента в буфере комнаты

1$:             return
; End of function DrawTileVisible


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; счёт за попадание ножом в охотника, если он активен
; если в процессе зарождения - то нет
; Вход: R3 - индекс: 2,4,6 - охотник1,2,3,  0 - ГГ быть не может

CheckHunterHit: tstb    HuntState(R3)   ; состояние охотника?
                blt     0Ret1$          ; в процессе рождения - выход
                clr     AnimStage(R3)   ; анимацию почистим
                clr     OffsetX(R3)     ; движение - тоже
                movb    #-40, HuntState(R3) ; состояние инициализируем
                mov     #2, R4          ; звук попадания в охотника
                mov     #400, CurrScoreBuf+2 ; прибавка к счёту


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; изменяем счёт

IncrScore:      mov     #ValScore+5, R1
                mov     R3, -(SP)
                mov     R2, -(SP)
                call    AddAsc          ; добавление очков к счёту
                                        ; Вход: R1 - адрес буфера числа, указатель на мл. разряд
                mov     #ValScore, R0
                mov     #6, R1
                mov     #40014, R2
                call    PutStr          ; Вывод строки
                                        ; Вход: R0 - адрес строки
                                        ;       R1 - длина строки
                                        ;       R2 - адрес экрана
                                        ;       R5 - адрес сопрограммы (типично - фоновый звук)
                                        ; Выход: R0 += R1 указывает за конец строки
                mov     (SP)+, R2
                mov     (SP)+, R3
0Ret1$:         return
; End of function IncrScore
; End of function CheckHunterHit


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; добавление очков к счёту
; Вход: R1 - адрес буфера числа, указатель на мл. разряд

AddAsc:         mov     #CurrScoreBuf+5, R2 ; число, которое прибавляем
                mov     R4, -(SP)

1$:             movb    (R2), R4        ; разряд источник
                movb    (R1), R3        ; разряд приёмник
                add     R4, R3          ; складываем
                cmp     #10., R3        ; переполнение?
                bgt     3$              ; нет
                sub     #10., R3        ; да, оставим единицы
                cmp     #ValScore+2, R1 ; дошли до 4 разряда счёта?
                bne     2$              ; нет
                mov     R1, -(SP)       ; да
                mov     R2, -(SP)
                mov     R3, -(SP)
                mov     #ValRest, R1    ; +1 к жизням
                mov     R1, R0          ; адрес для вывода на экран
                mov     #1, R2
                call    IncAsc          ; +-1 к двузначному числу
                                        ; Вход: R2 - аргумент >=0 : +1, <0 : -1
                                        ;       R1 - адрес, где находится число
                                        ; Выход: R1 = R1 - 1
                                        ; не портит регистров
                mov     #2, R1          ; выведем на экран
                mov     #40074, R2
                call    PutStr          ; Вывод строки
                                        ; Вход: R0 - адрес строки
                                        ;       R1 - длина строки
                                        ;       R2 - адрес экрана
                                        ;       R5 - адрес сопрограммы (типично - фоновый звук)
                                        ; Выход: R0 += R1 указывает за конец строки
                mov     (SP)+, R3
                mov     (SP)+, R2
                mov     (SP)+, R1

2$:             cmp     #CurrScoreBuf, R2 ; перенос есть делать куда?
                beq     3$              ; уже нету
                incb    -1(R1)          ; есть - делаем

3$:             movb    R3, (R1)        ; сохраняем результат в приёмнике
                dec     R2              ; к следующему разряду
                dec     R1
                cmp     #CurrScoreBuf-1, R2 ; достигли конца?
                bne     1$              ; пока нет, продолжаем
                mov     (SP)+, R4
                return
; End of function AddAsc


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; проверка на взаимодействие ГГ с ножом

CheckKnifeCatch:tstb    GGHaveEquip     ; в руках что-то есть?
                bne     DecrLive        ; да - умер
                decb    GGHaveEquip     ; нет - теперь будет нож


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; подбор ножа

CatchKnife:     movb    #200, ThrowKnife ; нож подобран, в руках
                clr     KnifeAddr       ; никуда не летит
                return
; End of function CatchKnife
; End of function CheckKnifeCatch


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Уменьшение количества жизней

DecrLive:       jmp     Vec4.1$ nop     ; ### чтобы жизни не уменьшались
                ;mov     #ROMCmdRti, @#4 ; Указатель на команду RTI, т.е. игнорирование СТОП
                mov     #ValRest, R1
                mov     #-1, R2
                call    IncAsc          ; +-1 к двузначному числу
                                        ; Вход: R2 - аргумент >=0 : +1, <0 : -1
                                        ;       R1 - адрес, где находится число
                                        ; Выход: R1 = R1 - 1
                                        ; не портит регистров
                tst     (R1)
                beq     GameOver
                br      Vec4.1$
; End of function DecrLive


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; +-1 к двузначному числу
; Вход: R2 - аргумент >=0 : +1, <0 : -1
;       R1 - адрес, где находится число
; Выход: R1 = R1 - 1
; не портит регистров

IncAsc:         tst     R2              ; что делаем?
                bge     2$              ; плюсуем
                                        ; минусуем
                decb    1(R1)           ; уменьшим единицы
                bge     1$              ; если >=0 то пока норма
                decb    (R1)            ; иначе уменьшим десятки (а почему нет проверки?)
                movb    #9., 1(R1)      ; а в единицах станет 9

1$:             return
; ───────────────────────────────────────────────────────────────────────────

2$:             cmp     (PC)+, (R1)     ; 99. - максимум достигнут?
                .byte   9.,9.
                beq     1$              ; да - ничего не делаем
                inc     R1
                incb    (R1)            ; увеличиваем единицы
                cmpb    (R1), #10.      ; до 10 дошли?
                bne     1$              ; нет ещё
                clrb    (R1)            ; да - значит перенос в десятки
                incb    -(R1)

NoCoProgrGmeOvr:return
; End of function IncAsc

; ───────────────────────────────────────────────────────────────────────────
StrStage:       .byte 34, 35, 12, 20, 16, 46 ; "STAGE "
ValStage:       .byte 0, 1
StrGameOver:    .byte 20, 12, 26, 16, 46, 46, 30, 37, 16, 33 ; "GAME  OVER"
                .even

; ███████████████ S U B R O U T I N E ███████████████████████████████████████


GameOver:       mov     #20, @#177712
                mov     #RequestExit, @#4
                mov     #NoCoProgrGmeOvr, R5
                call    DrawGameName    ; очистка экрана и вывод названия игры и имя автора
                mov     #StrGameOver, R0
                mov     #12, R1
                mov     #ReqExitScr+26, R2
                call    PutStr          ; Вывод строки
                                        ; Вход: R0 - адрес строки
                                        ;       R1 - длина строки
                                        ;       R2 - адрес экрана
                                        ;       R5 - адрес сопрограммы (типично - фоновый звук)
                                        ; Выход: R0 += R1 указывает за конец строки
                mov     #StrScore, R0
                mov     #14, R1
                mov     #61424, R2
                call    PutStr          ; Вывод строки
                                        ; Вход: R0 - адрес строки
                                        ;       R1 - длина строки
                                        ;       R2 - адрес экрана
                                        ;       R5 - адрес сопрограммы (типично - фоновый звук)
                                        ; Выход: R0 += R1 указывает за конец строки
                mov     #2, R4

1$:             mov     #10, R0
                call    PlaySounds      ; Вход: R0 - индекс адреса звука. 0..012
                sob     R4, 1$
                mov     #12, R0
                call    PlaySounds      ; Вход: R0 - индекс адреса звука. 0..012

2$:             tstb    @#177660
                bpl     2$
                bit     #100, @#177716
                bne     2$
; End of function GameOver


; ███████████████ S U B R O U T I N E ███████████████████████████████████████


GameMenu:       ; полная начальная инициализация, сброс очков счёта
                mov     #100, @#177660
                mov     #SpriteParam, R0 ; очистка всех переменных и буферов по адр.40-1000
                mov     #TopStack - SpriteParam, R1

1$:             clrb    (R0)+
                sob     R1, 1$
                clrb    @#DopplerEffect
                mov     #400, ValStage  ; инициализируем начальный этап
                mov     #1400, ValRest  ; инициализируем начальное количество жизней
                mov     #ValScore, R2   ; инициализируем текущий счёт
                clr     (R2)+
                clr     (R2)+
                clr     (R2)+
                ; инициализация, начать с начала.
GameMenu2:      mov     #400, ValPyramid ; инициализируем начальный номер пирамиды
                mov     #1, CurrPyramid ; Номер текущей пирамиды, отсчёт с 1
                clr     AccomplishPyramid
                add     #300, HuntFoVVert   ; повышаем область чувствительности охотников
                add     #5, HuntFoVHorz

Vec4.1$:        mov     #TopStack, SP   ; инициализация стека
                mov     #Vec4.1$, @#4
                mov     #SpriteParam, R0 ; Очистка всех переменных и буферов. по адр 40-667
                mov     #MoveToBack - SpriteParam, R1

1$:             clrb    (R0)+
                sob     R1, 1$
                mov     #ValScore, R2   ; копируем тек.счёт в макс.счёт.
                mov     #6, R1

2$:             movb    (R2)+, ValHiScore-ValScore-1(R2)
                sob     R1, 2$
                movb    #1, DirMove     ; флаг направления движения для ГГ/охотника, 0 - вправо, !0 - влево
                movb    #377, TrHBlinkingFlg ; флаг мигания ореола сокровища
                movb    #200, ThrowKnife ; нож не летит
                mov     #NoCoProgrGme, R5 ; музыки пока нет
                clrb    BreakMus        ; зацикливание отменим
                ; показываем, в какой сейчас пирамиде
                call    SelectPyramid   ; Подсветка текущего этапа
                mov     #DecrLive, @#4  ; Уменьшение количества жизней при нажатии на СТОП
                ; прорисовка комнаты
                call    DrawLabyrint    ; Формирование и вывод на экран лабиринта
                movb    #10, HuntTHCnt + 2 ; счётчик верчения головой охотника 1
                movb    #31, HuntTHCnt + 4 ; счётчик верчения головой охотника 2
                movb    #10, HuntTHCnt + 6 ; счётчик верчения головой охотника 3
                mov     ThreasuresNum, R0 ; берём количество сокровищ в лабиринте
                beq     4$              ; 0 - нету
                mov     #CurrScoreBuf, R2 ; Формируем число 100 в буфере
                clr     (R2)+
                mov     #1, (R2)+
                clr     (R2)+

3$:             mov     #ValHiScore+5, R1
                call    AddAsc          ; добавление очков к счёту
                                        ; Вход: R1 - адрес буфера числа, указатель на мл. разряд
                sob     R0, 3$          ; генерируем макс счёт - кол-во сокровищ * 100.
                ; вывод текста на экран
4$:             mov     #StrScore, R0
                mov     #40, R1
                mov     #40000, R2
                call    PutStr          ; Вывод строки
                                        ; Вход: R0 - адрес строки
                                        ;       R1 - длина строки
                                        ;       R2 - адрес экрана
                                        ;       R5 - адрес сопрограммы (типично - фоновый звук)
                                        ; Выход: R0 += R1 указывает за конец строки
                mov     #12, R1
                mov     #GameNameScr2, R2
                call    PutStr          ; Вывод строки
                                        ; Вход: R0 - адрес строки
                                        ;       R1 - длина строки
                                        ;       R2 - адрес экрана
                                        ;       R5 - адрес сопрограммы (типично - фоновый звук)
                                        ; Выход: R0 += R1 указывает за конец строки
                ; анимация открытия входа в комнату
                clr     R4              ; входная дверь
                tstb    MoveToBack      ; куда движемся?
                beq     5$              ; вперёд
                tst     (R4)+           ; обратно - значит выходная дверь

5$:             clrb    MoveToBack      ; сбрасываем флаг
                mov     DoorAddress(R4), R2 ; адрес входа в буфере лабиринта
                call    DrawGrWall      ; рисуем зелёную стену, где открывается дверь входа
                                        ; Вход: R2 - адрес в буфере лабиринта
                clr     R0              ; звук открытия двери 1 часть
                call    PlaySounds      ; Вход: R0 - индекс адреса звука. 0..012
                call    AnimDoorOpen    ; Анимация открывающегося прохода в стене
                mov     #2, R0          ; звук открытия двери 2 часть
                call    PlaySounds      ; Вход: R0 - индекс адреса звука. 0..012
                ; анимация входа ГГ через открытый проход
                mov     #40377, OffsetX ; X <- -1, Y <- 100
                movb    @#177662, R0    ; последняя нажатая клавиша
                call    AnimGGGoIn      ; Анимация спуска человечка из прохода в пирамиду
                clr     OffsetX         ; X <- 0, Y <- 0
                mov     DoorAddress(R4), R2
                call    AnimDoorClose   ; Анимация закрытия прохода
                ; прорисовка ГГ в стартовой точке
                clr     R3
                call    DrawNPC         ; прорисовка ГГ/охотника
                                        ; Вход: R3 - индекс: 0 - ГГ; 2,4,6 - охотник1,2,3
                mov     #4, R0          ; звук закрытия двери 1 часть
                call    PlaySounds      ; Вход: R0 - индекс адреса звука. 0..012

                cmp     CurrPyramid, AccomplishPyramid ; мы зашли в новую пирамиду?
                bgt     6$              ; да
                decb    DrawEntryFlag   ; нет - вернулись в прошлую, отметим, что можно рисовать двери
                call    DrawInOutDoor   ; рисуем дверь прохода в следующую
                                        ; Прорисовка входа/выхода с ключиком
                                        ; Вход: R4 - индекс: 0 - вход, 2 - выход
                sub     #2, R4          ; рисуем дверь прохода в предыдущую
                neg     R4              ; или наоборот.
                call    DrawInOutDoor   ; Прорисовка входа/выхода с ключиком
                                        ; Вход: R4 - индекс: 0 - вход, 2 - выход
                br      7$
; ───────────────────────────────────────────────────────────────────────────
                ; зашли в пирамиду, в которой не были
6$:             mov     DoorAddress(R4), R2
                call    AnimGrWallOff   ; Анимация исчезновения зелёной стены
                                        ; (человечек тоже стирается)

7$:             clr     R3
                call    StoreScrNPC     ; сохранение экрана под ГГ/охотником
                                        ; Вход: R3 - индекс: 0 - ГГ; 2,4,6 - охотник1,2,3
                clr     R3
                call    DrawNPC         ; прорисовка ГГ/охотника
                                        ; Вход: R3 - индекс: 0 - ГГ; 2,4,6 - охотник1,2,3
                mov     #6, R0          ; звук закрытия двери 2 часть
                call    PlaySounds      ; Вход: R0 - индекс адреса звука. 0..012
                call    StartPlayMelody1 ; запускаем фоновую музыку
                clrb    @#DopplerEffect
                clr     R4
; игровой цикл
GameCycle:
; ====== определение, надо ли менять комнату ================================
                clrb    word_556
                clrb    ChangeRoomFlg
                mov     GGCoord, R0     ; координата ГГ в буфере лабиринта
                bic     #177700, R0     ; только горизонтальная часть
                call    (R5)
                tstb    OffsetX         ; куда по горизонтали движемся?
                beq     11$             ; стоим на месте
                blt     9$
                ; вправо
                dec     R0              ; нужно сравнивать с #40, уменьшим на 1 и можно теперь тоже сравнивать с #37
                ; влево
9$:             cmp     #37, R0         ; такая?
                bne     11$             ; нет, пока всё в норме
                ; нужно менять комнату
10$:            incb    ChangeRoomFlg   ; установим флаг, что нужно менять комнату
11$:            call    (R5)
; ===========================================================================
                call    sub_10662       ; перерисовка лабиринта при выходе за экран
                                        ; стираем человечков, потом рисуем, потом снова стираем
                                        ; Выход: R0 - номер текущей анимации
                                        ;        Z=1 - нет прохода через одностороннюю дверь
                                        ;        Z=0 - есть
                bne     18$             ; есть проход.
; ───────────────────────────────────────────────────────────────────────────
                ; нет прохода - обрабатываем анимации
12$:            sub     #3, R0          ; номер анимации
                blt     18$             ; 0,1,2 - пропускаем
                call    (R5)
                asl     R0
                add     R0, PC
                br      13$             ; анимация 3
                br      18$             ; анимация 4 пропускаем
                br      15$             ; анимация 5
                br      16$             ; анимация 6
                br      18$             ; анимация 7 пропускаем
; ───────────────────────────────────────────────────────────────────────────
                ; анимация 3 - подпрыгнуть на месте чтоб взять ключ или кирку
13$:            mov     GGCoord, R1
                sub     #100, R1        ; подбор ключа или кирки
                call    (R5)
                cmpb    (R1), #TS$Hack  ; кирка?
                beq     14$
                cmpb    (R1), #TS$Key   ; ключ?
                bne     18$

14$:            clrb    (R1)            ; взяли, сотрём на карте
                ; сотрём предмет с того места, где он был на экране
                call    DrawTileRoomAdr ; вывод на экран элемента комнаты
                                        ; Вход: R1 - адрес элемента в буфере комнаты
                br      17$
; ───────────────────────────────────────────────────────────────────────────
                ; анимация 5 - стучание киркой вбок
                ; просто стирание куска стены
15$:            call    ClrWallHackSide ; стирание куска стены при стучании киркой вбок
                br      17$
; ───────────────────────────────────────────────────────────────────────────
                ; анимация 6 - стучание киркой вниз
                ; просто стирание куска стены
16$:            call    ClrWallHackDown ; стирание куска стены при стучании киркой вниз
18$:            call    (R5)
17$:            call    DrawHumanoids   ; Прорисовка ГГ и охотников
                                        ; Обработка попадания ножа в кого-нибудь, и воспроизведение звука
                                        ; Вход: R4 - индекс звука
;======= цикл 1 =============================================================
 ; это обработка состояния свободного падения
                mov     #10, R3         ; индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
19$:            tst     -(R3)           ; изменяем индекс
                call    (R5)
                mov     Coordinate(R3), R1  ; координата охотника или ГГ
                beq     19$             ; 0 - его нету, переход к следующему
                                        ; если ни одного охотника нету, то ГГ всегда есть
                cmpb    AnimType(R3), #4 ; персонаж в свободном падении?
                bne     20$             ; нет - пропускаем
                cmp     #RoomFooter, R1 ; самый низ?
                blt     20$             ; да - пропускаем
                movb    200(R1), R0     ; что там ниже?
                call    (R5)
                cmpb    #TS$Wall, R0    ; стена?
                beq     20$             ; да - пропускаем
                cmpb    #TS$BreachLeft, R0 ; односторонняя дверь?
                ble     20$             ; да - пропускаем
                call    (R5)
                call    IsLadderHere    ; проверка на лестницу по текущим координатам
                                        ; Вход: R3 - индекс
                                        ; Выход: Z - лестница
                beq     20$             ; да - пропускаем
                movb    #2, AnimStage(R3) ; начало отработки анимации. Конец падения.
                add     #100, Coordinate(R3) ; на строку вниз

20$:            tst     R3              ; и так всех персонажей
                bne     19$
;======= обработка после цикла 1 ============================================
                call    sub_10662       ; перерисовка лабиринта при выходе за экран
                                        ; стираем человечков, потом рисуем, потом снова стираем
                                        ; Выход: R0 - номер текущей анимации
                                        ;        Z=1 - нет прохода через одностороннюю дверь
                                        ;        Z=0 - есть
                bne     30$             ; есть проход.
; ───────────────────────────────────────────────────────────────────────────
                ; нет прохода - обрабатываем анимации
21$:            call    (R5)
                sub     #3, R0          ; номер анимации
                blt     31$             ; 0,1,2 - пропускаем
                asl     R0
                add     R0, PC
                br      30$             ; анимация 3 -> анимация 0
                br      31$             ; анимация 4 пропускаем
                br      23$             ; анимация 5
                br      25$             ; анимация 6
                ; анимация 7 - определение в какую сторону бросили нож, куда ему лететь
                ; начало полёта ножа
                mov     GGCoord, R1     ; адрес ГГ, с него начнётся полёт ножа
                mov     #1, R2          ; направление движения
                tstb    DirMove         ; флаг направления движения для ГГ/охотника, 0 - вправо, !0 - влево
                beq     22$
                neg     R2              ; влево

22$:            clrb    ThrowKnife      ; нож остановился
                call    (R5)
                movb    R2, OffsXFlyKnife ; сохраним приращение координаты
                add     R2, R1          ; начальный адрес, чтоб не с самого ГГ было, а чуть в стороне
                mov     R1, KnifeAddr   ; адрес летящего ножа в буфере лабиринта
                call    (R5)
                br      29$             ; идём туда
; ───────────────────────────────────────────────────────────────────────────
                ; анимация 5 - долбить киркой вбок
                ; продолжение стирания стены и изменения на карте
23$:            call    ClrWallHackSide ; стирание куска стены при стучании киркой вбок
                tstb    AnimStage       ; номер этапа в анимации
                bne     31$
                mov     GGCoord, R1
                call    (R5)
                call    NextCoord       ; вычисление следующей горизонтальной координаты, в зависимости от направления движения
                                        ; Вход: R1 - текущий адрес в буфере лабиринта
                                        ;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
                                        ; Выход: R1 - следующий адрес
                cmpb    (R1), #TS$Wall  ; там стена?
                bne     24$             ; нет
                clrb    (R1)            ; да - теперь пусто

24$:            add     #100, R1
                cmpb    (R1), #TS$Wall  ; а там стена?
                bne     30$             ; нет
                clrb    (R1)            ; да - и там теперь пусто
                br      30$
; ───────────────────────────────────────────────────────────────────────────
                ; анимация 6 - долбить киркой вниз
                ; продолжение стирания стены и изменения на карте
25$:            call    (R5)
                call    ClrWallHackDown ; стирание куска стены при стучании киркой вниз
                mov     GGCoord, R1
                tstb    AnimStage       ; номер этапа в анимации
                beq     27$
                cmp     #RoomFooter - 100, R1
                blt     26$
                cmpb    300(R1), #TS$Wall
                beq     31$

26$:            clrb    AnimStage       ; номер этапа в анимации
                br      28$
; ───────────────────────────────────────────────────────────────────────────

27$:            clrb    300(R1)
28$:            clrb    200(R1)
                call    (R5)
                comb    GGFlag          ; флаг - висеть и не падать в только что пробитую дыру киркой вниз.
                mov     GGCoord, StartCoord ; а это - чтобы сбросить этот флаг при любом движении.

29$:            clrb    GGHaveEquip     ; экипировку (кирку или нож) использовали, в руках пусто
30$:            clrb    AnimType        ; теперь анимация - ходьба
;======= цикл 2 =============================================================
; обработка анимации прыжков, и отлов конца падения
31$:            mov     #10, R3         ; R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
32$:            tst     -(R3)           ; изменяем индекс
                call    (R5)
                mov     Coordinate(R3), R1 ; координата охотника или ГГ
                beq     32$             ; 0 - его нету, переход к следующему
                                        ; если ни одного охотника нету, то ГГ всегда есть
                movb    AnimStage(R3), R2 ; текущий этап в анимации
                movb    AnimType(R3), R0 ; какая анимация?
                beq     39$             ; 0 - ходьба пропускаем
                cmpb    #5, R0          ; 5,6,7 ?
                ble     39$             ; пропускаем
                call    (R5)
                cmpb    #2, R0
                blt     36$
                beq     34$
; ───────────────────────────────────────────────────────────────────────────
                ; 1 - малый прыжок
                cmpb    #4, R2          ; достигли середины анимации?
                bne     35$             ; нет
                ; да - начинаем приземление
33$:            call    (R5)
                negb    OffsetY(R3)
                br      39$
; ───────────────────────────────────────────────────────────────────────────
                ; 2 - большой прыжок
34$:            cmpb    #10, R2         ; достигли середины анимации?
                beq     33$             ; да - начинаем приземление

35$:            tstb    R2              ; прыжок закончился?
                bne     39$             ; нет ещё
                clrb    OffsetY(R3)     ; да - всё, конец движения по вертикали
                br      38$
; ───────────────────────────────────────────────────────────────────────────
                ; 3,4 - отлов окончания падения
36$:            cmp     #RoomFooter, R1 ; до низу долетели?
                blt     37$             ; да
                movb    200(R1), R0     ; под ногами что?
                cmpb    #TS$Wall, R0    ; стена?
                beq     37$             ; да
                cmpb    #TS$BreachLeft, R0 ; проход?
                ble     37$             ; да
                call    (R5)
                call    IsLadderHere    ; проверка на лестницу по текущим координатам
                                        ; Вход: R3 - индекс
                                        ; Выход: Z - лестница
                bne     39$             ; не лестница - пропускаем

37$:            clr     OffsetX(R3)     ; стоп, закончили падать, и прекратим движение
38$:            clrb    AnimType(R3)    ; закончили анимацию, теперь ходьба

39$:            call    (R5)
                tst     R3
                bne     32$
;======= обработка после цикла 2 ============================================
                mov     GGCoord, R2
                call    PickLUT         ; Проверка и подбор лута
                                        ; Вход: R2 - координаты ГГ
                add     #100, R2
                call    PickLUT         ; Проверка и подбор лута
                                        ; Вход: R2 - координаты ГГ
                mov     R4, -(SP)
; ───────────────────────────────────────────────────────────────────────────
; теперь, если ключик подобран, то надо проиграть анимацию открытия двери
; убрать отсюда - не прокатывает, получается косяк анимации.
40$:            tstb    CatchKeyFlg     ; ключик подобран?
                beq     47$             ; нет
                blt     42$             ; да, но больше не нужно
                comb    CatchKeyFlg     ; отметим, что уже обработали
                mov     #2, R4
                mov     ExitDoor, R0    ; мы около выходной двери?
                sub     GGCoord, R0
                bic     #177700, R0
                sub     #4, R0
                ble     41$             ; да
                clr     R4              ; нет - около входной

41$:            comb    ClosedDoor(R4)  ; отметим, что дверь открыта
                call    AnimDoorOpen    ; Анимация открывающегося прохода в стене
                br      47$
; ───────────────────────────────────────────────────────────────────────────
; теперь проверка - вошли ли в дверь
42$:            cmp     GGCoord, ExitDoor ; ГГ в выходной двери?
                beq     43$             ; да
                cmp     GGCoord, EntryDoor ; ГГ во входной двери
                bne     47$             ; нет - продолжаем
                clr     R4              ; индекс входной двери
                br      44$
; ───────────────────────────────────────────────────────────────────────────

43$:            mov     #2, R4          ; индекс выходной двери.
; анимация выхода из пирамиды и закрытия прохода
44$:            tstb    ClosedDoor(R4)  ; дверь закрыта?
                beq     47$             ; да - пропустить
                mov     #NoCoProgrGme, R5 ; выключаем музыку
                clrb    DirMove         ; флаг направления движения для ГГ, 0 - вправо, !0 - влево
                mov     #140001, OffsetX    ; X <- 1, Y <- -100
                call    AnimGGGoIn      ; Анимация спуска человечка из прохода в пирамиду
                mov     DoorAddress(R4), R2
                call    AnimDoorClose   ; Анимация закрытия прохода
                clr     R0
                call    PlaySounds      ; Вход: R0 - индекс адреса звука. 0..012
                mov     DoorAddress(R4), R2
                call    AnimGrWallOff   ; Анимация исчезновения зелёной стены
                                        ; (человечек тоже стирается)
                mov     #2, R0
                call    PlaySounds      ; Вход: R0 - индекс адреса звука. 0..012
                clr     R0
                sob     R0, .

                mov     #1, R2
                tst     R4
                bne     45$
                comb    MoveToBack      ; да - отметим, что движемся назад.
                neg     R2

45$:            add     R2, CurrPyramid ; Номер текущей пирамиды, отсчёт с 1
                cmp     CurrPyramid, #16. ; вышли из последней?
                bne     46$             ; нет, продолжаем
                mov     #1, R2          ; да - начинаем сначала, с более жёсткими условиями
                mov     #ValStage, R1
                call    IncAsc          ; +-1 к двузначному числу
                                        ; Вход: R2 - аргумент >=0 : +1, <0 : -1
                                        ;       R1 - адрес, где находится число
                                        ; Выход: R1 = R1 - 1
                                        ; не портит регистров
                jmp     GameMenu2
; ───────────────────────────────────────────────────────────────────────────
; изменяем номер пирамиды, которую проходим
46$:            mov     #ValPyramid, R1
                call    IncAsc          ; +-1 к двузначному числу
                                        ; Вход: R2 - аргумент >=0 : +1, <0 : -1
                                        ;       R1 - адрес, где находится число
                                        ; Выход: R1 = R1 - 1
                                        ; не портит регистров
                jmp     Vec4.1$
;============================================================================
                ; обработка зарастающих стен
47$:            dec     HuntTurnHead    ; уменьшаем счётчик
                bgt     53$             ; время ещё не пришло
                beq     48$             ; пришло
                inc     HuntTurnHead    ; не даём стать отрицательным.

48$:            mov     GrownWallsPtr, R0
                mov     (R0)+, R4
                beq     53$

49$:            mov     (R0)+, R1
                cmpb    (R1), #TS$Wall  ; там уже стена?
                beq     52$             ; да - пропускаем
                cmpb    100(R1), #TS$Wall ; там уже стена?
                beq     50$             ; значит надо стену выше
                add     #100, R1

50$:            mov     #10, R3         ; R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3

51$:            call    (R5)
                tst     -(R3)
                mov     Coordinate(R3), R2
                add     #100, R2
                cmp     R1, R2          ; если кто-то стоит на месте зарастающей стены
                beq     52$             ; то её пока не рисовать
                tst     R3
                bne     51$
                mov     R0, -(SP)
                movb    #TS$Wall, (R1)
                call    DrawTileVisible ; Вывод на экран элемента комнаты, если он видимый.
                                        ; Это для перерисовки.
                                        ; Вход: R1 - адрес в буфере
                mov     (SP)+, R0

52$:            call    (R5)
                sob     R4, 49$

53$:            mov     (SP)+, R4
;============================================================================
                call    DrawHumanoids   ; Прорисовка ГГ и охотников
                                        ; Обработка попадания ножа в кого-нибудь, и воспроизведение звука
                                        ; Вход: R4 - индекс звука
                call    (R5)
; ───────────────────────────────────────────────────────────────────────────
; проверка, поймал ли охотник ГГ, этот код нельзя перенести отсюда в другое место
; т.к. начинаются какие-то наведённые глюки - почему-то количество сокровищ не восстанавливается, а продолжается
; с того, на котором умерли. Хотя, так честнее, но там визуально хуже получается
; или визуально получается слишком большое расстояние между ГГ и охотником
                tstb    GGCatched       ; флаг, охотник поймал человечка
                br      54$             ; ### неуязвимость для ГГ
                ;beq     54$
                jmp     DecrLive        ; Уменьшение количества жизней
54$:
;======= цикл 3 =============================================================
; обработка клавиатуры и управление анимациями.
55$:            mov     #10, R3         ; R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
56$:            tst     -(R3)
                call    (R5)
                tst     R3              ; кто?
                beq     58$             ; ГГ - управлять им вручную
                                        ; охотниками управлять компьютером
                tst     Coordinate(R3)  ; текущая координата охотника
                bne     57$             ; если есть, то нормально, если нету
                tst     StartCoord(R3)  ; проверим, есть ли он вообще
                beq     56$             ; нету - перейдём к следующему

57$:            call    EmulateHunt     ; Выполнение движения охотников.
                                        ; Вход: R3 - индекс: 2,4,6 - охотник1,2,3. Индекс не может быть 0
                br      59$
; ───────────────────────────────────────────────────────────────────────────

58$:            call    KeyboardWrk     ; Обработка нажатий клавиатуры

59$:            call    sub_7452        ; проверка на препятствия
                                        ; Вход: R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
                call    (R5)
                cmpb    AnimType(R3), #3
                beq     60$
                movb    OffsetX(R3), R0 ; если анимация не 3, то перемещаем персонаж
                add     R0, Coordinate(R3)
                movb    OffsetY(R3), R0
                add     R0, Coordinate(R3)
                ;!!! вот здесь повторная проверка попадания ножа в охотника
                ; если её убрать, не всегда будет срабатывать попадание ножом в охотника
60$:            tst     R3
                beq     62$
                mov     Coordinate(R3), R1
                call    (R5)
                cmp     KnifeAddr, R1   ; адрес летящего ножа в буфере лабиринта
                beq     61$
                add     #100, R1
                cmp     KnifeAddr, R1   ; адрес летящего ножа в буфере лабиринта
                bne     62$

61$:            call    (R5)
                call    CheckHunterHit  ; проверка, попали ножом в охотника и он исчезает или нет.
                                        ; если в процессе зарождения - то нет
                                        ; Вход: R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3

62$:            call    (R5)
                mov     Coordinate(R3), R1  ; координата охотника
                mov     R1, R2
                add     #100, R2        ; + ниже
                call    (R5)
                tst     R3              ; Это ГГ?
                beq     63$             ; тогда пойдём туда
                ; проверка на столкновение текущего охотника с ГГ
                mov     GGCoord, R0     ; координата ГГ
                call    IsCatching      ; проверка, кто кого поймал
                                        ; Вход: R0 - кого
                                        ;       R1, R2 - кто
                                        ;       R3 - индекс: 2,4,6 - охотник1,2,3, 0 - ГГ быть не может
                                        ; Выход: установка флага GGCatched - да, поймал.
                br      66$
; ───────────────────────────────────────────────────────────────────────────
                ; тут в R1 R2 - координаты ГГ
                ; проверяем на столкновение ГГ со всеми охотниками последовательно.
                ; если это убрать - не всегда будет срабатывать пойматие охотником ГГ.
                ; вот как так?
63$:            mov     R3, -(SP)
                mov     #10, R3         ; R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3

64$:            tst     -(R3)
                call    (R5)
                tst     R3
                beq     65$
                mov     Coordinate(R3), R0 ; координата охотника
                beq     64$
                call    IsCatching      ; проверка, кто кого поймал
                                        ; Вход: R0 - кого
                                        ;       R1, R2 - кто
                                        ;       R3 - индекс: 2,4,6 - охотник1,2,3, 0 - ГГ быть не может
                                        ; Выход: установка флага GGCatched - да, поймал.
                br      64$

65$:            mov     (SP)+, R3
; ───────────────────────────────────────────────────────────────────────────

66$:            call    (R5)
; Вот эту штуку можно переместить в sub_11016, но при этом при падениях человечки
; начинают подпрыгивать, и анимации рождения охотников ускоряются в два раза.
; причина - в том что этот код начинает вызываться в два раза чаще.
; т.к. sub_11016 вызывается дважды за игровой цикл, а тут - единожды
                tstb    AnimStage(R3)   ; анимации не кончились?
                bne     68$             ; нет - переход
                tst     R3              ; кто?
                beq     67$             ; ГГ
                tstb    HuntState(R3)   ; охотник, а его состояние?
                bge     67$             ; активен
                ; ждём рождения охотника
                incb    HuntState(R3)
                cmpb    HuntState(R3), #-5
                bne     56$
                mov     #12, R4         ; звук рождения охотника
                movb    #20, @#DopplerEffect
                br      56$
; ───────────────────────────────────────────────────────────────────────────
                ; задаём новый цикл анимаций
67$:            call    (R5)
                tst     OffsetX(R3)     ; горизонтальное движение есть?
                beq     68$             ; нету
                movb    #4, AnimStage(R3) ; есть - инициализируем
                cmpb    AnimType(R3), #4
                bne     68$
                asrb    AnimStage(R3)

68$:            call    (R5)
                tst     R3
                bne     56$
;======= конец цикла 3 ======================================================
                call    (R5)
                jmp     GameCycle       ; и всё сначала
; End of function GameMenu


; ███████████████ S U B R O U T I N E ███████████████████████████████████████


RequestExit:    mov     #GameMenu, @#4
                mov     #20, @#177712
                call    DrawGameName    ; очистка экрана и вывод названия игры и имя автора
                mov     #StrExitYN, R0
                mov     #12, R1
                mov     #ReqExitScr+26, R2
                call    PutStr          ; Вывод строки
                                        ; Вход: R0 - адрес строки
                                        ;       R1 - длина строки
                                        ;       R2 - адрес экрана
                                        ;       R5 - адрес сопрограммы (типично - фоновый звук)
                                        ; Выход: R0 += R1 указывает за конец строки
                add     #374, R2        ; тут как бы запятую делаем
                mov     #45, R3         ; "'" (апостроф)
                call    PutChr          ; Вывод символа
                                        ; Вход: R2 - адрес вывода
                                        ;       R3 - код символа
                                        ;       R5 - адрес сопрограммы (типично - фоновый звук)

1$:             tstb    @#177660
                bpl     1$
                bit     #100, @#177716
                bne     1$
                mov     @#177662, R0
                bic     #240, R0
                cmp     #'Y, R0
                beq     ExitGame
                jmp     GameMenu
; ───────────────────────────────────────────────────────────────────────────

ExitGame:       mov     #ROMCmdRti, @#4
                mov     #MoveBgn, R0
                mov     #/MoveEnd-/MoveBgn, R1
                mov     #40, R2

2$:             mov     (R0)+, (R2)+
                sob     R1, 2$
                jmp     @#ROMEXitMon

; ───────────────────────────────────────────────────────────────────────────
; код, который стирает всю игру в памяти. Но не используется.
MoveBgn:        mov     #60, R0
                mov     #17750, R1

3$:             clr     (R0)+
                sob     R1, 3$
                jmp     @#ROMEXitMon
MoveEnd:
; End of function RequestExit
; ───────────────────────────────────────────────────────────────────────────
StrExitYN:      .byte 16, 41, 22, 35, 46, 43, 46, 42, 46, 27 ; "EXIT ? Y N"
                .even

; ███████████████ S U B R O U T I N E ███████████████████████████████████████


OutCopyRight:   clr     CharColorMask   ; маска цвета символов
                mov     #47, R3
                mov     #40000, R2
                call    PutChr          ; Вывод символа
                                        ; Вход: R2 - адрес вывода
                                        ;       R3 - код символа
                                        ;       R5 - адрес сопрограммы (типично - фоновый звук)
                return
; End of function OutCopyRight


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; очистка экрана и вывод названия игры и имя автора

DrawGameName:   call    ClrScr
                call    OutCopyRight
                mov     #Kings, R0
                mov     #6, R1
                mov     #GameNameScr1, R2
                call    PutStr          ; Вывод строки
                                        ; Вход: R0 - адрес строки
                                        ;       R1 - длина строки
                                        ;       R2 - адрес экрана
                                        ;       R5 - адрес сопрограммы (типично - фоновый звук)
                                        ; Выход: R0 += R1 указывает за конец строки
                mov     #6, R1
                mov     #GameNameScr2, R2
                call    PutStr          ; Вывод строки
                                        ; Вход: R0 - адрес строки
                                        ;       R1 - длина строки
                                        ;       R2 - адрес экрана
                                        ;       R5 - адрес сопрограммы (типично - фоновый звук)
                                        ; Выход: R0 += R1 указывает за конец строки
                add     #6, R0
                mov     #8., R1
                mov     #GameNameScr1+60, R2
                call    PutStr          ; Вывод строки
                                        ; Вход: R0 - адрес строки
                                        ;       R1 - длина строки
                                        ;       R2 - адрес экрана
                                        ;       R5 - адрес сопрограммы (типично - фоновый звук)
                                        ; Выход: R0 += R1 указывает за конец строки
                mov     #8., R1
                mov     #GameNameScr2+60, R2
                call    PutStr          ; Вывод строки
                                        ; Вход: R0 - адрес строки
                                        ;       R1 - длина строки
                                        ;       R2 - адрес экрана
                                        ;       R5 - адрес сопрограммы (типично - фоновый звук)
                                        ; Выход: R0 += R1 указывает за конец строки
                return
; End of function DrawGameName


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Вход: R4 - номер звука:
; 0
; 2
; 4
; 6
; 10
; 12
; 14

PlaySound:      mov     R0, -(SP)
                mov     R1, -(SP)
                mov     R2, -(SP)
                mov     R3, -(SP)
                add     R4, PC
                br      0Sound0$
                br      0Sound1$
                br      0Sound2$
                br      0Sound3$
                br      0Sound4$
                br      0Sound5$
0Sound6$:       mov     #10, R1
                mov     #4, R0

1$:             call    PlayTone        ; Что-то связанное со звуком.
                                        ; Вроде как Тон частотой в R1 и длительностью в R0
                inc     R1
                cmp     #14, R1
                bne     1$
                br      6$
; ───────────────────────────────────────────────────────────────────────────

0Sound0$:       mov     #2000, R0

2$:             call    (R5)
                sob     R0, 2$
                br      7$
; ───────────────────────────────────────────────────────────────────────────

0Sound1$:       mov     #1, R1
                mov     #6, R0

3$:             call    PlayTone        ; Что-то связанное со звуком.
                                        ; Вроде как Тон частотой в R1 и длительностью в R0
                inc     R1
                cmp     #10, R1
                bne     3$
                br      6$
; ───────────────────────────────────────────────────────────────────────────

0Sound2$:       mov     #300, R1
                mov     #1, R0

4$:             call    PlayTone        ; Что-то связанное со звуком.
                                        ; Вроде как Тон частотой в R1 и длительностью в R0
                inc     R1
                cmp     #320, R1
                bne     4$
                br      6$
; ───────────────────────────────────────────────────────────────────────────

0Sound3$:       mov     #30, R1
                mov     #3, R0

5$:             call    PlayTone        ; Что-то связанное со звуком.
                                        ; Вроде как Тон частотой в R1 и длительностью в R0
                inc     R1
                cmp     #60, R1
                bne     5$

6$:             clr     R4
                br      7$
; ───────────────────────────────────────────────────────────────────────────

0Sound4$:       movb    @#DopplerEffect, R1
                mov     #40, R0
                asr     R1
                call    PlayTone        ; Что-то связанное со звуком.
                                        ; Вроде как Тон частотой в R1 и длительностью в R0
                decb    @#DopplerEffect

7$:             mov     (SP)+, R3
                mov     (SP)+, R2
                mov     (SP)+, R1
                mov     (SP)+, R0
                return
; ───────────────────────────────────────────────────────────────────────────

0Sound5$:       decb    @#DopplerEffect
                movb    @#DopplerEffect, R3
                bne     8$
                clr     R4

8$:             bic     #10, R3
                cmp     #3, R3
                asl     R3
                mov     SndTones(R3), R1
                beq     0Sound0$
                mov     #1, R0
                mov     #10, R3

9$:             call    PlayTone        ; Что-то связанное со звуком.
                                        ; Вроде как Тон частотой в R1 и длительностью в R0
                sub     #14, R1
                sob     R3, 9$
                br      7$
; End of function PlaySound

; ───────────────────────────────────────────────────────────────────────────
; задержки частоты
SndTones:       .word 440
                .word 300
                .word 150
                .word 0
                .word 300
                .word 440
                .word 600
                .word 0

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Что-то связанное со звуком.
; Вроде как Тон частотой в R1 и длительностью в R0

PlayTone:       mov     R0, -(SP)
                add     #BgrMusOffs1-BgrMusPlay, R5

1$:             call    BgrMusOffs2-BgrMusPlay(R5)
                mov     R1, R2

2$:             tst     @#177710
                bpl     3$
                call    (R5)

3$:             sob     R2, 2$
                sob     R0, 1$
                sub     #BgrMusOffs1-BgrMusPlay, R5
                mov     (SP)+, R0
                return
; End of function PlayTone


; ███████████████ S U B R O U T I N E ███████████████████████████████████████


StartPlayMelody1:
                mov     #BgrMusPlay, R5
                mov     #Melody1, BgrMusPtr ; Указатель на текущую ноту фоновой музыки


; ███████████████ S U B R O U T I N E ███████████████████████████████████████


StartPlayMusic: mov     #1, BgrMusTempo ; Длительность текущей ноты
                tstb    @#MusicOff
                bne     1$
                mov     #32, @#177712
                return
; ───────────────────────────────────────────────────────────────────────────

1$:             mov     #20, @#177712
                return
; End of function StartPlayMusic
; End of function StartPlayMelody1


RedrawInOutDoor:mov     R4, -(SP)
                clr     R4
                call    DrawInOutDoor   ; Прорисовка входа/выхода с ключиком
                                        ; Вход: R4 - индекс: 0 - вход, 2 - выход
                tst     (R4)+
                call    DrawInOutDoor   ; Прорисовка входа/выхода с ключиком
                                        ; Вход: R4 - индекс: 0 - вход, 2 - выход
                mov     (SP)+, R4
                return


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Прорисовка входа/выхода с ключиком
; Вход: R4 - индекс двери: 0 - вход, 2 - выход

DrawInOutDoor:  tstb    DrawEntryFlag   ; вход/выход рисовать можно?
                beq     3$              ; нет - выход
                mov     DoorAddress(R4), R2 ; адрес двери
                call    (R5)
                tstb    ClosedDoor(R4)  ; дверь открыта?
                bne     1$              ; да
                movb    #TS$Key, -101(R2) ; нет - добавим на ключ карту

1$:             call    IsVisible       ; проверка, в видимой полукомнате или нет.
                                        ; Вход: R2 - адрес в буфере
                                        ; Выход: <0 - нет
                blt     3$              ; дверь невидима - выходим
                tstb    ClosedDoor(R4)  ; дверь открыта?
                bne     2$              ; да - прорисуем сразу открытой
                mov     DoorAddress(R4), R2
                call    DrawGrWall      ; рисуем зелёную стену, где открывается дверь входа
                                        ; Вход: R2 - адрес в буфере лабиринта
                mov     DoorAddress(R4), R2
                sub     #101, R2
                call    CalcScrAddr     ; вычисление адреса экрана по адресу байта в буфере комнаты
                                        ; вход: R2 - адрес в буфере комнаты
                                        ; выход: R2 - адрес экрана
                mov     #TS$Key, R0
                call    DrawTile0       ; Вывести объект на экран без цветовой маски
                                        ; Вход: R0 - номер тайла в массиве
                                        ;       R2 - адрес экрана
3$:             jmp     (R5)
; ───────────────────────────────────────────────────────────────────────────

2$:             call    (R5)
                jmp     AnimDoorOpen    ; Анимация открывающегося прохода в стене
; End of function DrawInOutDoor


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; проверка, кто кого поймал
; Вход: R0 - кого
;       R1, R2 - кто
;       R3 - индекс: 2,4,6 - охотник1,2,3, 0 - ГГ быть не может
; Выход: установка флага GGCatched - да, поймал.

IsCatching:     tstb    HuntState(R3)   ; а состояние? если тут 0, то пойматие считается
                                        ; иначе - не поймал
                bne     2$
                cmp     R1, R0          ; координаты совпали?
                beq     1$              ; да - поймал
                cmp     R2, R0          ; а эти совпали?
                beq     1$              ; да - поймал
                add     #100, R0        ; а если так?
                cmp     R1, R0          ; совпали?
                beq     1$              ; да - поймал
                cmp     R2, R0          ; а вот так?
                bne     2$              ; нет - не поймал

1$:             incb    GGCatched       ; флаг, охотник поймал человечка
2$:             jmp     (R5)

; End of function IsCatching


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; проверка на лестницу по текущим координатам
; Вход: R0 - адрес в буфере
;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
; Выход: Z - лестница

IsLadderHere:   mov     Coordinate(R3), R0


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; проверка на лестницы
; Вход: R0 - координата
; Выход: Z - да

IsLadder:       cmpb    200(R0), #TS$LadderUppLeft
                beq     1$
                cmpb    200(R0), #TS$LadderUppRight
1$:             return
; End of function IsLadder
; End of function IsLadderHere

; ───────────────────────────────────────────────────────────────────────────
; номера тайлов спрайтов
AnimDoorSequence:
                ; при движении вправо
                .byte TS$ClosBreachLeft
                .byte TS$OpnClsBrchRight
                .byte TS$BreachLeft
                .byte TS$HalfWallLeft
                ; при движении влево
                .byte TS$OpnBreachLeft
                .byte TS$HalfWallLeft
                .byte TS$BreachLeft
                .byte TS$OpnClsBrchRight

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; отработка поворота односторонней двери

DrawAnimDoor:   mov     GGCoord, R2
                cmpb    -(R2), #TS$BreachLeft
                bge     1$
                inc     R2

1$:             cmpb    -100(R2), #TS$BreachLeft
                blt     2$
                sub     #100, R2

2$:             call    (R5)
                mov     #AnimDoorSequence, R0
                tstb    DirMove         ; флаг направления движения для ГГ, 0 - вправо, !0 - влево
                beq     3$
                cmp     (R0)+, (R0)+    ; +4

3$:             movb    AnimStage, R3   ; номер этапа в анимации
                bic     #177774, R3
                add     R3, R0
                movb    (R0), R0

4$:             call    DrawDoorElement ; Вход: R0 - номер тайла
                                        ;       R2 - адрес экрана
                inc     R0
                inc     R2
                call    DrawDoorElement ; Вход: R0 - номер тайла
                                        ;       R2 - адрес экрана
                dec     R0
                add     #77, R2
                cmpb    (R2), #TS$BreachLeft
                bge     4$
                jmp     (R5)
; End of function DrawAnimDoor


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Вход: R0 - номер тайла в массиве
;       R2 - адрес экрана

DrawDoorElement:mov     R0, -(SP)
                mov     R2, -(SP)
                call    CalcScrAddr     ; вычисление адреса экрана по адресу байта в буфере комнаты
                                        ; вход: R2 - адрес в буфере комнаты
                                        ; выход: R2 - адрес экрана
                call    DrawTile0       ; Вывести объект на экран без цветовой маски
                                        ; Вход: R0 - номер тайла в массиве
                                        ;       R2 - адрес экрана
                mov     (SP)+, R2
                mov     (SP)+, R0
                bitb    #3, AnimStage   ; номер этапа в анимации
                bne     1$
                movb    R0, (R2)

1$:             jmp     (R5)
; End of function DrawDoorElement

; ───────────────────────────────────────────────────────────────────────────
WallClearMask:  .word ^b1111000000000000
                .word ^b0000111100000000
                .word ^b0000000011110000
                .word ^b0000000000001111
                .word ^b0000000011110000
                .word ^b0000111100000000
                .word ^b1111000000000000

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; стирание куска стены при стучании киркой вбок

ClrWallHackSide:call    (R5)
                mov     #WallClearMask, R0
                mov     GGCoord, R2
                inc     R2
                tstb    DirMove         ; куда направление движения?
                beq     2$              ; вправо
                add     #6, R0          ; влево, значит коорд. - 1
                tst     -(R2)

2$:             movb    AnimStage, R1   ; номер этапа в анимации
                add     R1, R0          ; по номеру этапа
                mov     #4, R4          ; звук удара киркой
                call    (R5)
                mov     (R0), R0        ; получим нужную маску
                call    ClrWHSSub       ; стираем кусок стены
                add     #100, R2
                ;call    ClrWHSSub       ; и ещё пониже
                ;return


; ███████████████ S U B R O U T I N E ███████████████████████████████████████


ClrWHSSub:      cmpb    (R2), #TS$Wall  ; если там не стена
                bne     2$              ; выход
                mov     R2, -(SP)
                call    CalcScrAddr     ; вычисление адреса экрана по адресу байта в буфере комнаты
                                        ; вход: R2 - адрес в буфере комнаты
                                        ; выход: R2 - адрес экрана
                mov     #10., R1        ; иначе сотрём кусочек стены по маске
1$:             bic     R0, (R2)
                add     #100, R2
                sob     R1, 1$
                mov     (SP)+, R2

2$:             jmp     (R5)
; End of function ClrWHSSub
; End of function ClrWallHackSide


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; стирание куска стены при стучании киркой вниз
; одно непонятно, почему вычитание, вниз же должно быть приращение

ClrWallHackDown:mov     GGCoord, R2
                add     #400, R2
                call    CalcScrAddr     ; вычисление адреса экрана по адресу байта в буфере комнаты
                                        ; вход: R2 - адрес в буфере комнаты
                                        ; выход: R2 - адрес экрана
                movb    AnimStage, R0   ; номер этапа в анимации
                asr     R0
                beq     2$

1$:             sub     #500, R2
                sob     R0, 1$
                call    (R5)

2$:             mov     #5, R0

3$:             sub     #100, R2
                clr     (R2)
                sob     R0, 3$
                mov     #4, R4          ; звук удара киркой
                jmp     (R5)
; End of function ClrWallHackDown


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Проверка и подбор лута
; Вход: R2 - координаты ГГ

PickLUT:        cmp     KnifeAddr, R2   ; ножик попал в ГГ
                bne     1$              ; нет
                call    CheckKnifeCatch ; проверка на взаимодействие ГГ с ножом

1$:             mov     R2, -(SP)
                tstb    (R2)            ; а не сокровище ли там?
                bmi     4$              ; да, пойдём, подберём
                cmpb    (R2), #TS$Key   ; нет, может ключ от двери ?
                beq     6$              ; да, пойдём отметим
                ; проверка подбора кирки или ножа
                call    (R5)
                tstb    GGHaveEquip     ; в руках есть что-нибудь?
                bne     7$              ; да - ничего подобрать не можем
                cmpb    (R2), #TS$Hack  ; если там кирка
                beq     5$              ; переход
                cmpb    (R2), #TS$Knife ; нет, там нож?
                bne     7$              ; нет, там что-то другое
                decb    GGHaveEquip     ; да - отметим, взяли нож
                br      3$
5$:             incb    GGHaveEquip     ; да - отметим, взяли кирку
                br      3$
; ───────────────────────────────────────────────────────────────────────────
                ; проверка подбора ключа
6$:             movb    #1, CatchKeyFlg ; да - отметим
                br      3$
; ───────────────────────────────────────────────────────────────────────────
                ; подбор сокровища
4$:             call    ClearLUT
                mov     #1, CurrScoreBuf+2
                call    IncrScore       ; изменяем счёт

                dec     ThreasuresNum   ; все сокровища подобраны?
                bne     2$              ; нет
                inc     AccomplishPyramid ; да - пирамида пройдена
                incb    DrawEntryFlag   ; можно показать дверь
                call    RedrawInOutDoor ; надо - рисуем

                movb    #253, BreakMus  ; ставим зацикливание музыки
                mov     #Melody2, BgrMusPtr ; Указатель на текущую ноту фоновой музыки
                call    StartPlayMusic  ; проиграем музыку
2$:             mov     #6, R4          ; звук подбора сокровища
                br      7$

                ; очистка в карте лабиринта
3$:             call    ClearLUT
7$:             mov     (SP)+, R2
                jmp     (R5)
; End of function PickLUT


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Выполнение движения охотников.
; Вход: R3 - индекс: 2,4,6 - охотник1,2,3. Индекс не может быть 0

EmulateHunt:    mov     R3, -(SP)
                call    (R5)
                call    RND             ; Генерация случайного числа.
                                        ; Выход: R3 - число
                mov     (SP)+, R3
                clrb    HuntTurnHead(R3)
                movb    HuntState(R3), R0 ; состояние охотника
                beq     2$              ; активен - пойдём обрабатывать
                cmp     #-6, R0         ; время пришло?
                bne     0Done4$         ; нет ещё
                tst     RndBuff         ; коэффициент случайности
                bmi     0Done4$
                mov     StartCoord(R3), Coordinate(R3)  ; возвращаем начальную координату

0Done4$:        jmp     (R5)
; ───────────────────────────────────────────────────────────────────────────

2$:             call    (R5)
                tstb    AnimType(R3)    ; тип анимации?
                bne     0Done4$         ; не ходьба - выход
                movb    HuntParam(R3), R0 ; параметр охотника 0..4
                beq     9$              ; если 0 - пропускаем
                ; иначе проверим в зоне видимости ли?
                mov     GGCoord, R1     ; координата ГГ
                mov     Coordinate(R3), R2 ; координата охотника
                sub     R2, R1          ; вычисляем расстояние
                bge     3$
                neg     R1              ; по модулю

3$:             call    (R5)
                cmp     HuntFoVVert, R1 ; расстояние больше этого коэффициента?
                blt     9$              ; да - переход
                bic     #177700, R1
                cmp     HuntFoVHorz, R1 ; расстояние больше этого коэффициента?
                blt     9$              ; да - переход
                ; да в зоне видимости
                call    (R5)
                cmp     #2, R0
                blt     13$
                ; параметр охотника 1,2
5$:             mov     GGCoord, R1     ; координата ГГ
                mov     Coordinate(R3), R2 ; координата охотника
                bic     #177700, R1     ; оставляем расстояние по горизонтали
                bic     #177700, R2
                call    (R5)
                sub     R2, R1          ; вычисляем
                beq     12$             ; совпали
                bgt     7$
                ; правее ГГ на одном уровне
6$:             mov     #10, R0         ; идём влево
                mov     Coordinate(R3), R2
                dec     R2
                call    sub_20042       ; Выполнение прыжков охотников
                bne     0Done4$
                dec     R2
                br      8$
; ───────────────────────────────────────────────────────────────────────────
                ; левее ГГ на одном уровне
7$:             mov     #31, R0         ; идём вправо
                mov     Coordinate(R3), R2
                inc     R2
                call    sub_20042       ; Выполнение прыжков охотников
                bne     0Done4$
                inc     R2

8$:             mov     #1, R1
                call    (R5)
;
; если параметр охотника нечётный, и он движется по горизонтали и у ног препятствие
; а у головы и выше головы нет препятствия, то можно прыгать
; иначе - просто обработка движений
; if ( HuntParam(R3) & 1 == 0 && OffsetY(R3) == 0 &&
;     (R2) == TS$Wall && !(-100(R2) == TS$Wall || -200(R2) == TS$Wall) 
;    )
; {
;       MakeJumpHere(R3);
; }
; else
; {
;       ReactControl(R0, R3);
; }
                bitb    HuntParam(R3), R1 ; охотник типа #1
                bne     10$             ; да
                ; типа #2
                tstb    OffsetY(R3)     ; движение по вертикали есть?
                bne     10$             ; да
                ; нет
                cmpb    (R2), R1        ; там стена?
                bne     10$             ; нет
                cmpb    -100(R2), R1    ; а выше?
                beq     10$             ; да
                call    (R5)
                cmpb    -200(R2), R1    ; а ещё выше?
                beq     10$             ; да
                call    MakeJumpHere    ; нет - можно прыгать
                br      11$
; ───────────────────────────────────────────────────────────────────────────

9$:             br      20$
; ───────────────────────────────────────────────────────────────────────────
                ; просто ходьба влево-вправо
10$:            call    (R5)
                call    ReactControl    ; Обработка реакции на взаимодействие
                                        ; Вход: R0 - код нажатой клавиши: 10,31,32,33,40. других нет
                                        ;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3

; Если нет анимаций и параметр охотника не 0 и ГГ движется по вертикали
; то если ГГ движется вниз, идти вверх, иначе - идти вниз
; в общем, навстречу ГГ
;if (AnimType(R3) == 0 && HuntParam(R3) != 0 && OffsetY != 0?)
;{
;    R0 = (OffsetY > 0) ? 33 : 32;
;    goto 16$;
;}
;else
;{
;    goto 0Done5$
;}
                                        
11$:            tstb    AnimType(R3)    ; что с анимацией?
                bne     0Done5$         ; есть какая-то - выход
                tstb    HuntParam(R3)   ; нет, а параметр?
                beq     0Done5$         ; нету - выход
                tstb    OffsetY         ; есть, Куда идёт ГГ по вертикали?
                beq     0Done5$         ; никуда, горизонтально движется - выход
                bgt     14$             ; вниз идёт !!! тут было на 14$
                mov     #32, R0         ; тогда пойдём вверх
                br      16$
; ───────────────────────────────────────────────────────────────────────────
                ; охотник и ГГ встретились
12$:            clr     OffsetX(R3)     ; остановиться
                mov     #2001, HuntTurnHead(R3)
0Done5$:        jmp     (R5)

; ───────────────────────────────────────────────────────────────────────────
                ; параметр охотника 3,4
13$:            mov     GGCoord, R1     ; координата ГГ
                bic     #77, R1         ; оставляем вертикальную координату
                bic     #77, R2
                call    (R5)
                sub     R2, R1
                beq     5$              ; на одном уровне - проверим куда идти по горизонтали
                blt     18$             ; ниже
                ; выше ГГ
14$:            tstb    OffsetY(R3)     ; движение по вертикали есть?
                bne     15$             ; да - идём, нет - проверим.
                mov     Coordinate(R3), R2
                cmpb    200(R2), #TS$Wall ; под ногами стена?
                beq     0Done6$         ; да - выход

15$:            mov     #33, R0         ; тогда пойдём вниз
16$:            call    (R5)
                call    ReactControl    ; Обработка реакции на взаимодействие
                                        ; Вход: R0 - код нажатой клавиши: 10,31,32,33,40. других нет
                                        ;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
0Done6$:        jmp     (R5)
; ───────────────────────────────────────────────────────────────────────────
                ; ниже ГГ
18$:            mov     #32, R0         ; тогда пойдём вверх
                call    ReactControl    ; Обработка реакции на взаимодействие
                                        ; Вход: R0 - код нажатой клавиши: 10,31,32,33,40. других нет
                                        ;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
                tstb    OffsetY(R3)     ; движение по вертикали есть?
                blt     0Done6$         ; вверх - выход
                tstb    OffsetX(R3)     ; нет или вниз - а по горизонтали? !!! тут было без (R3)
                beq     12$             ; нет - стоять
19$:            blt     6$              ; влево
                br      7$              ; вправо
; ───────────────────────────────────────────────────────────────────────────

20$:            call    (R5)
                tstb    OffsetX(R3)
                beq     23$
                tstb    OffsetY(R3)
                bne     21$
                bit     RndBuff, #61010
                beq     22$
                br      26$
; ───────────────────────────────────────────────────────────────────────────

21$:            bit     RndBuff, #103204
                bne     26$

22$:            call    ReflectMove     ; изменение направления движения на обратное
                br      26$
; ───────────────────────────────────────────────────────────────────────────

23$:            bit     RndBuff, #100401
                bmi     26$
                bne     24$
                mov     #10, R0         ; влево
                br      25$
; ───────────────────────────────────────────────────────────────────────────

24$:            mov     #31, R0         ; вправо
25$:            call    ReactControl    ; Обработка реакции на взаимодействие
                                        ; Вход: R0 - код нажатой клавиши: 10,31,32,33,40. других нет
                                        ;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
26$:            call    (R5)
                tstb    OffsetY(R3)
                bne     0Done6$
                tstb    OffsetX(R3)
                beq     29$
                bit     RndBuff, #400
                beq     27$
                mov     #32, R0         ; вверх
                call    ReactControl    ; Обработка реакции на взаимодействие
                                        ; Вход: R0 - код нажатой клавиши: 10,31,32,33,40. других нет
                                        ;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
                tstb    OffsetY(R3)
                bne     0Done6$

27$:            call    (R5)
                mov     Coordinate(R3), R2
                cmpb    200(R2), #TS$Wall
                beq     28$
                cmp     RndBuff, #20000
                bgt     28$
                mov     #33, R0         ; вниз
                call    ReactControl    ; Обработка реакции на взаимодействие
                                        ; Вход: R0 - код нажатой клавиши: 10,31,32,33,40. других нет
                                        ;       R3 - индекс: 0 - ГГ, 2,4,6 - охотник1,2,3
                tstb    OffsetY(R3)
                bne     0Done6$

28$:            call    (R5)
                bit     RndBuff, #74020
                beq     12$

29$:            tstb    OffsetX(R3)
                beq     0Done6$
                br      19$
; End of function EmulateHunt


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Выполнение прыжков охотников ?? вроде бы нет.
; Вход: R2 - следующая координата текущего охотника, куда он наступит
;       R3 - индекс: 2,4,6 - охотник1,2,3. Индекс не может быть 0
; Выход: состояние типа анимации
;        Z = 0 / не 0

sub_20042:      call    (R5)
                tstb    OffsetY(R3)     ; движение по вертикали есть?
                bne     5$              ; да - выход
                mov     #1, R1
                cmpb    100(R2), R1     ; у ног - стена?
                bne     3$              ; нет
                cmpb    (R2), R1        ; да, а перед собой - стена?
                beq     2$              ; да - прыгнуть нельзя
                ; запрыгиваем на препятствие
1$:             mov     R2, -(SP)
                call    MakeJumpHere
                mov     (SP)+, R2
                br      5$              ; выход
; ───────────────────────────────────────────────────────────────────────────
                ; непреодолимое препятствие
2$:             call    (R5)
                bit     RndBuff, #540   ; фактор случайности - тупить
                bne     5$              ; выход
                tstb    OffsetX(R3)     ; если стоим на месте
                beq     5$              ; выход
                movb    #-41, HuntState(R3) ; исчезнуть ??
                br      6$              ; вообще выход на уровень выше
; ───────────────────────────────────────────────────────────────────────────

3$:             bitb    HuntParam(R3), R1 ; тип охотника?
                beq     5$              ; чётный - выход
                tstb    200(R2)         ; под ногами что-то есть?
                bne     5$              ; да - выход
                mov     RndBuff, R0     ; пусто
                bic     #177760, R0
                beq     1$              ; шанс - прыгнуть
                call    (R5)
                sub     #2, R0          ; случайное число
                blt     5$              ; <0 - выход
                bgt     4$              ; >0
                clr     OffsetX(R3)     ; =0 - остановиться
                br      5$              ; и выход
; ───────────────────────────────────────────────────────────────────────────

4$:             cmp     GGCoord, Coordinate(R3)
                ble     6$

5$:             call    (R5)
                tstb    AnimType(R3)
                return
; ───────────────────────────────────────────────────────────────────────────
; вот это место непонятное. любые действия тут ни на что не влияют
6$:             ;tst     (SP)+           ; выход из этой п/п
                ;call    ReflectMove     ; отзеркалим направление движения, и выйдем из функции EmulateHunt
                ;br      5$
                sez
                return
; End of function sub_20042


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; изменение направления движения на обратное

ReflectMove:    call    (R5)
                negb    OffsetX(R3)     ; поворачиваем в обратную сторону по горизонтали
                negb    OffsetY(R3)     ; поворачиваем в обратную сторону по вертикали
                negb    DirMove(R3)     ; меняем направление движения
                incb    DirMove(R3)     ; т.е. 0 на 1 или 1 на 0
                jmp     (R5)
; End of function ReflectMove

; ───────────────────────────────────────────────────────────────────────────
; таблица адресов пирамид в карте выбора этапа
PyramidMap:     .word 52006
                .word 45616
                .word 52026
                .word 45636
                .word 52046
                .word 45656
                .word 51766
                .word 56056
                .word 61766
                .word 66056
                .word 61646
                .word 66036
                .word 61626
                .word 66016
                .word 62006
; таблица адресов вывода стрелок-указателей между пирамидами
; если бит 15 - то снизу-слева вправо-вверх, если нет - то сверху-слева вправо-вниз
; бит 0 определяет, что адрес рассчитан на направление вверх
; бит 2 определяет, что адрес направления влево
StageMap:       .word 55412
                .word 51416+100000
                .word 51427
                .word 51436+100000
                .word 51447
                .word 51456+100000
                .word 51467
                .word 55463+100000
                .word 61467
                .word 65463+100000
                .word 65452
                .word 65443+100000
                .word 65432
                .word 65423+100000
                .word 65412
                .word 61416+100000
; спрайт дорожки ширина: 2 слова, высота: 16. строк
ArrowLineSpr:   .word ^B0000000010000000,^B0000000000000000
                .word ^B0000001010100000,^B0000000000000000
                .word ^B0000101010101000,^B0000000000000000
                .word ^B0010101010101010,^B0000000000000000
                .word ^B1010101010101000,^B0000000000000000
                .word ^B1010101010100000,^B0000000000000010
                .word ^B1010101010000000,^B0000000000001010
                .word ^B1010101000000000,^B0000000000101010
                .word ^B1010100000000000,^B0000000010101010
                .word ^B1010000000000000,^B0000001010101010
                .word ^B1000000000000000,^B0000101010101010
                .word ^B0000000000000000,^B0010101010101010
                .word ^B0000000000000000,^B1010101010101000
                .word ^B0000000000000000,^B0010101010100000
                .word ^B0000000000000000,^B0000101010000000
                .word ^B0000000000000000,^B0000001000000000
; спрайты указателя стрелки, по 8 слов на два направления
; стрелка влево-вверх
ArrowPtrSpr:    .word ^B1010101010101010
                .word ^B0010101010101010
                .word ^B0000101010101010
                .word ^B0000001010101010
                .word ^B0000000010101010
                .word ^B0000000000101010
                .word ^B0000000000001010
                .word ^B0000000000000010
; стрелка вправо-вверх
                .word ^B1010101010101010
                .word ^B1010101010101000
                .word ^B1010101010100000
                .word ^B1010101010000000
                .word ^B1010101000000000
                .word ^B1010100000000000
                .word ^B1010000000000000
                .word ^B1000000000000000
; ширина 2 слова, высота 040 строк
PyramidSprite:  .word ^B1100000000000000,^B0000000000000000
                .word ^B1011000000000000,^B0000000000000000
                .word ^B1111000000000000,^B0000000000000011
                .word ^B1110110000000000,^B0000000000000011
                .word ^B1010110000000000,^B0000000000001110
                .word ^B1111101100000000,^B0000000000001110
                .word ^B1110101100000000,^B0000000000111011
                .word ^B1011111011000000,^B0000000000111010
                .word ^B1111101011000000,^B0000000011101111
                .word ^B1011101110110000,^B0000000011101010
                .word ^B1010111010110000,^B0000001110111010
                .word ^B1111101011101100,^B0000001110101111
                .word ^B1011101110101100,^B0000111010101010
                .word ^B1010111010111011,^B0000111011111110
                .word ^B1111101011101011,^B0011101010101011
                .word ^B1010111110101110,^B0011101111111010
                .word ^B1110111010111010,^B1110101010101111
                .word ^B1011111011101011,^B1111111110101010
                .word ^B1010111110101110,^B1010101011111110
                .word ^B1111101010111010,^B1111101010111011
                .word ^B1010111111101011,^B1010111111101010
                .word ^B1010101110101110,^B1110101010111111
                .word ^B1111111010111010,^B1011111010101010
                .word ^B1010101111101011,^B1010101111111010
                .word ^B1110101110101110,^B1110101010101111
                .word ^B1011111111111010,^B1011111110101010
                .word ^B1010101011101011,^B1010101011111110
                .word ^B1111101010101110,^B1111101010101011
                .word ^B1010111111111010,^B0000111111101010
                .word ^B1010101011101011,^B0000000000111111
                .word ^B1111111010101100,^B0000000000000000
                .word ^B0000001111110000,^B0000000000000000
; боковушки пирамиды, левая
; ширина 1 байт, высота 016 строк
                .byte ^B11000000
                .byte ^B11000000
                .byte ^B10110000
                .byte ^B10110000
                .byte ^B11101100
                .byte ^B10101100
                .byte ^B10111011
                .byte ^B11101011
                .byte ^B10101110
                .byte ^B10111010
                .byte ^B11101011
                .byte ^B10101100
                .byte ^B10110000
                .byte ^B11000000
; и правая
; ширина 1 байт высота 012 строк
                .byte ^B00000011
                .byte ^B00000011
                .byte ^B00001110
                .byte ^B00001111
                .byte ^B00111010
                .byte ^B00111010
                .byte ^B11101111
                .byte ^B11101010
                .byte ^B11111110
                .byte ^B00000011

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Подсветка текущего этапа

SelectPyramid:  call    ClrScr
                call    OutCopyRight
                mov     #StrStage, R0
                mov     #10, R1
                mov     #40030, R2
                call    PutStr          ; Вывод строки
                                        ; Вход: R0 - адрес строки
                                        ;       R1 - длина строки
                                        ;       R2 - адрес экрана
                                        ;       R5 - адрес сопрограммы (типично - фоновый звук)
                                        ; Выход: R0 += R1 указывает за конец строки
                mov     #Valley, R0
                mov     #14, R1
                mov     #GameNameScr2+24, R2
                call    PutStr          ; Вывод строки
                                        ; Вход: R0 - адрес строки
                                        ;       R1 - длина строки
                                        ;       R2 - адрес экрана
                                        ;       R5 - адрес сопрограммы (типично - фоновый звук)
                                        ; Выход: R0 += R1 указывает за конец строки
; выводим пирамиды
                mov     #15., R0
                mov     #PyramidMap, R4

1$:             mov     (R4)+, R2
                call    DrawPyramid     ; Вход: R2 - адрес вывода
                sob     R0, 1$
; выводим дорожки между ними
                mov     #16., R5

2$:             mov     #ArrowLineSpr, R1
                mov     #76, R0
                mov     (R4), R2
                bic     #100005, R2
                bit     #100000, (R4)+
                beq     3$
                add     #1700, R2
                sub     #200, R0

3$:             mov     #16., R3

4$:             mov     (R1)+, (R2)+
                mov     (R1)+, (R2)
                add     R0, R2
                sob     R3, 4$
                sob     R5, 2$
                mov     CurrPyramid, R4 ; Номер текущей пирамиды, отсчёт с 1
                mov     #ArrowPtrSpr, R1
                mov     #100, R0
                asl     R4
                movb     MoveToBack, R5 ; Движемся в обратном направлении?
                bne     5$              ; да
                tst     -(R4)           ; нет - скорректируем индекс

5$:             mov     StageMap(R4), R2 ; адрес экрана для вывода указателя стрелки
                mov     R2, R4          ; скопируем
                bic     #100005, R2     ; сбросим все флаги
                tst     R5              ; движемся назад?
                beq     7$              ; нет - переход
                                        ; !0 - да
                bit     #4, R4          ; адрес стрелки направленной влево?
                bne     6$              ; да
                tst     (R2)+           ; нет - корректируем адрес экрана
                add     #20, R1         ; и спрайт стрелки, чтоб был направлен вправо

6$:             bit     #1, R4          ; адрес стрелки по направлению вверх
                bne     10$             ; да
                br      9$              ; нет - идём корректировать
; ───────────────────────────────────────────────────────────────────────────

7$:             bit     #4, R4          ; адрес стрелки направленной влево?
                beq     8$              ; нет
                tst     (R2)+           ; да - корректируем адрес экрана
                add     #20, R1         ; и спрайт стрелки

8$:             bit     #1, R4          ; адрес стрелки по направлению вверх
                beq     10$             ; нет
                                        ; да - корректируем

9$:             add     #1700, R2       ; рисовать будем снизу-вверх
                sub     #200, R0

10$:            mov     #8., R3         ; рисуем стрелку

11$:            bis     (R1)+, (R2)
                add     R0, R2
                sob     R3, 11$
                bic     #100005, R4     ; снова сбросим все флаги
                mov     #GameOver, @#4  ; играем музыку
                clr     @#177706
                mov     #20, @#177712
                mov     #BgrMusPlay, R5
                mov     #PyramidSelMus, BgrMusPtr ; Указатель на текущую ноту фоновой музыки
                mov     #1, BgrMusTempo ; Длительность текущей ноты

12$:            mov     R4, R2
                mov     #16., R3        ; Выделяем текущую стрелку

13$:            mov     (R2), R1
                rol     R1
                bis     R1, (R2)+
                mov     (R2), R1
                rol     R1
                bis     R1, (R2)
                call    (R5)
                add     #76, R2
                sob     R3, 13$
                mov     #4000, R1

14$:            call    (R5)
                sob     R1, 14$
                mov     R4, R2
                mov     #16., R3

15$:            bic     #125252, (R2)+  ; теперь другим цветом
                bic     #125252, (R2)
                add     #76, R2
                call    (R5)
                sob     R3, 15$
                mov     #4000, R1

16$:            call    (R5)
                sob     R1, 16$
                cmp     #NoCoProgrGme, R5 ; пока музыка не кончится
                bne     12$             ; продолжаем цикл
                tstb    @#177660        ; ждём нажатия на любую клавишу
                bpl     12$             ; пока не нажата продолжаем цикл
                bit     #100, @#177716  ; пока клавиша не отпущена
                bne     12$             ; продолжаем цикл
                return
; End of function SelectPyramid


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Вход: R2 - адрес вывода

DrawPyramid:    mov     #PyramidSprite, R1
                mov     #40, R3

1$:             mov     (R1)+, (R2)+    ; сперва нарисуем основное тело, которое в 2 слова влазит
                mov     (R1)+, (R2)
                add     #76, R2
                sob     R3, 1$
                movb    (R1)+, -1102(R2)
                movb    -(R1), -1002(R2)
                sub     #2101, R2
                mov     #16, R3         ; затем нарисуем боковушки пирамиды

2$:             movb    (R1)+, (R2)     ; левую
                add     #100, R2
                sob     R3, 2$
                sub     #1273, R2
                mov     #12, R3

3$:             movb    (R1)+, (R2)      ; правую
                add     #100, R2
                sob     R3, 3$

StopSounds:     return
; End of function DrawPyramid


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Вход: R0 - индекс адреса звука. 0..012

PlaySounds:     mov     SoundsTbl(R0), R0 ; адрес звуковой последовательности

1$:             clr     R1
                bisb    (R0)+, R1       ; берём очередной байт - это длительность звука
                beq     StopSounds      ; 0 - конец
                clr     R2
                bisb    (R0)+, R2       ; берём следующий байт - это тон
                add     #40, R2         ; прибавляем к тону число

4$:             mov     R2, R3
                bis     #100, @#177716
                sob     R3, .

                mov     R2, R3
                bic     #100, @#177716
                sob     R3, .

                sob     R1, 4$          ; звучим

                mov     #2000, R3       ; небольшая пауза
                sob     R3, .
                br      1$              ; и пока вся мелодия не кончится
; End of function PlaySounds

; ───────────────────────────────────────────────────────────────────────────
SoundsTbl:      .word Sound0    ; звук открытия двери 1 часть
                .word Sound2    ; звук открытия двери 2 часть
                .word Sound4    ; звук закрытия двери 1 часть
                .word Sound6    ; звук закрытия двери 2 часть
                .word Sound10   ; звук в конце игры 1 часть
                .word Sound12   ; звук в конце игры 2 часть
; массив звуков, 0 - конец.
; первый байт - длительность звука, второй - его тон
Sound0:         .byte 25, 267
                .byte 27, 253
                .byte 141, 237
                .byte 0
Sound2:         .byte 25, 267
                .byte 27, 253
                .byte 60, 237
                .byte 31, 225
                .byte 33, 212
                .byte 35, 201
                .byte 75, 170
                .byte 0
Sound4:         .byte 36, 170
                .byte 35, 201
                .byte 141, 237
                .byte 0
Sound6:         .byte 27, 253
                .byte 25, 267
                .byte 51, 303
                .byte 23, 321
                .byte 22, 337
                .byte 21, 357
                .byte 40, 376
                .byte 0
Sound10:        .byte 161, 77
                .byte 161, 77
                .byte 132, 130
                .byte 234, 157
                .byte 234, 157
                .byte 314, 113
                .byte 314, 113
                .byte 146, 113
                .byte 204, 65
                .byte 204, 65
                .byte 212, 60
                .byte 226, 47
                .byte 0
Sound12:        .byte 270, 60
                .byte 0

; ███████████████ S U B R O U T I N E ███████████████████████████████████████


BgrMusPlay:
SndRise:        tst     @#177710
                bpl     1$
BgrMusOffs1:    dec     BgrMusTempo     ; Длительность текущей ноты
                beq     0NewNote$
                mov     @#177710, @#177706
                add     BgrMusTone, @#177706 ; тон текущей ноты
BgrMusOffs2:    mov     #32, @#177712
                bis     #100, @#177716
                add     #SndFall-SndRise, R5

1$:             return
; ───────────────────────────────────────────────────────────────────────────

SndFall:        tst     @#177710
                bpl     NoCoProgrGme
                dec     BgrMusTempo     ; Длительность текущей ноты
                beq     0NewNote$
                mov     @#177710, @#177706
                add     BgrMusTone, @#177706 ; тон текущей ноты
                mov     #32, @#177712
                bic     #100, @#177716
                sub     #SndFall-SndRise, R5

NoCoProgrGme:   return
; ───────────────────────────────────────────────────────────────────────────

0NewNote$:      mov     R4, -(SP)
                mov     R3, -(SP)
                mov     BgrMusPtr, R4   ; Указатель на текущую ноту фоновой музыки

1$:             clr     R3
                bisb    (R4)+, R3       ; берём очередной байт
                bne     4$              ; не 0, значит данные
                bisb    (R4), R3        ; иначе смотрим следующий байт
                bne     2$              ; не 0, значит пока не конец, это смещение зацикливания
                mov     #NoCoProgrGme, R5 ; а оба нулевые - конец музыки
                br      7$              ; всё. больше звучать не будем
; ───────────────────────────────────────────────────────────────────────────

2$:             sub     R3, R4          ; смещаем указатель мелодии на начало зацикливания
                br      1$              ; и идём получать ноту
; ───────────────────────────────────────────────────────────────────────────

4$:             movb    (R4)+, BgrMusTone ; берём следующий байт
                bge     6$              ; если >=0, то переход
                add     #400, R3        ; иначе - длительность большая, в байт не влазит - скорректируем
                negb    BgrMusTone      ; и это приведём к нормальному виду

6$:             mov     R3, BgrMusTempo ; Длительность текущей ноты

7$:             mov     R4, BgrMusPtr   ; Указатель на текущую ноту фоновой музыки
                mov     (SP)+, R3
                mov     (SP)+, R4
                return
; End of function BgrMusPlay

; ───────────────────────────────────────────────────────────────────────────
; разные мелодии
Melody1:        .byte 5, 336, 134, 40, 5, 336, 134, 40
                .byte 333, 33, 351, 32, 202, 27, 164, 32
                .byte 155, 33, 134, 40, 5, 336, 134, 40
                .byte 256, 42, 233, 46, 222, 50, 233, 46
                .byte 135, 336, 111, 345, 164, 32, 111, 345
                .byte 164, 32, 25, 353, 45, 354, 244, 22
                .byte 222, 24, 212, 25, 164, 32, 155, 33
                .byte 164, 32, 202, 27, 164, 32, 333, 33
                .byte 270, 40, 5, 336, 134, 40, 256, 42
                .byte 155, 33, 141, 36, 155, 33, 164, 32
                .byte 212, 25, 222, 24, 25, 353, 351, 32
                .byte 111, 345, 164, 32, 333, 33, 155, 33
                .byte 141, 36, 155, 33, 164, 32, 212, 25
                .byte 222, 24, 244, 22, 222, 24, 212, 25
byte_22346:     .byte 164, 32, 111, 345, 164, 32, 267, 345
                .byte 0 ;конец
                .byte 171 ; смещение зацикливания
Melody2:        .byte 270, 330

; музыка, звучащая перед выбором пирамиды
PyramidSelMus:  .byte 303, 36, 317, 35, 366, 30, 5, 351
                .byte 366, 30, 317, 35, 303, 36, 256, 42
                .byte 141, 36, 147, 35, 60, 36, 63, 35
                .byte 60, 36, 63, 35, 60, 36, 63, 35
                .byte 60, 36, 63, 35, 60, 36, 63, 35
                .byte 60, 36, 63, 35, 303, 36, 0 ; конец
BreakMus:       .byte 0 ; без зацикливания
                .even

; блок всяческих данных

; таблицы приращений к координате ГГ/охотника при движении и анимациях
param1:         .word -100
                .word -200
                .word -100
param2:         .word 200
                .word 500
                .word 700
param3:         .word -300
                .word -500
                .word -1000
param4:         .word -400
                .word -700
                .word -1100
                .word 0
                .word 100
                .word 300
                .word 600
param5:         .word -400
                .word -1100
                .word -1300
                .word -400
                .word -600
                .word -1000
                .word -1100
                .word 0
                .word 100
                .word 200
                .word 400
                .word -400
                .word -100
                .word 200
                .word 600
param6:         .word -500
                .word -700
param7:         .word -500

; смещения к массивам
word_22572:     .word .-param1  ; движение по горизонтали
                .word .-param2  ; вниз
                .word .-param3  ; вверх
                .word .-param4  ; анимация 1
                .word .-param5  ; анимация 2
                .word .-param6  ; анимация 3
                .word .-param7  ; анимация 4

; биты 10..0 - смещение в массиве спрайтов
; биты 13..11 - ширина в байтах
; биты 15..14 - предположительно, что-то, связанное с анимацией
TileIndex:      .word 54000             ; тут 047 тайлов.
                .word 114066
                .word 110154
                .word 110220
                .word 54264
                .word 114352
                .word 50440
                .word 150504
                .word 54550
                .word 114636
                .word 54724
                .word 115012
                .word 55100
                .word 115166
                .word 15254
                .word 155342
                .word 55430
                .word 115516
                .word 115604
                .word 55672
                .word 55760
                .word 116046
                .word 56134
                .word 116222
                .word 56310
                .word 116376
                .word 56464
                .word 116552
                .word 16640
                .word 156726
                .word 117014
                .word 57102
                .word 117170
                .word 57256
                .word 113344
                .word 113410
                .word 113454
                .word 63520
                .word 63630
; массив спрайтов человечка, охотников и всякое такое
; столбцами байтов по 18.(022)
TileArray:
TileSprite00:   .byte 0, 0, 0, 300, 200, 40, 300, 0, 0, 0, 300, 360, 60, 300, 360, 340, 40, 40
                .byte 50, 252, 252, 377, 252, 377, 377, 377, 52, 273, 253, 50, 252, 352, 303, 300, 0, 0
                .byte 0, 0, 0, 3, 2, 13, 0, 3, 0, 2, 3, 17, 14, 0, 3, 3, 13, 12
TileSprite01:   .byte 0, 0, 0, 300, 200, 340, 0, 300, 0, 200, 300, 360, 60, 0, 300, 300, 340, 240
                .byte 50, 252, 252, 377, 252, 377, 377, 377, 250, 356, 352, 50, 252, 253, 303, 3, 0, 0
                .byte 0, 0, 0, 3, 2, 10, 3, 0, 0, 0, 3, 17, 14, 3, 17, 13, 10, 10
TileSprite02:   .byte 200, 240, 240, 374, 224, 362, 374, 360, 240, 240, 370, 370, 370, 240, 360, 360, 360, 240
                .byte 2, 12, 12, 77, 52, 277, 17, 77, 2, 12, 12, 12, 17, 2, 0, 0, 0, 2
TileSprite03:   .byte 200, 240, 240, 374, 250, 376, 360, 374, 200, 240, 240, 240, 360, 200, 0, 0, 0, 200
                .byte 2, 12, 12, 77, 52, 217, 77, 17, 12, 12, 57, 57, 57, 12, 17, 17, 17, 12
TileSprite04:   .byte 0, 0, 0, 300, 200, 40, 300, 0, 0, 0, 300, 0, 0, 340, 340, 40, 0, 0
                .byte 50, 252, 252, 377, 252, 377, 377, 377, 52, 273, 253, 257, 256, 352, 363, 360, 360, 240
                .byte 0, 0, 0, 3, 2, 13, 0, 3, 0, 2, 17, 3, 0, 0, 0, 0, 0, 2
TileSprite05:   .byte 0, 0, 0, 300, 200, 340, 0, 300, 0, 200, 360, 300, 0, 0, 0, 0, 0, 200
                .byte 50, 252, 252, 377, 252, 377, 377, 377, 250, 356, 352, 372, 272, 253, 317, 17, 17, 12
                .byte 0, 0, 0, 3, 2, 10, 3, 0, 0, 0, 3, 0, 0, 13, 13, 10, 0, 0
TileSprite06:   .byte 200, 240, 240, 374, 250, 362, 374, 360, 240, 260, 274, 217, 243, 254, 77, 16, 2, 2
                .byte 2, 12, 12, 77, 52, 277, 17, 77, 2, 53, 72, 362, 312, 16, 74, 74, 260, 240
TileSprite07:   .byte 200, 240, 240, 374, 250, 376, 360, 374, 200, 350, 254, 217, 243, 260, 74, 74, 16, 12
                .byte 2, 12, 12, 77, 52, 217, 77, 17, 12, 16, 76, 362, 312, 72, 374, 260, 200, 200
TileSprite08:   .byte 0, 0, 0, 300, 200, 40, 300, 0, 0, 0, 300, 0, 0, 0, 0, 300, 300, 200
                .byte 50, 252, 252, 377, 252, 377, 377, 377, 52, 273, 253, 257, 256, 352, 317, 3, 3, 12
                .byte 0, 0, 0, 3, 2, 13, 0, 3, 0, 2, 17, 3, 0, 3, 17, 57, 0, 0
TileSprite09:   .byte 0, 0, 0, 300, 200, 340, 0, 300, 0, 200, 360, 300, 0, 300, 360, 370, 0, 0
                .byte 50, 252, 252, 377, 252, 377, 377, 377, 250, 356, 352, 372, 272, 253, 363, 300, 300, 240
                .byte 0, 0, 0, 3, 2, 10, 3, 0, 0, 0, 3, 0, 0, 0, 0, 3, 3, 2
TileSprite10:   .byte 0, 0, 0, 0, 200, 300, 160, 340, 60, 60, 60, 60, 0, 0, 0, 0, 0, 0
                .byte 200, 240, 240, 377, 251, 362, 374, 363, 257, 274, 370, 370, 370, 240, 360, 360, 360, 240
                .byte 2, 12, 12, 77, 52, 277, 17, 77, 2, 12, 12, 13, 17, 2, 0, 0, 0, 2
TileSprite11:   .byte 200, 240, 240, 374, 250, 376, 360, 374, 200, 240, 240, 340, 360, 200, 0, 0, 0, 200
                .byte 2, 12, 12, 377, 252, 217, 77, 317, 372, 76, 57, 57, 57, 12, 17, 17, 17, 12
                .byte 0, 0, 0, 0, 1, 3, 16, 7, 14, 14, 14, 14, 0, 0, 0, 0, 0, 0
TileSprite12:   .byte 0, 0, 0, 360, 230, 54, 307, 76, 363, 303, 203, 203, 200, 340, 340, 40, 0, 0
                .byte 50, 252, 252, 377, 252, 377, 377, 377, 52, 273, 257, 277, 377, 252, 363, 360, 360, 240
                .byte 0, 0, 0, 3, 2, 13, 0, 3, 0, 2, 17, 3, 0, 0, 0, 0, 0, 2
TileSprite13:   .byte 0, 0, 0, 300, 200, 340, 0, 300, 0, 200, 360, 300, 0, 0, 0, 0, 0, 200
                .byte 50, 252, 252, 377, 252, 377, 377, 377, 250, 356, 372, 376, 377, 252, 317, 17, 17, 12
                .byte 0, 0, 0, 17, 32, 70, 343, 174, 317, 303, 302, 302, 2, 13, 13, 10, 0, 0
TileSprite14:   .byte 0, 0, 0, 0, 200, 300, 160, 340, 60, 60, 60, 60, 0, 0, 0, 0, 0, 0
                .byte 200, 240, 240, 377, 251, 362, 374, 363, 257, 274, 370, 370, 370, 254, 77, 16, 2, 2
                .byte 2, 12, 12, 77, 52, 277, 17, 77, 2, 53, 72, 363, 317, 12, 74, 74, 260, 240
TileSprite15:   .byte 200, 240, 240, 374, 250, 376, 360, 374, 200, 350, 254, 317, 363, 240, 74, 74, 16, 12
                .byte 2, 12, 12, 377, 252, 217, 77, 317, 372, 76, 57, 57, 57, 72, 374, 260, 200, 200
                .byte 0, 0, 0, 0, 1, 3, 16, 7, 14, 14, 14, 14, 0, 0, 0, 0, 0, 0
TileSprite16:   .byte 0, 0, 0, 360, 230, 54, 307, 76, 363, 303, 203, 203, 200, 0, 0, 300, 300, 200
                .byte 50, 252, 252, 377, 252, 377, 377, 377, 52, 273, 257, 277, 377, 252, 317, 3, 3, 12
                .byte 0, 0, 0, 3, 2, 13, 0, 3, 0, 2, 17, 3, 0, 3, 17, 57, 0, 0
TileSprite17:   .byte 0, 0, 0, 300, 200, 340, 0, 300, 0, 200, 360, 300, 0, 300, 360, 364, 0, 0
                .byte 50, 252, 252, 377, 252, 377, 377, 377, 250, 356, 372, 376, 377, 252, 363, 300, 300, 240
                .byte 0, 0, 0, 17, 32, 70, 343, 174, 317, 303, 300, 300, 0, 0, 0, 3, 3, 2
TileSprite18:   .byte 200, 240, 240, 374, 250, 362, 374, 360, 240, 240, 350, 250, 250, 240, 360, 360, 360, 240
                .byte 2, 12, 212, 277, 252, 277, 217, 277, 202, 212, 313, 377, 276, 2, 0, 0, 0, 2
                .byte 0, 0, 0, 10, 12, 12, 10, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0
TileSprite19:   .byte 0, 0, 0, 0, 40, 240, 240, 40, 0, 0, 0, 300, 0, 0, 0, 0, 0, 0
                .byte 200, 240, 242, 376, 252, 376, 362, 376, 202, 242, 343, 377, 277, 202, 0, 0, 0, 200
                .byte 2, 12, 12, 77, 52, 217, 77, 17, 12, 12, 53, 52, 52, 12, 17, 17, 17, 12
TileSprite20:   .byte 0, 0, 0, 300, 200, 40, 300, 0, 0, 0, 200, 200, 200, 340, 340, 40, 0, 0
                .byte 50, 252, 252, 377, 252, 377, 377, 377, 52, 252, 376, 372, 252, 252, 363, 360, 360, 240
                .byte 0, 0, 10, 210, 250, 250, 210, 13, 10, 10, 74, 17, 10, 0, 0, 0, 0, 2
TileSprite21:   .byte 0, 0, 40, 42, 52, 52, 42, 340, 40, 40, 74, 360, 40, 0, 0, 0, 0, 200
                .byte 50, 252, 252, 377, 252, 377, 377, 377, 250, 252, 277, 257, 252, 252, 317, 17, 17, 12
                .byte 0, 0, 0, 3, 2, 10, 3, 0, 0, 0, 2, 2, 2, 13, 13, 10, 0, 0
TileSprite22:   .byte 200, 240, 240, 374, 250, 362, 374, 360, 240, 254, 353, 253, 250, 254, 77, 16, 2, 2
                .byte 2, 12, 12, 77, 52, 277, 17, 77, 2, 112, 17, 377, 12, 16, 74, 74, 260, 240
                .byte 0, 0, 2, 42, 52, 52, 42, 2, 2, 2, 17, 3, 2, 0, 0, 0, 0, 0
TileSprite23:   .byte 0, 0, 200, 210, 250, 250, 210, 200, 200, 200, 360, 300, 200, 0, 0, 0, 0, 0
                .byte 200, 240, 240, 374, 250, 376, 360, 374, 200, 240, 360, 377, 240, 260, 74, 74, 16, 12
                .byte 2, 12, 12, 77, 52, 217, 77, 17, 12, 72, 353, 352, 52, 72, 374, 260, 200, 200
TileSprite24:   .byte 0, 0, 0, 300, 200, 40, 300, 0, 0, 0, 200, 200, 200, 0, 0, 300, 300, 200
                .byte 50, 252, 252, 377, 252, 377, 377, 377, 52, 52, 376, 372, 252, 352, 317, 3, 3, 12
                .byte 0, 0, 10, 210, 250, 250, 210, 13, 10, 10, 76, 57, 0, 3, 17, 57, 0, 0
TileSprite25:   .byte 0, 0, 40, 42, 52, 52, 42, 340, 40, 40, 74, 370, 40, 300, 360, 370, 0, 0
                .byte 50, 252, 252, 377, 252, 377, 377, 377, 250, 252, 277, 257, 252, 253, 363, 300, 300, 240
                .byte 0, 0, 0, 3, 2, 10, 3, 0, 0, 0, 2, 2, 2, 0, 0, 3, 3, 2
TileSprite26:   .byte 0, 0, 0, 300, 200, 40, 0, 0, 0, 200, 200, 200, 0, 300, 300, 360, 360, 240
                .byte 50, 252, 252, 377, 252, 377, 377, 375, 56, 272, 356, 272, 252, 373, 303, 300, 300, 202
                .byte 0, 0, 0, 3, 2, 13, 0, 3, 0, 0, 2, 0, 0, 3, 3, 3, 3, 12
TileSprite27:   .byte 0, 0, 0, 300, 200, 340, 0, 300, 0, 0, 0, 0, 0, 300, 300, 300, 300, 240
                .byte 50, 252, 252, 377, 252, 377, 377, 377, 250, 256, 273, 256, 252, 357, 303, 3, 3, 202
                .byte 0, 0, 0, 3, 2, 10, 2, 0, 0, 2, 2, 2, 0, 3, 3, 17, 17, 12
TileSprite28:   .byte 50, 252, 10, 40, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
                .byte 200, 240, 240, 362, 270, 257, 303, 277, 257, 274, 270, 250, 250, 274, 17, 17, 17, 52
                .byte 2, 12, 12, 77, 52, 277, 17, 77, 2, 72, 372, 312, 17, 17, 74, 74, 74, 250
TileSprite29:   .byte 200, 240, 240, 374, 250, 376, 360, 374, 200, 254, 257, 243, 360, 360, 74, 74, 74, 52
                .byte 2, 212, 12, 17, 272, 277, 373, 377, 372, 76, 56, 52, 52, 76, 360, 360, 360, 250
                .byte 12, 212, 52, 10, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
TileSprite30:   .byte 200, 240, 240, 374, 250, 362, 374, 360, 240, 250, 350, 350, 240, 274, 36, 17, 17, 52
                .byte 62, 312, 12, 77, 52, 377, 377, 377, 362, 76, 17, 13, 12, 17, 76, 74, 74, 250
                .byte 0, 0, 3, 17, 17, 33, 30, 60, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0
TileSprite31:   .byte 0, 0, 300, 360, 360, 330, 30, 14, 14, 0, 0, 0, 0, 0, 0, 0, 0, 0
                .byte 214, 243, 240, 374, 250, 377, 377, 377, 217, 274, 360, 340, 240, 360, 174, 74, 74, 52
                .byte 2, 12, 12, 77, 52, 217, 77, 17, 12, 52, 53, 53, 12, 76, 170, 360, 360, 250
TileSprite32:   .byte 200, 240, 240, 374, 250, 362, 374, 360, 240, 350, 250, 250, 240, 274, 36, 17, 17, 52
                .byte 2, 12, 12, 77, 52, 277, 17, 77, 2, 13, 17, 76, 372, 317, 76, 74, 74, 250
                .byte 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 300, 303, 317, 154, 360, 60
TileSprite33:   .byte 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 303, 363, 66, 17, 14
                .byte 200, 240, 240, 374, 250, 376, 360, 374, 200, 340, 360, 274, 257, 363, 174, 74, 74, 52
                .byte 2, 12, 12, 77, 52, 217, 77, 17, 12, 53, 52, 52, 12, 76, 170, 360, 360, 250
TileSprite34:   .byte 200, 240, 240, 374, 250, 376, 314, 360, 374, 254, 274, 260, 240, 170, 70, 74, 74, 52
                .byte 1, 11, 11, 77, 51, 277, 63, 17, 77, 71, 76, 16, 12, 36, 34, 74, 74, 250
TileSprite35:   .byte 200, 240, 240, 374, 250, 376, 314, 360, 200, 260, 274, 374, 340, 270, 270, 274, 274, 252
                .byte 2, 12, 12, 77, 52, 277, 63, 17, 2, 16, 75, 77, 13, 35, 35, 75, 75, 251
TileSprite36:   .byte 0, 0, 0, 0, 0, 314, 377, 374, 363, 377, 374, 377, 63, 360, 0, 0, 0, 0
                .byte 0, 0, 0, 0, 0, 3, 14, 77, 63, 17, 74, 3, 17, 0, 0, 0, 0, 0
TileSprite37:   .byte 0, 0, 0, 300, 300, 300, 60, 360, 300, 0, 300, 360, 360, 0, 0, 0, 0, 0
                .byte 0, 0, 317, 374, 377, 377, 377, 377, 77, 377, 377, 377, 374, 377, 317, 360, 0, 0
                .byte 0, 0, 63, 374, 317, 377, 377, 377, 377, 377, 377, 377, 377, 77, 377, 74, 0, 0
                .byte 0, 0, 0, 0, 3, 0, 3, 0, 14, 17, 17, 0, 3, 3, 3, 0, 0, 0
TileSprite38:   .byte 0, 0, 60, 0, 0, 0, 0, 0, 314, 0, 0, 0, 0, 0, 60, 0, 0, 0
                .byte 300, 0, 300, 300, 3, 14, 0, 0, 3, 0, 0, 14, 3, 300, 300, 0, 300, 0
                .byte 0, 0, 0, 0, 60, 14, 0, 0, 360, 0, 0, 14, 60, 0, 0, 0, 0, 0
                .byte 0, 0, 3, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 3, 0, 0, 0
; массив спрайтов движения охотника
HuntTileArray:
TileSpriteH00:  .byte 0, 300, 300, 300, 300, 300, 0, 0, 300, 360, 360, 60, 0, 300, 360, 360, 60, 60
                .byte 377, 377, 377, 317, 377, 17, 377, 377, 377, 377, 74, 377, 377, 377, 303, 300, 0, 0
                .byte 0, 3, 3, 0, 3, 0, 3, 0, 3, 3, 17, 14, 14, 0, 3, 3, 17, 17
TileSpriteH01:  .byte 0, 300, 300, 0, 300, 0, 300, 0, 300, 300, 360, 60, 60, 0, 300, 300, 360, 360
                .byte 377, 377, 377, 363, 377, 360, 377, 377, 377, 377, 74, 377, 377, 377, 303, 3, 0, 0
                .byte 0, 3, 3, 3, 3, 3, 0, 0, 3, 17, 17, 14, 0, 3, 17, 17, 14, 14
TileSpriteH02:  .byte 360, 374, 374, 374, 374, 374, 360, 360, 74, 74, 74, 74, 374, 360, 360, 360, 360, 360
                .byte 17, 77, 77, 14, 77, 77, 17, 3, 17, 17, 17, 14, 3, 3, 0, 0, 0, 3
TileSpriteH03:  .byte 360, 374, 374, 60, 374, 374, 360, 300, 360, 360, 360, 60, 300, 300, 0, 0, 0, 300
                .byte 17, 77, 77, 77, 77, 77, 17, 17, 74, 74, 74, 74, 77, 17, 17, 17, 17, 17
TileSpriteH04:  .byte 0, 300, 300, 300, 300, 300, 0, 0, 300, 360, 60, 0, 0, 360, 360, 60, 0, 0
                .byte 377, 377, 377, 317, 377, 377, 377, 377, 77, 374, 317, 77, 77, 377, 363, 360, 360, 360
                .byte 0, 3, 3, 0, 3, 3, 0, 0, 0, 0, 3, 3, 0, 0, 0, 0, 0, 3
TileSpriteH05:  .byte 0, 300, 300, 0, 300, 300, 0, 0, 0, 0, 300, 300, 0, 0, 0, 0, 0, 300
                .byte 377, 377, 377, 363, 377, 377, 377, 377, 374, 77, 363, 374, 374, 377, 317, 17, 17, 17
                .byte 0, 3, 3, 3, 3, 3, 0, 0, 3, 17, 14, 0, 0, 17, 17, 14, 0, 0
TileSpriteH06:  .byte 360, 374, 374, 374, 374, 374, 360, 360, 374, 377, 317, 363, 360, 374, 77, 17, 3, 3
                .byte 17, 77, 77, 14, 77, 0, 77, 17, 77, 77, 363, 317, 317, 17, 74, 74, 360, 360
TileSpriteH07:  .byte 360, 374, 374, 60, 374, 0, 374, 360, 374, 374, 317, 363, 363, 360, 74, 74, 17, 17
                .byte 17, 77, 77, 77, 77, 77, 17, 17, 77, 377, 363, 317, 17, 77, 374, 360, 300, 300
TileSpriteH08:  .byte 0, 300, 300, 300, 300, 300, 0, 0, 300, 360, 60, 360, 0, 0, 0, 300, 300, 300
                .byte 377, 377, 377, 317, 377, 377, 377, 77, 377, 377, 77, 377, 377, 377, 317, 3, 3, 17
                .byte 0, 3, 3, 0, 3, 3, 0, 0, 0, 17, 17, 0, 0, 3, 17, 77, 0, 0
TileSpriteH09:  .byte 0, 300, 300, 0, 300, 300, 0, 0, 0, 360, 360, 0, 0, 300, 360, 374, 0, 0
                .byte 377, 377, 377, 363, 377, 377, 377, 374, 377, 377, 374, 377, 377, 377, 363, 300, 300, 360
                .byte 0, 3, 3, 3, 3, 3, 0, 0, 3, 17, 14, 17, 0, 0, 0, 3, 0, 0
; таблица адресов масок цвета для спрайтов
SpriteColorMaskTbl:.word 0              ; ColorMask0 - т.е. маски нет
                .word ColMask1
                .word ColMask2
                .word ColMask3
                .word ColMask4
                .word ColMask5
                .word ColMask6
                .word ColMask7
ColMask1:       .word 125252,125252,125252,125252,125252,125252,125252,125252,125252,125252
ColMask2:       .word 022222,044444,111111,022222,044444,111111,022222,044444,111111,022222
ColMask3:       .word 012121,042424,050505,012121,042424,050505,012121,042424,050505,012121
ColMask4:       .word 000000,125252,000000,125252,000000,125252,000000,125252,000000,125252
ColMask5:       .word 052525,052525,052525,052525,052525,052525,052525,052525,052525,052525
ColMask6:       .word 146314,031463,146314,031463,146314,031463,146314,031463,146314,031463
ColMask7:       .word 000000,000000,000000,000000,000000,000000,000000,000000,000000,000000
; массив объектов длиной 24 (20.) байта, шириной слово.
; спрайты элементов лабиринта
SpriteArray:    .word ^B1100111111111111    ; 1 - стена сплошная
                .word ^B1100111111111111
                .word ^B1100111111111111
                .word ^B1100111111111111
                .word ^B0000000000000000
                .word ^B1111111111001111
                .word ^B1111111111001111
                .word ^B1111111111001111
                .word ^B1111111111001111
                .word ^B0000000000000000

                .word ^B0000000000000000    ; 2 - сокровище
                .word ^B0000111111110000
                .word ^B0011111111111100
                .word ^B1111111111111111
                .word ^B1111111111110011
                .word ^B1111111111000011
                .word ^B1111111111001111
                .word ^B0011111111111100
                .word ^B0000111111110000
                .word ^B0000000000000000

                .word ^B0000000000000000    ; 3 - нож
                .word ^B0000000000000000
                .word ^B0010000000000000
                .word ^B0000100000000000
                .word ^B0000001000000000
                .word ^B0000000010000000
                .word ^B0000000000100000
                .word ^B0000101010101000
                .word ^B0000001010100000
                .word ^B0000000010100000

                .word ^B0000000000001100    ; 4 - кирка
                .word ^B0000000000110000
                .word ^B0000000011000000
                .word ^B0000001111000000
                .word ^B0000111100000000
                .word ^B0000111100000000
                .word ^B0011001111000000
                .word ^B0011000011110000
                .word ^B1100000000111100
                .word ^B1100000000001111

                .word ^B0000000000000000    ; 5 - мигание сокровища сверху
                .word ^B0000000000000000
                .word ^B0000000000000000
                .word ^B0000000000000000
                .word ^B0000000000000000
                .word ^B0000000011000000
                .word ^B0011000001000011
                .word ^B0001000010000010
                .word ^B0000100011000100
                .word ^B0000110001001100

                .word ^B0000000000000000    ; 6 - мигание сокровища слева
                .word ^B0000001011000000
                .word ^B0011010000000000
                .word ^B0000000000000000
                .word ^B0010110110110000
                .word ^B0000000000000000
                .word ^B0011010000000000
                .word ^B0000001011000000
                .word ^B0000000000000000
                .word ^B0000000000000000

                .word ^B0000000000000000    ; 7 - мигание сокровища справа
                .word ^B0000001101000000
                .word ^B0000000000101100
                .word ^B0000000000000000
                .word ^B0000110110110100
                .word ^B0000000000000000
                .word ^B0000000000101100
                .word ^B0000001101000000
                .word ^B0000000000000000
                .word ^B0000000000000000

                .word ^B0000000011111111    ; 8 - лестница левая верх
                .word ^B0000000000000000
                .word ^B0000000000111111
                .word ^B0000000000111111
                .word ^B0000000000111111
                .word ^B1111111100111111
                .word ^B0000000000000000
                .word ^B0011111100111111
                .word ^B0011111100111100
                .word ^B0011111100110000

                .word ^B0011111100000000    ; 9 - лестница левая низ
                .word ^B0000000000000000
                .word ^B0011111100000000
                .word ^B0011110000000000
                .word ^B0011000000000000
                .word ^B0000000000000000
                .word ^B0000000000000000
                .word ^B0000000000000000
                .word ^B0000000000000000
                .word ^B0000000000000000

                .word ^B1111111100000000    ; 10 - лестница правая верх
                .word ^B0000000000000000
                .word ^B1111110000000000
                .word ^B1111110000000000
                .word ^B1111110000000000
                .word ^B1111110011111111
                .word ^B0000000000000000
                .word ^B1111110011111100
                .word ^B0011110011111100
                .word ^B0000110011111100

                .word ^B0000000011111100    ; 11 - лестница правая низ
                .word ^B0000000000000000
                .word ^B0000000011111100
                .word ^B0000000000111100
                .word ^B0000000000001100
                .word ^B0000000000000000
                .word ^B0000000000000000
                .word ^B0000000000000000
                .word ^B0000000000000000
                .word ^B0000000000000000

                .word ^B0000000000000010    ; 12 - летящий нож 135 град.
                .word ^B0000000000001000
                .word ^B0000000000100000
                .word ^B0000000010000000
                .word ^B0000001000000000
                .word ^B0000101010101000
                .word ^B0000001010100000
                .word ^B0000001010000000
                .word ^B0000001000000000
                .word ^B0000000000000000

                .word ^B1000000000000000    ; 13 - летящий нож 225 град.
                .word ^B0010000000000000
                .word ^B0000100000000000
                .word ^B0000001000000000
                .word ^B0000000010000000
                .word ^B0010101010100000
                .word ^B0000101010000000
                .word ^B0000001010000000
                .word ^B0000000010000000
                .word ^B0000000000000000

                .word ^B0000000000000000    ; 14 - летящий нож 315 град.
                .word ^B0000000000000000
                .word ^B0000000000100000
                .word ^B0000000010000000
                .word ^B0000001010101010
                .word ^B0000100010101000
                .word ^B0010000010100000
                .word ^B1000000010000000
                .word ^B0000000000000000
                .word ^B0000000000000000

                .word ^B0000000000000000    ; 15 - летящий нож 45 град.
                .word ^B0000000000000000
                .word ^B0000100000000000
                .word ^B0000001000000000
                .word ^B1010101010000000
                .word ^B0010101000100000
                .word ^B0000101000001000
                .word ^B0000001000000010
                .word ^B0000000000000000
                .word ^B0000000000000000

GreenWallCheck: .word ^B0010101000101010    ; 16 - стена зелёная, в которой открывается проход на вход и выход из пирамиды
                .word ^B0010101000101010
                .word ^B0010101000101010
                .word ^B0010101000101010
                .word ^B0000000000000000
                .word ^B1010001010100010
                .word ^B1010001010100010
                .word ^B1010001010100010
                .word ^B1010001010100010
                .word ^B0000000000000000

                .word ^B0000111111110000    ; 17 - ключ
                .word ^B0011110000111100
                .word ^B0011110000111100
                .word ^B0000111111110000
                .word ^B0000001111000000
                .word ^B0000001111000000
                .word ^B0011111111000000
                .word ^B0000001111000000
                .word ^B0011111111000000
                .word ^B0000000000000000

                .word ^B1011011011000000    ; 18 - что-то справа
                .word ^B0110110111000000
                .word ^B1101101111000000
                .word ^B1011011011000000
                .word ^B0110110111000000
                .word ^B1101101111000000
                .word ^B1011011011000000
                .word ^B0110110111000000
                .word ^B1101101111000000
                .word ^B1011011011000000

                .word ^B0000001101101101    ; 19 - что-то слева
                .word ^B0000001111011011
                .word ^B0000001110110110
                .word ^B0000001101101101
                .word ^B0000001111011011
                .word ^B0000001110110110
                .word ^B0000001101101101
                .word ^B0000001111011011
                .word ^B0000001110110110
                .word ^B0000001101101101

                .word ^B0110110000000000    ; 20 - 0 справа
                .word ^B1101100000000000
                .word ^B1000010000000000
                .word ^B0100110000000000
                .word ^B1100100000000000
                .word ^B1000010000000000
                .word ^B0100110000000000
                .word ^B1100100000000000
                .word ^B1011010000000000
                .word ^B0110110000000000

                .word ^B0000000000010001    ; 21 - Н слева
                .word ^B0000000000010001
                .word ^B0000000000010001
                .word ^B0000000000010101
                .word ^B0000000000010101
                .word ^B0000000000010101
                .word ^B0000000000010101
                .word ^B0000000000010001
                .word ^B0000000000010001
                .word ^B0000000000010001

                .word ^B0100010000000000    ; 22 - Н справа
                .word ^B0100010000000000
                .word ^B0100010000000000
                .word ^B0101010000000000
                .word ^B0101010000000000
                .word ^B0101010000000000
                .word ^B0101010000000000
                .word ^B0100010000000000
                .word ^B0100010000000000
                .word ^B0100010000000000

                .word ^B0000000000011011    ; 23 - 0 слева
                .word ^B0000000000110110
                .word ^B0000000000100001
                .word ^B0000000000010011
                .word ^B0000000000110010
                .word ^B0000000000100001
                .word ^B0000000000010011
                .word ^B0000000000110010
                .word ^B0000000000101101
                .word ^B0000000000011011

                .word ^B1101101100000000    ; 24 - полкирпича справа
                .word ^B1111011100000000
                .word ^B1110111100000000
                .word ^B1101101100000000
                .word ^B1111011100000000
                .word ^B1110111100000000
                .word ^B1101101100000000
                .word ^B1111011100000000
                .word ^B1110111100000000
                .word ^B1101101100000000

                .word ^B0000000001000110    ; 25 - 0Н слева
                .word ^B0000000001001101
                .word ^B0000000001001000
                .word ^B0000000001010100
                .word ^B0000000001011100
                .word ^B0000000001011000
                .word ^B0000000001010100
                .word ^B0000000001001100
                .word ^B0000000001001011
                .word ^B0000000001000110

                .word ^B0110000100000000    ; 26 - Н0 справа
                .word ^B1101000100000000
                .word ^B0011000100000000
                .word ^B0010010100000000
                .word ^B0001010100000000
                .word ^B0011010100000000
                .word ^B0010010100000000
                .word ^B0001000100000000
                .word ^B1011000100000000
                .word ^B0110000100000000

                .word ^B0000000011011011    ; 27 - полкирпича слева
                .word ^B0000000011110111
                .word ^B0000000011101111
                .word ^B0000000011011011
                .word ^B0000000011110111
                .word ^B0000000011101111
                .word ^B0000000011011011
                .word ^B0000000011110111
                .word ^B0000000011101111
                .word ^B0000000011011011

; таблица адресов блоков параметров интерьеров пирамид, всего 15 пирамид
PyrIntAddrTbl:  .word PyramidInterrior1
                .word PyramidInterrior2
                .word PyramidInterrior3
                .word PyramidInterrior4
                .word PyramidInterrior5
                .word PyramidInterrior6
                .word PyramidInterrior7
                .word PyramidInterrior8
                .word PyramidInterrior9
                .word PyramidInterrior10
                .word PyramidInterrior11
                .word PyramidInterrior12
                .word PyramidInterrior13
                .word PyramidInterrior14
                .word PyramidInterrior15

; Массив структур внутреннего наполнения комнат для каждой четвертинки - соответствующе
PyramidInterrior1:
                .word 0x00e1            ; (1) каждые 4 бита - номера половинок комнат лабиринта, 0 - нет половинки
                .word Room+1117         ; (2) адрес входа
                .word Room+1117         ; (3) адрес выхода
                .word 2.                ; (4) количество охранников
                                        ; формат параметра:
                                        ; старшие 4 бита - номер
                                        ; младшие 10 битов - смещение в буфере комнат
                .word 1111              ; п1
                .word 21126             ; п2
                .word 4.                ; (5) количество сокровищ, которые надо собрать
                .word Room+0303         ; адр1
                .word Room+0334         ; адр2
                .word Room+2402         ; адр3
                .word Room+1732         ; адр4
                .word 1.                ; (6) количество ножей
                .word Room+2017         ; адр1
                .word 0.                ; (7) количество кирок
                .word 0.                ; (8) количество стен с односторонней проницаемостью
                .word 8.                ; (9) количество лестниц
                                        ; бит 15 в адресе - направление, лево/право:
                .word Room+0605+100000  ; адр1
                .word Room+0631         ; адр2
                .word Room+1205+100000  ; адр3
                .word Room+1231         ; адр4
                .word Room+1710         ; адр5
                .word Room+1726+100000  ; адр6
                .word Room+2412+100000  ; адр7
                .word Room+2424         ; адр8
                .word 0.                ; (10) количество зарастающих стен
PyramidInterrior2:
                .word 0xb961            ; (1) каждые 4 бита - номера половинок комнат лабиринта, 0 - нет половинки
                .word Room+1606         ; (2) адрес входа
                .word Room+1772         ; (3) адрес выхода
                .word 3.                ; (4) количество охранников
                                        ; формат параметра:
                                        ; старшие 4 бита - номер
                                        ; младшие 10 битов - смещение в буфере комнат
                .word 332               ; п1
                .word 40621             ; п2
                .word 11454             ; п3
                .word 5.                ; (5) количество сокровищ, которые надо собрать
                .word Room+1222         ; адр1
                .word Room+1427         ; адр2
                .word Room+0351         ; адр3
                .word Room+0654         ; адр4
                .word Room+1552         ; адр5
                .word 3.                ; (6) количество ножей
                .word Room+0207         ; адр1
                .word Room+2430         ; адр2
                .word Room+0372         ; адр3
                .word 7.                ; (7) количество кирок
                .word Room+0227         ; адр1
                .word Room+1003         ; адр2
                .word Room+1031         ; адр3
                .word Room+2016         ; адр4
                .word Room+2201         ; адр5
                .word Room+1155         ; адр6
                .word Room+2273         ; адр7
                .word 2.                ; (8) количество стен с односторонней проницаемостью
                .word Room+0456         ; адр1
                .word Room+0550         ; адр2
                .word 13.               ; (9) количество лестниц
                                        ; бит 15 в адресе - направление, лево/право:
                .word Room+0610         ; адр1
                .word Room+1207+100000  ; адр2
                .word Room+1433         ; адр3
                .word Room+1712         ; адр4
                .word Room+2034+100000  ; адр5
                .word Room+2412+100000  ; адр6
                .word Room+2522         ; адр7
                .word Room+1042         ; адр8
                .word Room+1073+100000  ; адр9
                .word Room+2062         ; адр10
                .word Room+2444+100000  ; адр11
                .word Room+2452+100000  ; адр12
                .word Room+2463         ; адр13
                .word 2.                ; (10) количество зарастающих стен
                .word Room+1717         ; адр1
                .word Room+2022         ; адр2
PyramidInterrior3:
                .word 0x00b3            ; (1) каждые 4 бита - номера половинок комнат лабиринта, 0 - нет половинки
                .word Room+2415         ; (2) адрес входа
                .word Room+1734         ; (3) адрес выхода
                .word 2.                ; (4) количество охранников
                                        ; формат параметра:
                                        ; старшие 4 бита - номер
                                        ; младшие 10 битов - смещение в буфере комнат
                .word 30227             ; п1
                .word 2007              ; п2
                .word 4.                ; (5) количество сокровищ, которые надо собрать
                .word Room+0333         ; адр1
                .word Room+1211         ; адр2
                .word Room+1217         ; адр3
                .word Room+1516         ; адр4
                .word 1.                ; (6) количество ножей
                .word Room+2420         ; адр1
                .word 5.                ; (7) количество кирок
                .word Room+0336         ; адр1
                .word Room+0701         ; адр2
                .word Room+1701         ; адр3
                .word Room+2235         ; адр4
                .word Room+2501         ; адр5
                .word 0.                ; (8) количество стен с односторонней проницаемостью
                .word 10.               ; (9) количество лестниц
                                        ; бит 15 в адресе - направление, лево/право:
                .word Room+0503         ; адр1
                .word Room+1023         ; адр2
                .word Room+1104+100000  ; адр3
                .word Room+1505+100000  ; адр4
                .word Room+2025         ; адр5
                .word Room+2105+100000  ; адр6
                .word Room+2112         ; адр7
                .word Room+2424+100000  ; адр8
                .word Room+2431         ; адр9
                .word Room+2506+100000  ; адр10
                .word 1.                ; (10) количество зарастающих стен
                .word Room+2403         ; адр1
PyramidInterrior4:
                .word 0xb851            ; (1) каждые 4 бита - номера половинок комнат лабиринта, 0 - нет половинки
                .word Room+0752         ; (2) адрес входа
                .word Room+2333         ; (3) адрес выхода
                .word 2.                ; (4) количество охранников
                                        ; формат параметра:
                                        ; старшие 4 бита - номер
                                        ; младшие 10 битов - смещение в буфере комнат
                .word 203               ; п1
                .word 11773             ; п2
                .word 6.                ; (5) количество сокровищ, которые надо собрать
                .word Room+0602         ; адр1
                .word Room+2017         ; адр2
                .word Room+2302         ; адр3
                .word Room+0374         ; адр4
                .word Room+1752         ; адр5
                .word Room+2055         ; адр6
                .word 3.                ; (6) количество ножей
                .word Room+1526         ; адр1
                .word Room+0365         ; адр2
                .word Room+2067         ; адр3
                .word 9.                ; (7) количество кирок
                .word Room+1007         ; адр1
                .word Room+1022         ; адр2
                .word Room+1217         ; адр3
                .word Room+1505         ; адр4
                .word Room+0376         ; адр5
                .word Room+1345         ; адр6
                .word Room+1667         ; адр7
                .word Room+2241         ; адр8
                .word Room+2276         ; адр9
                .word 1.                ; (8) количество стен с односторонней проницаемостью
                .word Room+504+100000   ; адр1
                .word 16.               ; (9) количество лестниц
                                        ; бит 15 в адресе - направление, лево/право:
                .word Room+0523+100000  ; адр1
                .word Room+0610         ; адр2
                .word Room+1032         ; адр3
                .word Room+1213+100000  ; адр4
                .word Room+1521         ; адр5
                .word Room+1710+100000  ; адр6
                .word Room+2032+100000  ; адр7
                .word Room+2411+100000  ; адр8
                .word Room+2521         ; адр9
                .word Room+1043         ; адр10
                .word Room+1065         ; адр11
                .word Room+1343         ; адр12
                .word Room+1354         ; адр13
                .word Room+2063         ; адр14
                .word Room+2445+100000  ; адр15
                .word Room+2471         ; адр16
                .word 0.                ; (10) количество зарастающих стен
PyramidInterrior5:
                .word 0x00e4            ; (1) каждые 4 бита - номера половинок комнат лабиринта, 0 - нет половинки
                .word Room+1405         ; (2) адрес входа
                .word Room+1126         ; (3) адрес выхода
                .word 2.                ; (4) количество охранников
                                        ; формат параметра:
                                        ; старшие 4 бита - номер
                                        ; младшие 10 битов - смещение в буфере комнат
                .word 122               ; п1
                .word 21402             ; п2
                .word 5.                ; (5) количество сокровищ, которые надо собрать
                .word Room+0333         ; адр1
                .word Room+1234         ; адр2
                .word Room+1102         ; адр3
                .word Room+2113         ; адр4
                .word Room+2503         ; адр5
                .word 2.                ; (6) количество ножей
                .word Room+0626         ; адр1
                .word Room+1724         ; адр2
                .word 3.                ; (7) количество кирок
                .word Room+0201         ; адр1
                .word Room+0402         ; адр2
                .word Room+1301         ; адр3
                .word 0.                ; (8) количество стен с односторонней проницаемостью
                .word 7.                ; (9) количество лестниц
                                        ; бит 15 в адресе - направление, лево/право:
                .word Room+0604         ; адр1
                .word Room+0631         ; адр2
                .word Room+1222+100000  ; адр3
                .word Room+1231         ; адр4
                .word Room+1512+100000  ; адр5
                .word Room+1731+100000  ; адр6
                .word Room+2422         ; адр7
                .word 1.                ; (10) количество зарастающих стен
                .word Room+1720         ; адр1
PyramidInterrior6:
                .word 0xda63            ; (1) каждые 4 бита - номера половинок комнат лабиринта, 0 - нет половинки
                .word Room+2013         ; (2) адрес входа
                .word Room+2064         ; (3) адрес выхода
                .word 3.                ; (4) количество охранников
                                        ; формат параметра:
                                        ; старшие 4 бита - номер
                                        ; младшие 10 битов - смещение в буфере комнат
                .word 20230             ; п1
                .word 11734             ; п2
                .word 1047              ; п3
                .word 6.                ; (5) количество сокровищ, которые надо собрать
                .word Room+0433         ; адр1
                .word Room+1033         ; адр2
                .word Room+1313         ; адр3
                .word Room+1515         ; адр4
                .word Room+0574         ; адр5
                .word Room+1162         ; адр6
                .word 2.                ; (6) количество ножей
                .word Room+2501         ; адр1
                .word Room+1545         ; адр2
                .word 10.               ; (7) количество кирок
                .word Room+0201         ; адр1
                .word Room+0701         ; адр2
                .word Room+1301         ; адр3
                .word Room+1417         ; адр4
                .word Room+1706         ; адр5
                .word Room+2307         ; адр6
                .word Room+1347         ; адр7
                .word Room+1571         ; адр8
                .word Room+2274         ; адр9
                .word Room+2574         ; адр10
                .word 1.                ; (8) количество стен с односторонней проницаемостью
                .word Room+1357         ; адр1
                .word 16.               ; (9) количество лестниц
                                        ; бит 15 в адресе - направление, лево/право:
                .word Room+0502         ; адр1
                .word Room+0714+100000  ; адр2
                .word Room+0717         ; адр3
                .word Room+1105+100000  ; адр4
                .word Room+1430         ; адр5
                .word Room+1502         ; адр6
                .word Room+2102         ; адр7
                .word Room+2432         ; адр8
                .word Room+2513+100000  ; адр9
                .word Room+0555+100000  ; адр10
                .word Room+1165         ; адр11
                .word Room+1553+100000  ; адр12
                .word Room+1566         ; адр13
                .word Room+2153+100000  ; адр14
                .word Room+2447         ; адр15
                .word Room+2561+100000  ; адр16
                .word 2.                ; (10) количество зарастающих стен
                .word Room+2403         ; адр1
                .word Room+2024         ; адр2
PyramidInterrior7:
                .word 0xca71            ; (1) каждые 4 бита - номера половинок комнат лабиринта, 0 - нет половинки
                .word Room+2423         ; (2) адрес входа
                .word Room+2372         ; (3) адрес выхода
                .word 3.                ; (4) количество охранников
                                        ; формат параметра:
                                        ; старшие 4 бита - номер
                                        ; младшие 10 битов - смещение в буфере комнат
                .word 40326             ; п1
                .word 21534             ; п2
                .word 1456              ; п3
                .word 5.                ; (5) количество сокровищ, которые надо собрать
                .word Room+1324         ; адр1
                .word Room+2016         ; адр2
                .word Room+0303         ; адр3
                .word Room+1042         ; адр4
                .word Room+1553         ; адр5
                .word 4.                ; (6) количество ножей
                .word Room+0216         ; адр1
                .word Room+1713         ; адр2
                .word Room+1166         ; адр3
                .word Room+2150         ; адр4
                .word 7.                ; (7) количество кирок
                .word Room+1004         ; адр1
                .word Room+1034         ; адр2
                .word Room+1505         ; адр3
                .word Room+0446         ; адр4
                .word Room+0755         ; адр5
                .word Room+0766         ; адр6
                .word Room+2266         ; адр7
                .word 1.                ; (8) количество стен с односторонней проницаемостью
                .word Room+1346         ; адр1
                .word 12.               ; (9) количество лестниц
                                        ; бит 15 в адресе - направление, лево/право:
                .word Room+0602         ; адр1
                .word Room+1210+100000  ; адр2
                .word Room+1710         ; адр3
                .word Room+2411+100000  ; адр4
                .word Room+2531         ; адр5
                .word Room+0571+100000  ; адр6
                .word Room+1151         ; адр7
                .word Room+1162         ; адр8
                .word Room+1774+100000  ; адр9
                .word Room+2445+100000  ; адр10
                .word Room+2462         ; адр11
                .word Room+2556+100000  ; адр12
                .word 3.                ; (10) количество зарастающих стен
                .word Room+1112         ; адр1
                .word Room+1664         ; адр2
                .word Room+1744         ; адр3
PyramidInterrior8:
                .word 0x00d4            ; (1) каждые 4 бита - номера половинок комнат лабиринта, 0 - нет половинки
                .word Room+2407         ; (2) адрес входа
                .word Room+2423         ; (3) адрес выхода
                .word 2.                ; (4) количество охранников
                                        ; формат параметра:
                                        ; старшие 4 бита - номер
                                        ; младшие 10 битов - смещение в буфере комнат
                .word 20424             ; п1
                .word 31417             ; п2
                .word 5.                ; (5) количество сокровищ, которые надо собрать
                .word Room+0534         ; адр1
                .word Room+0613         ; адр2
                .word Room+1513         ; адр3
                .word Room+2235         ; адр4
                .word Room+2402         ; адр5
                .word 1.                ; (6) количество ножей
                .word Room+1507         ; адр1
                .word 4.                ; (7) количество кирок
                .word Room+0727         ; адр1
                .word Room+1301         ; адр2
                .word Room+1323         ; адр3
                .word Room+2534         ; адр4
                .word 2.                ; (8) количество стен с односторонней проницаемостью
                .word Room+1714+100000  ; адр1
                .word Room+1723+100000  ; адр2
                .word 10.               ; (9) количество лестниц
                                        ; бит 15 в адресе - направление, лево/право:
                .word Room+0521+100000  ; адр1
                .word Room+0610         ; адр2
                .word Room+1102         ; адр3
                .word Room+1123         ; адр4
                .word Room+1505+100000  ; адр5
                .word Room+1517         ; адр6
                .word Room+1530+100000  ; адр7
                .word Room+2117         ; адр8
                .word Room+2514+100000  ; адр9
                .word Room+2530+100000  ; адр10
                .word 0.                ; (10) количество зарастающих стен
PyramidInterrior9:
                .word 0x00b4            ; (1) каждые 4 бита - номера половинок комнат лабиринта, 0 - нет половинки
                .word Room+1411         ; (2) адрес входа
                .word Room+1732         ; (3) адрес выхода
                .word 2.                ; (4) количество охранников
                                        ; формат параметра:
                                        ; старшие 4 бита - номер
                                        ; младшие 10 битов - смещение в буфере комнат
                .word 20225             ; п1
                .word 503               ; п2
                .word 5.                ; (5) количество сокровищ, которые надо собрать
                .word Room+0333         ; адр1
                .word Room+0611         ; адр2
                .word Room+1102         ; адр3
                .word Room+2104         ; адр4
                .word Room+2113         ; адр5
                .word 2.                ; (6) количество ножей
                .word Room+0216         ; адр1
                .word Room+2035         ; адр2
                .word 3.                ; (7) количество кирок
                .word Room+0201         ; адр1
                .word Room+0336         ; адр2
                .word Room+1306         ; адр3
                .word 0.                ; (8) количество стен с односторонней проницаемостью
                .word 8.                ; (9) количество лестниц
                                        ; бит 15 в адресе - направление, лево/право:
                .word Room+0606         ; адр1
                .word Room+1034+100000  ; адр2
                .word Room+1502         ; адр3
                .word Room+1515         ; адр4
                .word Room+2022         ; адр5
                .word Room+2115+100000  ; адр6
                .word Room+2433+100000  ; адр7
                .word Room+2506         ; адр8
                .word 0.                ; (10) количество зарастающих стен
PyramidInterrior10:
                .word 0x00d2            ; (1) каждые 4 бита - номера половинок комнат лабиринта, 0 - нет половинки
                .word Room+1027         ; (2) адрес входа
                .word Room+2404         ; (3) адрес выхода
                .word 1.                ; (4) количество охранников
                                        ; формат параметра:
                                        ; старшие 4 бита - номер
                                        ; младшие 10 битов - смещение в буфере комнат
                .word 20422             ; п1
                .word 4.                ; (5) количество сокровищ, которые надо собрать
                .word Room+1112         ; адр1
                .word Room+1523         ; адр2
                .word Room+2003         ; адр3
                .word Room+2112         ; адр4
                .word 2.                ; (6) количество ножей
                .word Room+0603         ; адр1
                .word Room+2121         ; адр2
                .word 6.                ; (7) количество кирок
                .word Room+0233         ; адр1
                .word Room+1132         ; адр2
                .word Room+1315         ; адр3
                .word Room+1316         ; адр4
                .word Room+1324         ; адр5
                .word Room+2317         ; адр6
                .word 0.                ; (8) количество стен с односторонней проницаемостью
                .word 7.                ; (9) количество лестниц
                                        ; бит 15 в адресе - направление, лево/право:
                .word Room+0513+100000  ; адр1
                .word Room+0527+100000  ; адр2
                .word Room+1121         ; адр3
                .word Room+1530+100000  ; адр4
                .word Room+2124+100000  ; адр5
                .word Room+2513         ; адр6
                .word Room+2530+100000  ; адр7
                .word 0.                ; (10) количество зарастающих стен
PyramidInterrior11:
                .word 0xc873            ; (1) каждые 4 бита - номера половинок комнат лабиринта, 0 - нет половинки
                .word Room+2416         ; (2) адрес входа
                .word Room+2366         ; (3) адрес выхода
                .word 3.                ; (4) количество охранников
                                        ; формат параметра:
                                        ; старшие 4 бита - номер
                                        ; младшие 10 битов - смещение в буфере комнат
                .word 31722             ; п1
                .word 30351             ; п2
                .word 41562             ; п3
                .word 6.                ; (5) количество сокровищ, которые надо собрать
                .word Room+1021         ; адр1
                .word Room+1503         ; адр2
                .word Room+1515         ; адр3
                .word Room+0274         ; адр4
                .word Room+1042         ; адр5
                .word Room+1356         ; адр6
                .word 3.                ; (6) количество ножей
                .word Room+2501         ; адр1
                .word Room+1175         ; адр2
                .word Room+2055         ; адр3
                .word 6.                ; (7) количество кирок
                .word Room+0202         ; адр1
                .word Room+0635         ; адр2
                .word Room+1301         ; адр3
                .word Room+1704         ; адр4
                .word Room+0645         ; адр5
                .word Room+0766         ; адр6
                .word 0.                ; (8) количество стен с односторонней проницаемостью
                .word 13.               ; (9) количество лестниц
                                        ; бит 15 в адресе - направление, лево/право:
                .word Room+0710+100000  ; адр1
                .word Room+1031         ; адр2
                .word Room+1104+100000  ; адр3
                .word Room+2110+100000  ; адр4
                .word Room+2507+100000  ; адр5
                .word Room+2531         ; адр6
                .word Room+0571+100000  ; адр7
                .word Room+1051+100000  ; адр8
                .word Room+1162         ; адр9
                .word Room+1343         ; адр10
                .word Room+1763         ; адр11
                .word Room+2445+100000  ; адр12
                .word Room+2474+100000  ; адр13
                .word 3.                ; (10) количество зарастающих стен
                .word Room+2403         ; адр1
                .word Room+0744         ; адр2
                .word Room+1074         ; адр3
PyramidInterrior12:
                .word 0x00c2            ; (1) каждые 4 бита - номера половинок комнат лабиринта, 0 - нет половинки
                .word Room+1027         ; (2) адрес входа
                .word Room+1703         ; (3) адрес выхода
                .word 2.                ; (4) количество охранников
                                        ; формат параметра:
                                        ; старшие 4 бита - номер
                                        ; младшие 10 битов - смещение в буфере комнат
                .word 422               ; п1
                .word 31702             ; п2
                .word 6.                ; (5) количество сокровищ, которые надо собрать
                .word Room+0603         ; адр1
                .word Room+1014         ; адр2
                .word Room+1315         ; адр3
                .word Room+1714         ; адр4
                .word Room+2011         ; адр5
                .word Room+2116         ; адр6
                .word 2.                ; (6) количество ножей
                .word Room+0530         ; адр1
                .word Room+2502         ; адр2
                .word 6.                ; (7) количество кирок
                .word Room+0201         ; адр1
                .word Room+0236         ; адр2
                .word Room+0510         ; адр3
                .word Room+1110         ; адр4
                .word Room+1216         ; адр5
                .word Room+1533         ; адр6
                .word 0.                ; (8) количество стен с односторонней проницаемостью
                .word 8.                ; (9) количество лестниц
                                        ; бит 15 в адресе - направление, лево/право:
                .word Room+0515+100000  ; адр1
                .word Room+0525         ; адр2
                .word Room+1123+100000  ; адр3
                .word Room+1134+100000  ; адр4
                .word Room+1727         ; адр5
                .word Room+2427+100000  ; адр6
                .word Room+2506+100000  ; адр7
                .word Room+2512         ; адр8
                .word 0.                ; (10) количество зарастающих стен
PyramidInterrior13:
                .word 0xc954            ; (1) каждые 4 бита - номера половинок комнат лабиринта, 0 - нет половинки
                .word Room+1424         ; (2) адрес входа
                .word Room+1674         ; (3) адрес выхода
                .word 3.                ; (4) количество охранников
                                        ; формат параметра:
                                        ; старшие 4 бита - номер
                                        ; младшие 10 битов - смещение в буфере комнат
                .word 20334             ; п1
                .word 40512             ; п2
                .word 1561              ; п3
                .word 6.                ; (5) количество сокровищ, которые надо собрать
                .word Room+1023         ; адр1
                .word Room+1102         ; адр2
                .word Room+2104         ; адр3
                .word Room+0351         ; адр4
                .word Room+1547         ; адр5
                .word Room+2056         ; адр6
                .word 3.                ; (6) количество ножей
                .word Room+1532         ; адр1
                .word Room+2146         ; адр2
                .word Room+0264         ; адр3
                .word 8.                ; (7) количество кирок
                .word Room+0236         ; адр1
                .word Room+0402         ; адр2
                .word Room+0411         ; адр3
                .word Room+1510         ; адр4
                .word Room+2403         ; адр5
                .word Room+0761         ; адр6
                .word Room+2153         ; адр7
                .word Room+2476         ; адр8
                .word 2.                ; (8) количество стен с односторонней проницаемостью
                .word Room+725+100000   ; адр1
                .word Room+1353         ; адр2
                .word 12.               ; (9) количество лестниц
                                        ; бит 15 в адресе - направление, лево/право:
                .word Room+0605         ; адр1
                .word Room+1032+100000  ; адр2
                .word Room+1503         ; адр3
                .word Room+2030+100000  ; адр4
                .word Room+2116         ; адр5
                .word Room+2430         ; адр6
                .word Room+2516+100000  ; адр7
                .word Room+0567         ; адр8
                .word Room+1165+100000  ; адр9
                .word Room+1766         ; адр10
                .word Room+2452+100000  ; адр11
                .word Room+2467         ; адр12
                .word 1.                ; (10) количество зарастающих стен
                .word Room+2375         ; адр1
PyramidInterrior14:
                .word 0x00e3            ; (1) каждые 4 бита - номера половинок комнат лабиринта, 0 - нет половинки
                .word Room+2003         ; (2) адрес входа
                .word Room+1631         ; (3) адрес выхода
                .word 2.                ; (4) количество охранников
                                        ; формат параметра:
                                        ; старшие 4 бита - номер
                                        ; младшие 10 битов - смещение в буфере комнат
                .word 30532             ; п1
                .word 12014             ; п2
                .word 5.                ; (5) количество сокровищ, которые надо собрать
                .word Room+0333         ; адр1
                .word Room+0505         ; адр2
                .word Room+1215         ; адр3
                .word Room+1312         ; адр4
                .word Room+1515         ; адр5
                .word 1.                ; (6) количество ножей
                .word Room+2510         ; адр1
                .word 8.                ; (7) количество кирок
                .word Room+0201         ; адр1
                .word Room+0401         ; адр2
                .word Room+0701         ; адр3
                .word Room+1301         ; адр4
                .word Room+1705         ; адр5
                .word Room+2132         ; адр6
                .word Room+2301         ; адр7
                .word Room+2311         ; адр8
                .word 0.                ; (8) количество стен с односторонней проницаемостью
                .word 10.               ; (9) количество лестниц
                                        ; бит 15 в адресе - направление, лево/право:
                .word Room+0502         ; адр1
                .word Room+0626+100000  ; адр2
                .word Room+1105+100000  ; адр3
                .word Room+1232         ; адр4
                .word Room+1502         ; адр5
                .word Room+1724+100000  ; адр6
                .word Room+2111+100000  ; адр7
                .word Room+2505+100000  ; адр8
                .word Room+2515+100000  ; адр9
                .word Room+2425         ; адр10
                .word 0.                ; (10) количество зарастающих стен
PyramidInterrior15:
                .word 0xe972            ; (1) каждые 4 бита - номера половинок комнат лабиринта, 0 - нет половинки
                .word Room+2356         ; (2) адрес входа
                .word Room+0733         ; (3) адрес выхода
                .word 2.                ; (4) количество охранников
                                        ; формат параметра:
                                        ; старшие 4 бита - номер
                                        ; младшие 10 битов - смещение в буфере комнат
                .word 31426             ; п1
                .word 20402             ; п2
                .word 6.                ; (5) количество сокровищ, которые надо собрать
                .word Room+1112         ; адр1
                .word Room+1512         ; адр2
                .word Room+2120         ; адр3
                .word Room+0751         ; адр4
                .word Room+1551         ; адр5
                .word Room+2151         ; адр6
                .word 2.                ; (6) количество ножей
                .word Room+2511         ; адр1
                .word Room+2061         ; адр2
                .word 12.               ; (7) количество кирок
                .word Room+0201         ; адр1
                .word Room+0202         ; адр2
                .word Room+0203         ; адр3
                .word Room+0215         ; адр4
                .word Room+0524         ; адр5
                .word Room+0602         ; адр6
                .word Room+1310         ; адр7
                .word Room+1010         ; адр8
                .word Room+0266         ; адр9
                .word Room+0646         ; адр10
                .word Room+1155         ; адр11
                .word Room+1565         ; адр12
                .word 1.                ; (8) количество стен с односторонней проницаемостью
                .word Room+2024+100000  ; адр1
                .word 11.               ; (9) количество лестниц
                                        ; бит 15 в адресе - направление, лево/право:
                .word Room+0515+100000  ; адр1
                .word Room+0603         ; адр2
                .word Room+2506+100000  ; адр3
                .word Room+2531         ; адр4
                .word Room+0655         ; адр5
                .word Room+0670         ; адр6
                .word Room+1042         ; адр7
                .word Room+1271         ; адр8
                .word Room+1771+100000  ; адр9
                .word Room+2445+100000  ; адр10
                .word Room+2462         ; адр11
                .word 0.                ; (10) количество зарастающих стен

; массив лабиринтов в пирамиде по 054 байта, их 14. штук
; каждый бит - 0 пусто, 1 - стена.
; 22. слова в столбик. - это одна четвертинка экрана.
PyramidConf:
Conf1:          .word ^B1100000000000000    ; 01
                .word ^B1000000000000000    ; 02
                .word ^B1000000000000000    ; 03
                .word ^B1000000111111111    ; 04
                .word ^B1111111100000000    ; 05
                .word ^B1000000000000000    ; 06
                .word ^B1000000000000000    ; 07
                .word ^B1111111111000000    ; 08
                .word ^B1000000000000000    ; 09
                .word ^B1000000000000000    ; 10
                .word ^B1000000000000000    ; 11
                .word ^B1001111111111111    ; 12
                .word ^B1000000000000000    ; 13
                .word ^B1000000000000000    ; 14
                .word ^B1000000000000000    ; 15
                .word ^B1000000000000000    ; 16
                .word ^B1000111111110000    ; 17
                .word ^B1000000000000011    ; 18
                .word ^B1000000000000000    ; 19
                .word ^B1111000000000000    ; 20
                .word ^B1111110000000000    ; 21
                .word ^B1111111111111111    ; 22

Conf2:          .word ^B1100000000000000    ; 01
                .word ^B1000000000000000    ; 02
                .word ^B1000000000000000    ; 03
                .word ^B1111111111111111    ; 04
                .word ^B1100000000000000    ; 05
                .word ^B1100000000000000    ; 06
                .word ^B1100000011111111    ; 07
                .word ^B1111100011111111    ; 08
                .word ^B1000000000001111    ; 09
                .word ^B1000000000001111    ; 10
                .word ^B1000000011110001    ; 11
                .word ^B1000000011110001    ; 12
                .word ^B1000000000001111    ; 13
                .word ^B1000000000001111    ; 14
                .word ^B1000000011111111    ; 15
                .word ^B1000000011111111    ; 16
                .word ^B1000000011111000    ; 17
                .word ^B1111110011111000    ; 18
                .word ^B1000000011111111    ; 19
                .word ^B1000000000000000    ; 20
                .word ^B1000000000000000    ; 21
                .word ^B1000000000000000    ; 22

Conf3:          .word ^B1100000000000000    ; 01
                .word ^B1000000000000000    ; 02
                .word ^B1000000000000000    ; 03
                .word ^B1111111111111000    ; 04
                .word ^B1000000000000000    ; 05
                .word ^B1000000000000000    ; 06
                .word ^B1111110000000000    ; 07
                .word ^B1000000000000000    ; 08
                .word ^B1000000011111111    ; 09
                .word ^B1000000011111111    ; 10
                .word ^B1111111111111111    ; 11
                .word ^B1000000011111111    ; 12
                .word ^B1000000011110000    ; 13
                .word ^B1000000011110000    ; 14
                .word ^B1111111111111111    ; 15
                .word ^B1000000000000000    ; 16
                .word ^B1000000000000000    ; 17
                .word ^B1000000000000000    ; 18
                .word ^B1111111111111111    ; 19
                .word ^B1000000000000000    ; 20
                .word ^B1000000000000000    ; 21
                .word ^B1000000000000000    ; 22

Conf4:          .word ^B1100000000000000    ; 01
                .word ^B1000000000000000    ; 02
                .word ^B1000000000000000    ; 03
                .word ^B1111111111111111    ; 04
                .word ^B1100000000000000    ; 05
                .word ^B1100000000000000    ; 06
                .word ^B1100000000000000    ; 07
                .word ^B1111111111110000    ; 08
                .word ^B1000000000000000    ; 09
                .word ^B1000000000000000    ; 10
                .word ^B1111000000000000    ; 11
                .word ^B1000000000000000    ; 12
                .word ^B1000000000000000    ; 13
                .word ^B1000000000000000    ; 14
                .word ^B1111111111111111    ; 15
                .word ^B1111111110000000    ; 16
                .word ^B1000000010000000    ; 17
                .word ^B1000000010000000    ; 18
                .word ^B1001110011111111    ; 19
                .word ^B1000000000000000    ; 20
                .word ^B1000000000000000    ; 21
                .word ^B1111000000000000    ; 22

Conf5:          .word ^B0000000000000000    ; 01
                .word ^B0000000000000000    ; 02
                .word ^B0000000000000000    ; 03
                .word ^B1111111111000000    ; 04
                .word ^B0000000000000000    ; 05
                .word ^B0000000000001111    ; 06
                .word ^B1111111000000000    ; 07
                .word ^B1100000000000000    ; 08
                .word ^B1100000000000000    ; 09
                .word ^B1111111111111111    ; 10
                .word ^B0000000000000000    ; 11
                .word ^B0000000000000000    ; 12
                .word ^B0000000000000000    ; 13
                .word ^B0000000000000000    ; 14
                .word ^B1111111111110000    ; 15
                .word ^B0000000000000000    ; 16
                .word ^B0000000000000000    ; 17
                .word ^B0000111111111111    ; 18
                .word ^B0000000000000000    ; 19
                .word ^B0000000000000000    ; 20
                .word ^B0000000000000000    ; 21
                .word ^B0000111111111111    ; 22

Conf6:          .word ^B0000000000000000    ; 01
                .word ^B0000000000000000    ; 02
                .word ^B0000000000000000    ; 03
                .word ^B1111111100000000    ; 04
                .word ^B0000001111000000    ; 05
                .word ^B0000001111111111    ; 06
                .word ^B0000000010000000    ; 07
                .word ^B0000000010000000    ; 08
                .word ^B1111000010000000    ; 09
                .word ^B1111000011111111    ; 10
                .word ^B1111000000000000    ; 11
                .word ^B1111000000000000    ; 12
                .word ^B1111000000000000    ; 13
                .word ^B1111001111110000    ; 14
                .word ^B1111000000000000    ; 15
                .word ^B0000000000000000    ; 16
                .word ^B0000000000000000    ; 17
                .word ^B0000000000011111    ; 18
                .word ^B1111111110000000    ; 19
                .word ^B0000000000000000    ; 20
                .word ^B0000000000000000    ; 21
                .word ^B0000000111111111    ; 22

Conf7:          .word ^B0000000000000000    ; 01
                .word ^B0000000000000000    ; 02
                .word ^B0000000000000000    ; 03
                .word ^B0000000000000000    ; 04
                .word ^B0000000000000000    ; 05
                .word ^B0000001111111111    ; 06
                .word ^B1111110000000000    ; 07
                .word ^B1111110000000000    ; 08
                .word ^B1111110000000000    ; 09
                .word ^B1111110011111111    ; 10
                .word ^B0000000011111100    ; 11
                .word ^B0000000011111100    ; 12
                .word ^B1111110011111100    ; 13
                .word ^B1111110011111100    ; 14
                .word ^B1111110000000000    ; 15
                .word ^B1111110000000000    ; 16
                .word ^B0000000000000000    ; 17
                .word ^B0000000001111111    ; 18
                .word ^B1111111111000000    ; 19
                .word ^B0000000000000000    ; 20
                .word ^B0000000000000000    ; 21
                .word ^B0000000000001111    ; 22

Conf8:          .word ^B0000000000000000    ; 01
                .word ^B0000000000000000    ; 02
                .word ^B0000000000000000    ; 03
                .word ^B0000000000000000    ; 04
                .word ^B0000000000000000    ; 05
                .word ^B1111111111111100    ; 06
                .word ^B0000000000000000    ; 07
                .word ^B0000000000000000    ; 08
                .word ^B0000000000000000    ; 09
                .word ^B1111111111111111    ; 10
                .word ^B0000000000000000    ; 11
                .word ^B0000000000000000    ; 12
                .word ^B0011110000001111    ; 13
                .word ^B0000000000111111    ; 14
                .word ^B0000000011111111    ; 15
                .word ^B0000001111110001    ; 16
                .word ^B0000111111110001    ; 17
                .word ^B1111111111111111    ; 18
                .word ^B0000000000000000    ; 19
                .word ^B0000000000000000    ; 20
                .word ^B0000000000000000    ; 21
                .word ^B1111111111111111    ; 22

Conf9:          .word ^B0000000000000000    ; 01
                .word ^B0000000000000000    ; 02
                .word ^B0000000000000000    ; 03
                .word ^B0000000000001111    ; 04
                .word ^B0000000011110000    ; 05
                .word ^B1111111100000000    ; 06
                .word ^B0000000000000000    ; 07
                .word ^B0000000000011111    ; 08
                .word ^B0000000111111000    ; 09
                .word ^B1111111111111000    ; 10
                .word ^B0000111111111111    ; 11
                .word ^B0000110000000000    ; 12
                .word ^B0000110000000000    ; 13
                .word ^B0000110000000000    ; 14
                .word ^B0000111111111111    ; 15
                .word ^B0000001111111111    ; 16
                .word ^B0000000000000011    ; 17
                .word ^B1111000000000011    ; 18
                .word ^B0000001111110000    ; 19
                .word ^B0000000000000000    ; 20
                .word ^B0000000000000000    ; 21
                .word ^B1111111111111111    ; 22

Conf10:         .word ^B0000000000000000    ; 01
                .word ^B0000000000000000    ; 02
                .word ^B0000000000000000    ; 03
                .word ^B0000000111111111    ; 04
                .word ^B0000000100000000    ; 05
                .word ^B1111111100000000    ; 06
                .word ^B0000000000011111    ; 07
                .word ^B0000000000000000    ; 08
                .word ^B0000000000000000    ; 09
                .word ^B1111000000000000    ; 10
                .word ^B0000001111111111    ; 11
                .word ^B0000000000000000    ; 12
                .word ^B0000000000000000    ; 13
                .word ^B0000000000000000    ; 14
                .word ^B0000011111111111    ; 15
                .word ^B0000000000000000    ; 16
                .word ^B0000000000000000    ; 17
                .word ^B1111110000000000    ; 18
                .word ^B0000000011111111    ; 19
                .word ^B0000000000000000    ; 20
                .word ^B0000000000000000    ; 21
                .word ^B1111111111111000    ; 22

Conf11:         .word ^B0000000000000011    ; 01
                .word ^B0000000000000001    ; 02
                .word ^B0000000000000001    ; 03
                .word ^B0000000000000001    ; 04
                .word ^B0000011111111111    ; 05
                .word ^B0000000000000001    ; 06
                .word ^B0000000000000001    ; 07
                .word ^B0000000000000001    ; 08
                .word ^B0000000000000001    ; 09
                .word ^B1111111111111111    ; 10
                .word ^B0000000000000001    ; 11
                .word ^B0000000000000001    ; 12
                .word ^B0000000000000001    ; 13
                .word ^B0000000000000001    ; 14
                .word ^B0000000000000001    ; 15
                .word ^B0000000000000001    ; 16
                .word ^B0000000000000001    ; 17
                .word ^B1111111111111111    ; 18
                .word ^B0000000000000001    ; 19
                .word ^B0000000000000001    ; 20
                .word ^B0000000000000001    ; 21
                .word ^B1111111111111111    ; 22

Conf12:         .word ^B0000000000000011    ; 01
                .word ^B0000000000000001    ; 02
                .word ^B0000000000000001    ; 03
                .word ^B1111111111111111    ; 04
                .word ^B0000000000000001    ; 05
                .word ^B0000000000000001    ; 06
                .word ^B1111111111110001    ; 07
                .word ^B0000000000000001    ; 08
                .word ^B0000000000000001    ; 09
                .word ^B0000000000000001    ; 10
                .word ^B1111111111111111    ; 11
                .word ^B0000000000000001    ; 12
                .word ^B0000000000000001    ; 13
                .word ^B0000000000000001    ; 14
                .word ^B0000000000000001    ; 15
                .word ^B0000000000000001    ; 16
                .word ^B0011111111111111    ; 17
                .word ^B0000000000000001    ; 18
                .word ^B0000000000000001    ; 19
                .word ^B0000000000000001    ; 20
                .word ^B0000000000000001    ; 21
                .word ^B1111111111111111    ; 22

Conf13:         .word ^B0000000000000011    ; 01
                .word ^B0000000000000001    ; 02
                .word ^B0000000000000001    ; 03
                .word ^B1111111111110001    ; 04
                .word ^B0000000000100001    ; 05
                .word ^B0000000000100001    ; 06
                .word ^B1111111111111001    ; 07
                .word ^B0000000000010001    ; 08
                .word ^B0000000000010001    ; 09
                .word ^B0000000000010001    ; 10
                .word ^B1111111111110001    ; 11
                .word ^B0000000000010001    ; 12
                .word ^B0000000000010001    ; 13
                .word ^B0000000000010001    ; 14
                .word ^B1111111111110001    ; 15
                .word ^B0000000000010001    ; 16
                .word ^B0000000000010001    ; 17
                .word ^B0000000000010001    ; 18
                .word ^B1111111110010001    ; 19
                .word ^B0000000000011111    ; 20
                .word ^B0000000000011111    ; 21
                .word ^B0000000000011111    ; 22

Conf14:         .word ^B0000000000000011    ; 01
                .word ^B0000000000000001    ; 02
                .word ^B0000000000000001    ; 03
                .word ^B1111111110000001    ; 04
                .word ^B0000000011111111    ; 05
                .word ^B0000000000000001    ; 06
                .word ^B0000000000000001    ; 07
                .word ^B0000001111111111    ; 08
                .word ^B0000000000000001    ; 09
                .word ^B0000000000000001    ; 10
                .word ^B0000000000000001    ; 11
                .word ^B1111111111111001    ; 12
                .word ^B0000000000000001    ; 13
                .word ^B0000000000000001    ; 14
                .word ^B0000000000000001    ; 15
                .word ^B0000000000000001    ; 16
                .word ^B0000111111110001    ; 17
                .word ^B1100000000000001    ; 18
                .word ^B0000000000000001    ; 19
                .word ^B0000000000001111    ; 20
                .word ^B0000000000111111    ; 21
                .word ^B1111111111111111    ; 22
; символы 8х8
; 0123456789ABCDEFGHIJKLMNOPQRSTUVWXY?-'
; пробел и последний символ: (с)
; всего 40.
Font:           .byte ^B00011100    ; 0 - 0
                .byte ^B00100010
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B00100010
                .byte ^B00011100
                .byte 0
                .byte ^B00011000    ; 1 - 1
                .byte ^B00011100
                .byte ^B00011000
                .byte ^B00011000
                .byte ^B00011000
                .byte ^B00011000
                .byte ^B01111110
                .byte 0
                .byte ^B00111110    ; 2 - 2
                .byte ^B01100011
                .byte ^B01100000
                .byte ^B00111000
                .byte ^B00011110
                .byte ^B00000111
                .byte ^B01111111
                .byte 0
                .byte ^B00111110    ; 3 - 3
                .byte ^B01100011
                .byte ^B01100000
                .byte ^B00111000
                .byte ^B01100000
                .byte ^B01100011
                .byte ^B00111110
                .byte 0
                .byte ^B00111000    ; 4 - 4
                .byte ^B00111100
                .byte ^B00110110
                .byte ^B00110011
                .byte ^B00110011
                .byte ^B01111111
                .byte ^B00110000
                .byte 0
                .byte ^B01111111    ; 5 - 5
                .byte ^B00000011
                .byte ^B00111111
                .byte ^B01100011
                .byte ^B01100000
                .byte ^B01100011
                .byte ^B00111110
                .byte 0
                .byte ^B00111110    ; 6 - 6
                .byte ^B01100011
                .byte ^B00000011
                .byte ^B00111111
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B00111110
                .byte 0
                .byte ^B01111111    ; 7 - 7
                .byte ^B01100011
                .byte ^B00110000
                .byte ^B00011000
                .byte ^B00001100
                .byte ^B00001100
                .byte ^B00001100
                .byte 0
                .byte ^B00111110    ; 10 - 8
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B00111110
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B00111110
                .byte 0
                .byte ^B00111110    ; 11 - 9
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B01111110
                .byte ^B01100000
                .byte ^B01100011
                .byte ^B00111110
                .byte 0
                .byte ^B00011100    ; 12 - A
                .byte ^B00110110
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B01111111
                .byte ^B01100011
                .byte ^B01100011
                .byte 0
                .byte ^B00111111    ; 13 - B
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B00111111
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B00111111
                .byte 0
                .byte ^B00111110    ; 14 - C
                .byte ^B01100011
                .byte ^B00000011
                .byte ^B00000011
                .byte ^B00000011
                .byte ^B01100011
                .byte ^B00111110
                .byte 0
                .byte ^B00011111    ; 15 - D
                .byte ^B00110011
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B00110011
                .byte ^B00011111
                .byte 0
                .byte ^B01111111    ; 16 - E
                .byte ^B00000011
                .byte ^B00000011
                .byte ^B00111111
                .byte ^B00000011
                .byte ^B00000011
                .byte ^B01111111
                .byte 0
                .byte ^B01111111    ; 17 - F
                .byte ^B00000011
                .byte ^B00000011
                .byte ^B00111111
                .byte ^B00000011
                .byte ^B00000011
                .byte ^B00000011
                .byte 0
                .byte ^B00111110    ; 20 - G
                .byte ^B01100011
                .byte ^B00000011
                .byte ^B01110011
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B01111110
                .byte 0
                .byte ^B01100011    ; 21 - H
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B01111111
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B01100011
                .byte 0
                .byte ^B00111100    ; 22 - I
                .byte ^B00011000
                .byte ^B00011000
                .byte ^B00011000
                .byte ^B00011000
                .byte ^B00011000
                .byte ^B00111100
                .byte 0
                .byte ^B01111100    ; 23 - J
                .byte ^B00110000
                .byte ^B00110000
                .byte ^B00110000
                .byte ^B00110000
                .byte ^B00110011
                .byte ^B00011110
                .byte 0
                .byte ^B01100011    ; 24 - K
                .byte ^B00110011
                .byte ^B00011011
                .byte ^B00001111
                .byte ^B00011011
                .byte ^B00110011
                .byte ^B01100011
                .byte 0
                .byte ^B00000011    ; 25 - L
                .byte ^B00000011
                .byte ^B00000011
                .byte ^B00000011
                .byte ^B00000011
                .byte ^B00000011
                .byte ^B01111111
                .byte 0
                .byte ^B01100011    ; 26 - M
                .byte ^B01110111
                .byte ^B01111111
                .byte ^B01111111
                .byte ^B01101011
                .byte ^B01100011
                .byte ^B01100011
                .byte 0
                .byte ^B01100011    ; 27 - N
                .byte ^B01100111
                .byte ^B01101111
                .byte ^B01111111
                .byte ^B01111011
                .byte ^B01110011
                .byte ^B01100011
                .byte 0
                .byte ^B00111110    ; 30 - O
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B00111110
                .byte 0
                .byte ^B00111111    ; 31 - P
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B00111111
                .byte ^B00000011
                .byte ^B00000011
                .byte 0
                .byte ^B00111110    ; 32 - Q
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B01111011
                .byte ^B00110011
                .byte ^B01011110
                .byte 0
                .byte ^B00111111    ; 33 - R
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B00100011
                .byte ^B00011111
                .byte ^B00110011
                .byte ^B01100011
                .byte 0
                .byte ^B00111110    ; 34 - S
                .byte ^B01100011
                .byte ^B00000011
                .byte ^B00111110
                .byte ^B01100000
                .byte ^B01100011
                .byte ^B00111110
                .byte 0
                .byte ^B01111110    ; 35 - R
                .byte ^B00011000
                .byte ^B00011000
                .byte ^B00011000
                .byte ^B00011000
                .byte ^B00011000
                .byte ^B00011000
                .byte 0
                .byte ^B01100011    ; 36 - U
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B00111110
                .byte 0
                .byte ^B01100011    ; 37 - V
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B01100011
                .byte ^B00110110
                .byte ^B00011100
                .byte ^B00001000
                .byte 0
                .byte ^B01100011    ; 40 - W
                .byte ^B01100011
                .byte ^B01101011
                .byte ^B01101011
                .byte ^B01111111
                .byte ^B01110111
                .byte ^B00100010
                .byte 0
                .byte ^B01100011    ; 41 - X
                .byte ^B00110111
                .byte ^B00011110
                .byte ^B00011100
                .byte ^B00111100
                .byte ^B01110110
                .byte ^B01100011
                .byte 0
                .byte ^B01100110    ; 42 - Y
                .byte ^B01100110
                .byte ^B01111110
                .byte ^B00111100
                .byte ^B00011000
                .byte ^B00011000
                .byte ^B00011000
                .byte 0
                .byte ^B01111110    ; 43 - ?
                .byte ^B11000011
                .byte ^B11000011
                .byte ^B01100000
                .byte ^B00110000
                .byte ^B00011000
                .byte 0
                .byte ^B00011000
                .byte 0             ; 44 - -
                .byte 0
                .byte 0
                .byte ^B01111111
                .byte 0
                .byte 0
                .byte 0
                .byte 0
                .byte ^B00011000    ; 45 - '
                .byte ^B00111100
                .byte ^B00011000
                .byte ^B00010000
                .byte ^B00001000
                .byte ^B00000100
                .byte 0
                .byte 0
                .byte 0             ; 46 - пробел
                .byte 0
                .byte 0
                .byte 0
                .byte 0
                .byte 0
                .byte 0
                .byte 0
                .byte ^B00111100    ; 47 - (с)
                .byte ^B01000010
                .byte ^B10011001
                .byte ^B10000101
                .byte ^B10000101
                .byte ^B10011001
                .byte ^B01000010
                .byte ^B00111100

                .even

.org 35200  ; !!! вот из-за этой команды приходится делать один файл.

Room:       ; Блок формирования заставки.
            ; потом используется как буфер комнаты лабиринта
RoomFooter = Room + 2400    ; низ

                .end


